@echo off
rem --------------------------------------------------------------------
rem File:        BC.BAT
rem
rem Description: Compile and link a C source file using Borland C++
rem              command-line compiler bcc32 
rem --------------------------------------------------------------------

rem NLIBDIR must be set to NLIB directory

  set NLIBDIR=c:\nlib
  if "%1" == ""  goto usage
  if exist %1.c  goto comp
  goto nofile

:comp
  
  if exist %NLIBDIR%\nlib_bc.lib goto comp1
  if "%2" == "" goto comp3
  bcc32 -A -N -w-par -w-aus -e%2 %1.c > err.log 	
  goto comp2

:comp3

  bcc32 -A -N -w-par -w-aus %1.c > err.log 	
  goto comp2

rem Use library

:comp1

  if "%2" == "" goto comp4
  bcc32 -A -N -w-par -w-aus -e%2 %1.c %NLIBDIR%\nlib_bc.lib > err.log 	
  goto comp2

:comp4
 
  bcc32 -A -N -w-par -w-aus %1.c %NLIBDIR%\nlib_bc.lib > err.log 	

rem Clean up

:comp2

  type err.log | more 
  if exist %1.obj del %1.obj
  dir %1.*
  goto quit

:usage

  echo -
  echo - This batch file compiles and links a named .c program using 
  echo - the Borland C++ command-line compiler, bcc32.  Usage:
  echo -
  echo -   bc prog 
  echo -
  echo - Here prog is the name of the user program (the .c extension 
  echo - is assumed).  If you get the error message "Bad command or
  echo - file name", then you must first configure the environment to 
  echo - use the Borland C++ command-line compiler (bcc32) as follows:
  echo -
  echo -   1. Add the bin directory of Borland C++ to your path in
  echo -      autoexec.bat and reboot.
  echo -
  echo -   2. Edit the .cfg files in the bin directory of Borland C++
  echo -      to make sure that the paths to the include and lib
  echo -      directories are correct.
  echo -
  goto quit

:nofile

  echo - 
  echo - The source file %1.c does not exist.
  echo - 
  goto quit

:quit
