     /*------------------------------------------------------------------*/
     /* Example A2.11.1: Cumulative Probability Distribution */
     /*------------------------------------------------------------------*/
     #include "c:\nlib\util.h"

     float f (float x)
     {
        return exp(-x*x/2)/sqrt(2*PI);
     }

     int main (void)
     {
        int          n[6]={100,100,100,10,10,30000},
                     i;
        float        a   = -1,               /* lower limit */
                     b   =  1,               /* upper limit */
                     tol =  1.e-6,           /* truncation error */
                     y = 0,
                     x;

        printf ("\nExample A2.11.1: Cumulative Probability Distribution\n");
        printf ("\ntrapezoid = %.7f",trapint(a,b,n[0],f));
        printf ("\nSimpson   = %.7f",simpson(a,b,n[1],f));
        printf ("\nmidpoint  = %.7f",midpoint(a,b,n[2],f));
        printf ("\nRomberg   = %.7f",romberg(a,b,tol,n[3],&n[3],f));
        printf ("\nGauss     = %.7f",gausquad(a,b,n[4],f));
        randinit (1000);
        for (i = 0; i < n[5]; i++)
        {
           x = randg (0,1);
           if ((x >= a) && (x <= b)) y++;
        } 
        printf ("\nDirect    = %.7f",y/n[5]);
        shownum ("Extrapolation level",n[3]);
        return 0;
     }
     /*------------------------------------------------------------------*/
