     /*------------------------------------------------------------------*/
     /* Example A2.13.1: Steady State Temperature */
     /*------------------------------------------------------------------*/
     #include "c:\nlib\util.h"

     float g (float x,float y)               /* boundary values */   
     {
        return cos(PI*(x+y));
     }

     int main (void)
     {
        int          m = 39,                 /* x precision */		
                     n = 39,                 /* y precision */
                     q = 500,                /* maximum iterations */
                     i;
        float        a = 2,                  /* maximum x */
                     b = 2,                  /* maximum y */ 
                     tol = 1.e-4,            /* error bound */
                     alpha;                  /* relaxation parameter */
        vector       x = vec (m,""),         /* x grid values */ 		
                     y = vec (n,"");         /* y grid values */
        matrix       U = mat (m,n,"");       /* solution */

        printf ("\nExample A2.13.1: Steady-State Temperature\n");
        printf ("Computing solution ... ");
        shownum ("Iterations",poisson (a,b,m,n,q,tol,&alpha,x,y,U,NULL,g));
        shownum ("Optimal relaxation parameter",alpha);
        plotxyz (x,y,U,m,n,"Steady-State Temperature","x (m)","y (m)",
                 "u (^oC)","figa2131");
        wait();
        return 0;
     }
     /*------------------------------------------------------------------*/


