     /*----------------------------------------------------------------*/
     /* Example A2.14.1: Digital Signal Processing */
     /*----------------------------------------------------------------*/
     #include "c:\nlib\util.h"

     float g (float f)
     {
     /* Description: Band stop filter */

        return ((f >= .5) && (f <= .7)) ? 0 : 1;
     }   

     int main (void)
     {
        int          p = 30,                        /* select order */ 
                     r = 2*p + 1,                   /* number of terms */
                     n = 512,                       /* number of samples */ 
                     i;
        float        fs = 1000;                     /* sampling frequencies */ 
        vector       b   = vec (r,""),              /* filter coefficients */
                     x   = vec (r,""),              /* filter state */
                     u   = vec (n,"1"),             /* unit pulse input */
                     h   = vec (n,"1"),             /* pulse response */
                     A   = vec (n,""),              /* magnitude response */
                     phi = vec (n,""),              /* phase response */
                     t   = vec (n,""),              /* discrete times */ 
                     f   = vec (n,"");              /* discrete frequencies */
                     
        printf ("\nExample A2.14.1: Digital Signal Processing\n");
        fir (g,p,b);
        showvec ("Filter coefficients",b,r,0);
        for (i = 1; i <= n; i++)
        {
           t[i] = (i - 1)/fs; 	
           h[i] = arma (u[i],b,x,0,2*p);
        }
        graphxy (t,h,3*r/2,"Pulse Response of Band Stop Filter",
                 "t (sec)","h(t)","figa2141");   
        freqrsp (u,h,n,fs,A,phi,f);
        graphxy (f,A,n/2,"Magnitude Response of Band Stop Filter",
                 "f (Hz)","A(f)","figa2142");
        wait(); 
        return 0;
     } 
     /*----------------------------------------------------------------*/

