     /* -------------------------------------------------------------- */
     /* Example A2.6.1: Linear Algebraic Systems */
     /* -------------------------------------------------------------- */
     #include "c:\nlib\util.h"
     int main (void)
     {
        int          n = 5,
                     m = 1000;
        float        tol = 1.e-5,
                     alpha = 1;
        vector       b = randvec (n,-1,1),
                     x = vec (n,"");
        matrix       A = mat (n,n,""),
                     B = randmat (n,n,-1,1);

        printf ("\nExample A2.6.1: Linear Algebraic Systems\n");             
        transpose (B,n,n,A);
        matmat (A,B,n,n,n,A);
        showmat ("A",A,n,n,0);
        showvec ("b",b,n,0);
        shownum ("det(A)",inv(A,n,B));
        showmat ("inv(A)",B,n,n,0);
        shownum ("K(A)",condnum(A,n,0));
        ludec(A,b,n,x);
        showvec ("LU decomposition solution",x,n,0);
        shownum ("||r||",residual(A,b,x,n));
        zerovec (x,n);
        shownum ("Iterations",sr(x,A,b,alpha,tol,n,m));
        showvec ("Successive relaxation solution",x,n,0);
        shownum ("||r||",residual(A,b,x,n));
        return 0;
     }
     /* -------------------------------------------------------------- */

