     /* -------------------------------------------------------------- */
     /* Example A2.7.1: Eigenvalues and Eigenvectors */
     /* -------------------------------------------------------------- */
     #include "c:\nlib\util.h"
     int main (void)
     {
        int         n = 4,
                    m = 500,
                    i;
        float       tol = 1.e-6,
                    t = 0;
        vector      a = vec (n+1,"");	
        cvector     c = cvec (n,"");
        matrix      A = randmat (n,n,-1,1);
        cmatrix     X = cmat (n,n,"");

        printf ("\nExample A2.7.1: Eigenvalues and Eigenvectors\n");
        showmat ("A",A,n,n,0);
        leverrier (A,n,a);
        showvec ("Characteristic polynomial coefficients",a,n+1,0);
        shownum ("QR iterations",qr(A,n,m,tol,c));
        showcvec ("Eigenvalues",c,n,0);
        for (i = 1; i <= n; i++)
           t += A[i][i] - c[i].x;
        shownum ("Trace check",fabs(t));
        i = danilevsky(A,n,m,tol,c,X); 
        if (!i)
        {
           printf ("\nA is a deficient matrix.");
           wait();
        }   
        else
        {
           shownum ("Danilevsky iterations",i);
           showcmat ("Eigenvectors",X,n,n,0);
        }
        return 0;
     }      
/* -------------------------------------------------------------- */


