     /* -------------------------------------------------------------- */
     /* Example A2.8.1: Curve Fitting */
     /* -------------------------------------------------------------- */
     #include "c:\nlib\util.h"

     float f(float x)
     { 
        return sin(PI*x)/(1 + x*x);
     } 

     int main (void)
     {
        int          n = 24,
                     p = 10*n,
                     q = 3,
                     i,j,k;
        float        b = 4,
                     a;		
        vector       x = vec (n,""),
                     y = vec (n,""),
                     w = vec (n,"");
        matrix       A = mat (3,n,""),
                     X = mat (q+1,p,""),
                     Y = mat (q+1,p,"");

        printf ("\nExample A2.8.1: Curve Fitting\n"); 
        for (i = 1; i <= n; i++)
        {
           w[i] = 1;
           a = (i-1)*b/(n-1);
           x[i] = a;
           y[i] = f(a);
        }
        polyfit (0,x,y,w,A,n,n-1,1);             /* initialize A */
        for (i = 1; i <= p; i++)
        {
           a = x[1] + (i-1)*(x[n] - x[1])/(p-1);
           for (j = 1; j <= q; j++)
           {
              X[j][i] = a;
              Y[j][i] = polyfit (a,x,y,w,A,n,3*j-1,0);
           }
           k = MIN (i,n);
           X[q+1][i] = x[k];
           Y[q+1][i] = y[k];
        }
        graphmm (X,Y,q+1,p,"Least-Squares Fit","x","y","figa281",1);
        wait();
        return 0;
     }
     /* -------------------------------------------------------------- */

