     /*------------------------------------------------------------------*/
     /* Example A2.9.1: Root Finding */
     /*------------------------------------------------------------------*/
     #include "c:\nlib\util.h"

     float f(float x)                      /* bisection, secant */
     {                             
        return (1 - x - sqrt(x));
     }
     complex g(complex x)                  /* Muller */
     {                         
        return (csub(csub(cnum(1,0),x),csqrt(x)));
     }
     void h(vector x,int n,vector y)       /* Newton */
     {               
        y[1] = 1 - x[1] - sqrt(x[1]);
     }
   
     int main (void)
     {
        int          m = 100,
                     n = 1,
                     i;
        float        x0 = 0,
                     x1 = 1,
                     tol = 1.e-6,
                     x;
        complex	u0 = {0,0},
                     u1 = {1,0},
                     u2 = {2,0},
                     u;
        vector	v = vec (n,"1");

        printf ("\nExample A2.9.1: Root Finding\n");
        printf ("\n------------------------------------------");
        i = bisect (x0,x1,tol,m,&x,f);
        printf ("\nBisection: x = %9.5f cm, %2i iterations",100*x,i);
        i = secant (x0,x1,tol,m,&x,f);
        printf ("\nSecant:    x = %9.5f cm, %2i iterations",100*x,i); 
        i = muller (u0,u1,u2,tol,m,&u,g);
        printf ("\nMuller:    x = %9.5f cm, %2i iterations",100*u.x,i); 
        i = newton (v,tol,n,m,h,NULL);
        printf ("\nNewton:    x = %9.5f cm, %2i iterations",100*v[1],i); 
        printf ("\n------------------------------------------");
        wait(); 
        return 0;
     }
     /*------------------------------------------------------------------*/


