/*------------------------------------------------------------------*/
/* Example 10.4.1: Target detection                                 */
/*------------------------------------------------------------------*/

#include "c:\nlib\util.h"

int main (void)
{
   int		i,
		N = 512,
		M = 256,
		d = 200,
		seed = 1000;
   float	alpha = 0.05,
		beta = 0.05;
   vector       t = vec (N,""),
		x = vec (N,""),
   		y = vec (M,""),
   		pxy = vec (N,"");

   printf ("\nExample 10.4.1: Target Detection\n");
   randinit (seed);
   for (i = 1; i <= N; i++)
   {
      t[i] = i - 1;
      if (i <= M)
         y[i] = randg (0,1);
      x[i] = randg (0,beta);
      if ((i > d) && (i <= d+M))
         x[i] += alpha*y[i-d];
   }
   graphxy (t,x,N,"The Received Signal x(k)","k","x(k)","fig1042"); 
   putstr0 ("axis([0 600 -0.4 0.4])","fig1042.m",0);
   crosscor (x,y,N,M,pxy);
   graphxy (t,pxy,N,"Normalized Cross Correlation of x(k) with y(k)",
            "i","\\rho_{xy}(i)","fig1043");
   wait();
   return;
 }
/*------------------------------------------------------------------*/

