/*------------------------------------------------------------------*/
/* Example 10.5.2: Convolution                                      */
/*------------------------------------------------------------------*/

#include "c:\nlib\util.h"

int main (void)
{
   int		i,
		q = 512,
		p = 50,
		seed = 50;
   float	a = 1.0,
		b = q/3;
   vector   	t = vec (q,""),
   		h = vec (q,""),
   		u = vec (q,""),
   		y = vec (q,"");

   printf ("\nExample 10.5.2: Convolution\n");   		
   randinit (seed);
   for (i = 1; i <= q; i++)
   {
      t[i] = i - 1;
      if (i <= p)
         h[i] = 1.0/p;
      u[i] = exp(-t[i]/b)*sin(2*PI*t[i]/b) + randg(0,a);
   }
   convolve (h,u,q,y);
   graphxy (t,u,q,"Input to Running Average Filter",
            "k","u(k)","fig1052");
   putstr0 ("axis([0 600 -4 4])","fig1052.m",0);         
   graphxy (t,y,q,"Output from Running Average Filter (p = 50)",
            "k","y(k)","fig1053");
   putstr0 ("axis([0 600 -0.8 0.8])","fig1053.m",0);         
   wait();
   return 0;
}
/*------------------------------------------------------------------*/


