/*------------------------------------------------------------------*/
/* Example 10.6.1: FIR filter                                       */
/*------------------------------------------------------------------*/

#include "c:\nlib\util.h"

float g (float f)
{
   float fN = 2000.0/2,	
         fl = 200.0/fN,
         fh = 600.0/fN;

   return ((f >= fl) && (f <= fh)) ? 1 : 0;
}

int main (void)
{
   int		i,
		q = 1024,
		p = 20,
		seed = 100;
   float	fs = 2000;
   vector       f = vec (q,""),
   		u = vec (q,""),
   		y = vec (q,""),
   		A = vec (q,""),
   		phi = vec (q,""),
   		b = vec (q,"");

   printf ("\nExample 10.6.1: FIR Filter\n");
   randinit (seed);
   for (i = 1; i <= q; i++)
      u[i] = randg (0,1);
   fir (g,p,b);
   convolve (b,u,q,y);

   spectra (u,q,fs,A,phi,f);
   graphxy (f,A,q/2,"Magnitude Spectrum of White Noise Input",
            "f (Hz)","A(f)","fig1065");
   putstr0 ("axis([0 1000 0 100])","fig1065.m",0);
   spectra (y,q,fs,A,phi,f);
   graphxy (f,A,q/2,"Magnitude Spectrum of Filter Output",
            "f (Hz)","A(f)","fig1066");
   putstr0 ("axis([0 1000 0 100])","fig1066.m",0);
   wait();
   return 0;
 }
/*------------------------------------------------------------------*/

   

   
 
