/*------------------------------------------------------------------*/
/* Example 10.7.1: Two-dimensional FFT                              */
/*------------------------------------------------------------------*/

#include "c:\nlib\util.h"

float f (float x,float y)
{
   return exp(-y)*sin(PI*x);
}  

int main (void)
{
   int		m = 64,
		n = m,
		k,i;
   float 	delta_x = 1.0/8.0,
		delta_y = 1.0/10.0;
   vector       x = vec (m,""),
   		y = vec (n,"");
   matrix       A = mat (m,n,"");
   cmatrix      Z = cmat (m,n,"");
   
   printf ("\nExample 10.7.1: Two-Dimensional FFT\n"); 
   for (k = 1; k <= m; k++)
   {
      x[k] = (k-1)*delta_x;	
      for (i = 1; i <= n; i++)
      {
      	 y[i] = (i-1)*delta_y;
         A[k][i] = f(x[k],y[i]);
         Z[k][i].x = A[k][i];
      }
   }
   plotxyz (x,y,A,m,n,
            "A Two-Dimensional Signal z(k,i)",
            "x","y","z","fig1072");
   
   dft2 (Z,m,n,1);
   for (k = 1; k <= m; k++)
   {
      x[k] = (k-1)/(m*delta_x);	
      for (i = 1; i <= n; i++)
      {
         y[i] = (i-1)/(n*delta_y);
         A[k][i] = cmag(Z[k][i]);
      }
   }
   plotxyz (x,y,A,m/2,n/2,
            "Two-Dimensional Magnitude Spectrum A(m,n)",
            "f_x","f_y","A","fig1073");
   wait();
   return 0;
}
/*------------------------------------------------------------------*/
   
 

