/*----------------------------------------------------------------*/
/* Example 10.8.2: LMS method                                     */
/*----------------------------------------------------------------*/

#include "c:\nlib\util.h"

int main (void)
{
   int          i,j,
		p = 512,
		n1 = 3,
                m1 = 3,
		n2 = 0,
		m2 = 32,
                r1 = n1 + m1 + 1,
                r2 = n2 + m2 + 1;
   float	mu = 1.0/(m2+1);
   vector       theta1 = vec (r1,"-.5 .6 -.3 1. -2. 8. -4."), 
  		theta2 = vec (r2,""),
   		x1 = vec (r1,""),
   		x2 = vec (r2,""),
   		t = vec (p,""),
   		u = vec (p,""),
   		e = vec (p,"");
   matrix       Y = mat (2,p,"");

/* Identify system */ 

   printf ("\nExample 10.8.2: LMS Method\n");
   showvec ("theta",theta1,r1,0);
   printf ("\nmu%g",mu);
   for (i = 1; i <= p; i++)
   {
      t[i] = i - 1; 	
      u[i] = randu (-1,1);
      Y[1][i] = arma (u[i],theta1,x1,n1,m1);
      e[i] = lms (u[i],Y[1][i],x2,theta2,mu,m2);
   }
         
   showvec ("estimated theta",theta2,r2,0);
   graphxy (t,e,p,"LMS Error Signal","k","e(k)","fig1085");  
         
/* Compare responses */
   
   zerovec (x1,r1);
   zerovec (x2,r2);
   for (i = 1; i <= p; i++)
   {
      u[i] = randu(-1,1);
      Y[1][i] = arma (u[i],theta1,x1,n1,m1);
      Y[2][i] = arma (u[i],theta2,x2,n2,m2);
   }
   graphxm (t,Y,2,MIN(50,p),
            "Time Responses of System and LMS Model",
            "k","outputs","fig1086");
   putstr0 ("axis([0 50 -10 10])","fig1086.m",0);
   wait();
   return 0; 
}
/*----------------------------------------------------------------*/
   
