/*---------------------------------------------------------------------*/
/* Example 10.9.2: Flag Pole Motion                                    */
/*---------------------------------------------------------------------*/

#include "c:\nlib\util.h"

int main (void)
{
   int          p,                      /* number of samples */	
                n = 0,                  /* number of past outputs */ 		
                m = 20,                 /* number of past inputs */
                r = n + m + 1,
                i,j;
   vector       theta = vec (r,""),     /* parameters */ 
                x     = vec (r,""),     /* states */
                t,                      /* time data */
                u,                      /* input data */
                y;                      /* output data */
   matrix       Y;                      /* outputs */
   FILE         *f;
   
/* Get input/output data */

   printf ("\nExample 10.9.2: Flag Pole Motion\n");
   f = fopen ("data1092.m","r");
   t = getvec (f,&p);
   u = getvec (f,&p);
   y = getvec (f,&p);
   fclose (f);
   Y = mat (2,p,"");
   Y[1] = y;
   
/* Identify MA model and compare responses */

   getarma(u,y,p,n,m,theta);
   showvec ("theta",theta,r,0);
   for (i = 1; i <= p; i++)
      Y[2][i] = arma (u[i],theta,x,n,m);
   graphxm (t,Y,2,p,"Response of MA Model Due to Wind",
            "t (sec)","y (cm)","fig1094");

/* Write theta to file */

   f = fopen ("theta.dat","w");
   for (i = 1; i <= r/2; i++)
   {
      j = r/2 + 1 + i;	
      fprintf (f,"%i & %.3f & %i & %.3f \\\\ \n",
               i,theta[i],j,theta[j]);
   }
   fprintf (f,"%i & %.3f & & \\\\ \n",r/2+1,theta[r/2+1]);
   wait();
   return 0;
}
/*---------------------------------------------------------------------*/

   
