/*----------------------------------------------------------------*/
/* Example 10.9.3: Band Pass Filter                               */
/*----------------------------------------------------------------*/

#include "c:\nlib\util.h"

float g (float f)
{
/* Description: Band pass filter */

   return ((f >= 0.4) && (f <= 0.8)) ? 1 : 0;
}
 
int main (void)
{
   int          i,
                p = 25,
                r = 2*p + 1,                   /* number of terms */
                n = 512;                       /* number of samples */ 
   float        fs = 1000.0f;                  /* sampling frequencies */ 
   vector       b   = vec (r,""),              /* filter coefficients */
                x   = vec (r,""),              /* filter state */
       		u   = vec (n,"1"),	           /* unit pulse input */ 		
                y   = vec (n,""),	           /* pulse response */	
                A   = vec (n,""),              /* magnitude response */
                phi = vec (n,""),              /* phase response */
                f   = vec (n,"");              /* discrete frequencies */

/* Find coefficients */
                
   printf ("\nExample 10.9.3: Band Pass Filter\n");
   fir (g,p,b);
   showvec ("Filter coefficients",b,r,0);

/* Compute pulse response and magnitude response */

   for (i = 1; i <= n; i++)
      y[i] = arma (u[i],b,x,0,r-1);
   freqrsp (u,y,n,fs,A,phi,f);
   graphxy (f,A,n/2,"Magnitude Response of Band Pass Filter (p = 25)",
            "f (Hz)","A(f)","fig1095");
   wait();
   return 0;
} 
/*----------------------------------------------------------------*/



