/* ------------------------------------------------------------------- */
/* Example 1.8.1: Estimating PI by Throwing Darts                      */
/* ------------------------------------------------------------------- */

#include "c:\nlib\util.h"

int main (void)
{                              
    int    n    = 5000,         /* number of random points */
           p    = 0,            /* number of points inside unit circle */ 
           seed = 1000,         /* select random sequence */
           i;
    float  s = 3.0,             /* size of square mat */
           x,y,r,q;       
    vector e = vec (n,"");      /* errors in estimate */       
              
/* Generate estimate with random numbers */

    printf ("\nExample 1.8.1: Estimating PI by Throwing Darts\n");
    randinit(seed);
    for (i = 1; i <= n; i++)
    {
       x = randu (-s/2,s/2);
       y = randu (-s/2,s/2);
       r = sqrt(x*x + y*y);
       if (r <= 1)
          p += 1;
       q = s*s*p/i;
       e[i] = q - PI;
    }

/* Display results */

    shownum ("Number of random points",n);
    shownum ("Final estimate of PI",q);
    graphvec (e,n,"Error in Estimate of \\pi","number of darts",
              "error","fig182");
    wait();
    return 0;
}
/* ------------------------------------------------------------------- */
