/* -------------------------------------------------------------- */
/* Example 2.6.1 Jacobi's Iterative Method */
/* -------------------------------------------------------------- */ 
#include "c:\nlib\util.h"
int main (void)
{
   int          i,j,k,
		n = 3;
   float	a;
   vector	b = vec (n,"7 2 -4"),
		x = vec (n,""),
		y = vec (n,"");
   matrix	A = mat (n,n,"5 0 -2  3 5 1  0 -3 4");
   printf ("\nExample 2.6.1: Jacobi Iterative Method\n");
   showmat ("A",A,n,n,0);
   showvec ("b",b,n,0);
   printf ("\nk       x[1]         x[2]         x[3]       ||r(x)||"); 
   printf ("\n-----------------------------------------------------"); 
   for (k = 0; k < 10; k++)
   {
      printf ("\n%i & %10.7f & %10.7f & %10.7f & %10.7f \\\\",
               k,x[1],x[2],x[3],residual(A,b,x,n)); 
      copyvec (x,n,y);
      for (i = 1; i <= n; i++)
      {
      	 a = A[i][i];
      	 x[i] = b[i]/a;
      	 for (j = 1; j <= n; j++)
      	    if (j != i)
      	       x[i] -= A[i][j]*y[j]/a;
      }
   }
   printf ("\n-----------------------------------------------------"); 
   wait();
   return 0;
}
/* -------------------------------------------------------------- */

