/* -------------------------------------------------------------- */
/* Example 2.6.2: Gauss-Seidel Iterative Method */
/* -------------------------------------------------------------- */ 
#include "c:\nlib\util.h"
int main (void)
{
   int          i,
		n = 3;
   float	alpha = 1;
   vector	b = vec (n,"7 2 -4"),
		x = vec (n,"");
   matrix	A = mat (n,n,"5 0 -2  3 5 1  0 -3 4");
   printf ("\nExample 2.6.2: Gauss-Seidel Iterative Method\n");
   showmat ("A",A,n,n,0);
   showvec ("b",b,n,0);
   printf ("\nk       x[1]         x[2]         x[3]       ||r(x)||"); 
   printf ("\n-----------------------------------------------------"); 
   for (i = 0; i < 10; i++)
   {
      printf ("\n%i & %10.7f & %10.7f & %10.7f & %10.7f \\\\",
               i,x[1],x[2],x[3],residual(A,b,x,n)); 
      zerovec (x,n);
      sr (x,A,b,alpha,0,n,i+1);
   }
   printf ("\n-----------------------------------------------------"); 
   wait();
   return 0;
}
/* -------------------------------------------------------------- */


