/* -------------------------------------------------------------- */
/* Example 2.6.3: Successive Under-Relaxation Method */
/* -------------------------------------------------------------- */ 
#include "c:\nlib\util.h"
int main (void)
{
   int          i,j,
		n = 3;
   float	alpha;
   vector	b = vec (n,"7 2 -4"),
		x = vec (n,"");
   matrix	A = mat (n,n,"5 0 -2  3 5 1  0 -3 4");
   printf ("\nExample 2.6.3: Successive Under-Relaxation Method\n");
   showmat ("A",A,n,n,0);
   showvec ("b",b,n,0);
   printf ("\nalpha     0.7          0.8          0.9          1.0          1.1");
   printf 
   ("\n--------------------------------------------------------------------"); 
   for (i = 0; i < 10; i++)
   {
      printf ("\n  %i ",i);
      for (j = 1; j <= 5; j++)
      {
      	 alpha = 0.6 + j/10.0;
         zerovec (x,n);
         if (i > 0)
            sr (x,A,b,alpha,0,n,i);
         printf ("& %10.7f ",residual(A,b,x,n));
      }
      printf ("\\\\");
   }
   printf 
   ("\n--------------------------------------------------------------------"); 
   wait();
   return 0;
}   
/* -------------------------------------------------------------- */


