/* -------------------------------------------------------------- */
/* Example 2.6.4 Successive Over-Relaxation Method */
/* -------------------------------------------------------------- */
#include "c:\nlib\util.h"
int main (void)
{
   int          i,
 		n = 3,
		m = 39,
		jmax=800;
   float	eps = 1.e-5;
   vector	b = vec (n,"2 -4 24"),
		x = vec (n,""),
		a = vec (m,""),
		y = vec (m,"");
   matrix	A = mat (n,n," 1 2 3  2 9 6  3 6 27");
   printf ("\nExample 2.6.4: Successive Over-Relaxation Method\n");
   showmat ("A",A,n,n,0);
   showvec ("b",b,n,0);
   for (i = 1; i <= m; i++)
   {
      a[i] = 0.05 + (i-1)/20.0;
      zerovec (x,n);
      y[i] = sr (x,A,b,a[i],eps,n,jmax);
   }
   showvec ("x",x,n,0);   
   graphxy (a,y,m,"Successive Over-Relaxation Method",
            "\\alpha","N","fig261");
   wait();
   return 0;   
} 
/* -------------------------------------------------------------- */

