/* ----------------------------------------------------------------- */
/* Example 2.7.1: Chemical Absorption Process                        */
/* ----------------------------------------------------------------- */

#include "c:\nlib\util.h"

int main (void) 
{
   int          n = 5,			/* number of stages */
 		i;
   float        a = 0.72f,		/* slope */	
		b = 0.0f,		/* intercept */
		K = 1.63f,		/* gas to liquid ratio */ 
		xf = 0.01f,		/* liquid feed concentration */ 
		yf = 0.06f,		/* gas feed concentration */
		delta = a*K;		/* stripping factor */
   vector       x = vec (n,""),
		c = vec (n,""),
		y = vec (n,"");
   matrix       A = mat (n,n,"");
   
/* Initialize A and y */

   printf ("\nExample 2.7.1: Chemical Absorption Process\n");
   putchar('\n');
   for (i = 1; i <= n; i++)
   {
      A[i][i] = -(1 + delta);
      if (i < n)
      {
         A[i][i+1] = 1;
         A[i+1][i] = delta;
      }
   }
   c[1] = K*(b - yf);
   c[n] = -xf;
   showmat ("A",A,n,n,0);
   showvec ("c",c,n,0);
   
/* Find liquid concentrations */

   shownum ("K(A)",condnum(A,n,0));
   ludec (A,c,n,x);
   showvec ("x",x,n,0);
   for (i = 1; i <= n; i++)
      y[i] = a*x[i] + b;
   showvec ("y",y,n,0);   
   shownum ("||r(x)||",residual(A,c,x,n)); 
   return 0;
}
/* -------------------------------------------------------------- */
