/* ------------------------------------------------------------------- */
/* Example 2.7.2: Planar Truss                                         */
/* ------------------------------------------------------------------- */

#include "c:\nlib\util.h"

int main (void)
{                              
   int          n = 8;                      /* number of forces */	 
   float        theta = PI/3.0f,            /* joint A angle */
                phi   = PI/6.0f;            /* joint D angle */            
   vector       f = vec (n,""),
                g = vec (n,"0 0 -250 0 0 1500 0 0 0");
   matrix       A = mat (n,n,"");

/* Initialize A */

   printf ("\nExample 2.7.2: Planar Truss\n");
   A[1][1] = (float) cos(theta);
   A[2][1] = (float) sin(theta);
   A[3][1] = (float) -cos(theta);
   A[4][1] = (float) -sin(theta);
   A[3][4] = (float) cos(phi);
   A[4][4] = (float) -sin(phi);
   A[8][4] = (float) sin(phi);
   A[7][4] = (float) -cos(phi);
   A[1][2] = A[2][7] = A[5][5] = A[6][3] = A[8][8] = 1;
   A[1][6] = A[4][3] = A[5][2] = A[7][5] = -1;
   showmat ("A",A,n,n,0);
   showvec ("g",g,n,0);
   
/* Find forces */

   shownum ("K(A)",condnum(A,n,0));
   ludec(A,g,n,f);
   showvec ("f",f,n,0);
   shownum ("||r(f)||",residual(A,g,f,n));
   return 0;
}
/* ------------------------------------------------------------------- */


