/* -------------------------------------------------------------- */
/* Example 2.7.3: DC Bridge Circuit                               */
/* -------------------------------------------------------------- */

#include "c:\nlib\util.h"

int main (void)
{
   int          n = 3;
   float        Gs = 1.0f/10.0f,
		GL = 1.0f/1000.0f,
	        G1 = 1.0f/220.0f,
	        G2 = 1.0f/330.0f,
	        G3 = 1.0f/470.0f,
  	        G4 = 1.0f/560.0f,
	        E  = 12.0f;
   vector       v = vec (n,""),
		b = vec (n,"");
   matrix       A = mat (n,n,"");

/* Initialize A and b */

   printf ("\nExample 2.7.3: DC Bridge Circuit\n");
   A[1][1] = Gs + G1 + G1;
   A[1][2] = -G1;
   A[1][3] = -G2;
   A[2][1] = -G1;
   A[2][2] = G1 + G3 + GL;
   A[2][3] = -GL;
   A[3][1] = -G1;
   A[3][2] = -GL;
   A[3][3] = G2 + G4 + GL;
   b[1] = Gs*E;
   showmat ("A",A,n,n,0);
   showvec ("b",b,n,0);
   
/* Find node voltages */

   shownum ("K(A)",condnum(A,n,0));
   ludec(A,b,n,v);
   showvec ("v",v,n,0);
   shownum ("||r(v)||",residual(A,b,v,n));
   return 0;
}
/* -------------------------------------------------------------- */

