/* -------------------------------------------------------------- */
/* Example 2.7.4: Mass-Spring-Damper System                       */
/* -------------------------------------------------------------- */

#include "c:\nlib\util.h"

int main (void)
{
   int          n = 4;                /* system order */
   float        m1 = 15.0f,           /* mass 1 */
                m2 = 30.0f,           /* mass 2 */
                k1 = 3.2f,            /* spring constant 1 */
                k2 = 2.4f,            /* spring constant 2 */
                b = 0.5f,             /* viscous friction coefficient */
                F = 1.2f;             /* applied force */
   vector       x = vec (n,""),
                y = vec (n,"");
   matrix       A = mat (n,n,"");
   
/* Initialize A and y */

   printf ("\nExample 2.7.4: Mass-Spring-Damper System\n");
   A[1][2] = A[3][4] = 1;
   A[2][1] = -(k1+k2)/m1;
   A[2][2] = -b/m1;
   A[2][3] = k2/m1;
   A[4][1] = k2/m2;
   A[4][3] = -k2/m2;
   y[4] = -F/m2;
   showmat ("A",A,n,n,0);
   showvec ("y",y,n,0);
   
/* Find positions and velocities */

   shownum ("K(A)",condnum(A,n,0));
   ludec(A,y,n,x);
   showvec ("x",x,n,0);
   shownum ("||r(x)||",residual(A,y,x,n));
   return 0;
}
/* -------------------------------------------------------------- */

