/*------------------------------------------------------------------*/
/* Example 3.4.1: Jacobi's method */
/*------------------------------------------------------------------*/
#include "c:\nlib\util.h"
int main (void)
{
   int		n = 2,
		m = 25,
		i;
   float	tol = 1.e-7,
		phi;
   vector       c = vec (n,"");	
   matrix	A = mat (n,n,"-1,2, 2,2"),
		P = mat (n,n,""),
		R = mat (n,n,"");
   printf ("\nExample 3.4.1: Jacobi's Method\n");
   i = jacobi (A,n,m,tol,c,P);
   showmat ("A",A,n,n,0);
   shownum ("Jacobi iterations",i);
   showvec ("Eigenvalues",c,n,0);
   showmat ("Eigenvectors",P,n,n,0);
   phi = atan2 (2*A[1][2],A[1][1]-A[2][2])/2;
   shownum ("phi",phi);
   R[1][1] = cos(phi);
   R[2][2] = cos(phi);
   R[1][2] = -sin(phi);
   R[2][1] = sin(phi);
   showmat ("R",R,n,n,0); 
   matmat (A,R,n,n,n,A);
   transpose (R,n,n,R);
   matmat (R,A,n,n,n,A);
   showmat ("R'AR",A,n,n,0);
   return 0;
}
/*------------------------------------------------------------------*/

