/*------------------------------------------------------------------*/
/* Example 3.5.1: Householder Transformation */
/*------------------------------------------------------------------*/
#include "c:\nlib\util.h"
int main (void)
{
   int		n = 3,
		k = 1,
		i,j; 
   float	alpha = 0,
		beta;
   vector	u = vec (n,"");
   matrix	A = mat (n,n,"1,-2,3, -2,4,1, 3,1,2"),
   		I = mat (n,n,"1,0,0, 0,1,0, 0,0,1"),
   		P = mat (n,n,""),
   		B = mat (n,n,"");

   printf ("\nExample 3.5.1: Householder Transformation\n");		
   house (A,n,B,P);
   showmat ("A",A,n,n,0);
   showmat ("B",B,n,n,0);
   for (j = k+1; j <= n; j++)
      alpha += A[j][k]*A[j][k];
   alpha = SGN(A[k+1][k])*sqrt(alpha);
   shownum ("alpha",alpha);
   for (j = 1; j <= n; j++)
   {
      if (j <  (k+1))  u[j] = 0;
      if (j == (k+1))  u[j] = A[j][k] + alpha;
      if (j >  (k+1))  u[j] = A[j][k];
   }
   showvec ("u",u,n,0);
   beta = inner (u,u,n)/2;
   for (i = 1; i <= n; i++)
      for (j = 1; j <= n; j++)
         P[i][j] = I[i][j] - u[i]*u[j]/beta;
   showmat ("P",P,n,n,0);
   matmat (A,P,n,n,n,A);
   matmat (P,A,n,n,n,A);
   showmat ("P'AP",A,n,n,0);
   return 0;
}
/*------------------------------------------------------------------*/


