/* -------------------------------------------------------------- */
/* Example 3.7.1: Danilevsky's Method */
/* -------------------------------------------------------------- */
#include "c:\nlib\util.h"
int main (void)
{
   int          n = 4,
		m = 50,
		i,j,p;
   float        tol = 1.e-6,
		q = 0;
   cvector	c = cvec (n,"");
   matrix	A = mat (n,n,"2,-1,3,4 0,7,1,-6 5,8,0,-3 1,4,-3,9");  
   cmatrix	X = cmat (n,n,"");
   FILE         *f = fopen ("out.lat","a");
   printf ("\nExample 3.7.1: Danilevsky's Method\n");
   showmat ("A",A,n,n,0);
   p = danilevsky (A,n,m,tol,c,X);
   printf ("\nDanilevsky iterations = %i\n\n",p);
   if (p > 0)
   {
      showcmat ("eigenvectors",X,n,n,0);
      for (i = 1; i <= n; i++)
      {
         fprintf (f,"\n %.4f %+.4fj & ",c[i].x,c[i].y);
         for (j = 1; j < n; j++)
            fprintf (f,"%.4f %+.4fj & ",X[i][j].x,X[i][j].y);
         fprintf (f,"%.4f %+.4fj \\\\",X[i][n].x,X[i][n].y);
      }
   }
   for (j = 1; j <= n; j++)
      q += c[j].x - A[j][j];
   printf ("\nTrace check = %.4g",fabs(q));
   wait();
   return 0;
}  
/* -------------------------------------------------------------- */

