/* -------------------------------------------------------------- */
/* Example 3.9.4: Rotating Masses and Torsional Springs           */
/* -------------------------------------------------------------- */

#include "c:\nlib\util.h"

int main (void)
{
   int          n = 4,			/* order of system */
   		m = 500,		/* maximum iterations */
   		i;
   		
   float        J1 = 1.5f,		/* moment of inertia 1 */
		J2 = 3.8f,		/* moment of inertia 2 */
		k1 = 5.1f,		/* spring constant 1 */
		k2 = 8.3f,		/* spring constant 2 */
		eps = 1.e-6f,		/* convergence threshold */
		t = 0.0f;
		
   cvector	lambda = cvec (n,"");	/* eigenvalues */	
		
   matrix       A = mat (n,n,"");
   
/* Initialize A */

   printf ("\nExample 3.9.4: Rotating Masses and Torsional Springs\n");
   A[1][2] = A[3][4] = 1;
   A[2][1] = -(k1 + k2)/J1;
   A[2][3] = k2/J1;
   A[4][1] = k2/J2;
   A[4][3] = -k2/J2;  
   showmat ("A",A,n,n,0);
   
/* Find eigenvalues and oscillation frequencies */

   shownum ("QR iterations",(float) qr(A,n,m,eps,lambda));
   showcvec ("Eigenvalues",lambda,n,0);
   for (i = 1; i <= n; i++)
      t += A[i][i] - lambda[i].x;
   shownum ("Trace check",(float) fabs(t)); 
   shownum ("T1",(float) fabs(2*PI/lambda[1].y));
   shownum ("T2",(float) fabs(2*PI/lambda[3].y));
   return 0;
}
/* -------------------------------------------------------------- */



