/* -------------------------------------------------------------- */
/* Example 4.1.1: Variation in Gravity with Latitude              */
/* -------------------------------------------------------------- */
#include "c:\nlib\util.h"
int main (void)
{
   char         *fname = "data411.m";	
   int          n,m,i,j,p=4;
   float	a;
   vector	x,y,w;
   matrix       X,Y,A;
   FILE		*f;

/* Get data */

   printf ("\nExample 4.1.1: Variation in Gravity with Latitute\n");
   if ((f = fopen (fname,"r")) == NULL)
   {
      printf ("\nThe file %s does not exist.",fname);
      exit(1);
   }
   else
   {
      x = getvec (f,&n);
      showvec ("x",x,n,0);
      y = getvec (f,&n);
      showvec ("y",y,n,0);
      fclose (f);
   }

/* Perform least-squares fit of degree p */
   
   m = 10*n; 
   w = vec (n,"");
   A = mat (3,n,"");
   X = mat (2,m,"");
   Y = mat (2,m,"");
   for (i = 1; i <= n; i++)
      w[i] = 1;
   polyfit (0,x,y,w,A,n,p,1);

/* Plot curve and data */    

   for (i = 1; i <= m; i++)
   {
      a = x[1] + (i-1)*(x[n] - x[1])/(m-1);
      X[1][i] = a;
      Y[1][i] = polyfit (a,x,y,w,A,n,p,0);
      j = MIN (i,n);
      X[2][i] = x[j];
      Y[2][i] = y[j];
   }
   graphmm (X,Y,2,m,"Variation in Gravity with Latitude",
            "latitude (deg.)","g (m/s^2)","fig411",1);
   wait();
   return 0;
}
/* -------------------------------------------------------------- */

