/* -------------------------------------------------------------- */
/* Example 4.2.1: Piecewise-Linear Fit */
/* -------------------------------------------------------------- */
#include "c:\nlib\util.h"
int main (void)
{
   int          n = 9,
		p = 20*n,
		i,j;
   vector       x = vec (n,"0 1 2 3 4 5 6 7 8"),
                y = vec (n,"6 0 2 -1 3 4 -2 5 4");		
   matrix       X = mat (2,p,""),
		Y = mat (2,p,"");

   printf ("\nExample 4.2.1: Piecewise-Linear Fit\n");
   showvec ("x",x,n,0);
   showvec ("y",y,n,0);
   for (i = 1; i <= p; i++)
   {
      X[1][i] = x[1] + (i-1)*(x[n] - x[1])/(p-1);
      Y[1][i] = piece (X[1][i],x,y,n);
      j = MIN(i,n);
      X[2][i] = x[j];
      Y[2][i] = y[j];
   }
   graphmm (X,Y,2,p,"Piecewise-Linear Fit","x","y","fig422",1);
   wait(); 
   return 0;
}
/* -------------------------------------------------------------- */
