/* -------------------------------------------------------------- */
/* Example 4.2.2: Quadratic Polynomial Fit */
/* -------------------------------------------------------------- */
#include "c:\nlib\util.h"
int main (void)
{
   int          n = 3,
   		m = 10*n+1,
		i,j;
   float	a;
   vector       x = vec (n,"0 1 2"),
                y = vec (n,"6 0 2"), 
                w = vec (n,"1 1 1");
   matrix	A = mat (3,n,""),
		X = mat (2,m,""),
   		Y = mat (2,m,"");

   printf ("\nExample 4.2.2: Quadratic Polynomial Fit\n");
   showvec ("x",x,n,0);
   showvec ("y",y,n,0); 
   polyfit (0,x,y,w,A,n,n-1,1);
   for (i = 1; i <= m; i++)
   {
      a = x[1] + (i-1)*(x[n] - x[1])/(m-1);
      X[1][i] = a;
      Y[1][i] = polyfit (a,x,y,w,A,n,n-1,0);
      j = MIN (i,n);
      X[2][i] = x[j];
      Y[2][i] = y[j];
   }
   graphmm (X,Y,2,m,"Quadratic Polynomial Fit","x","y","fig424",1);
   wait();
   return 0;
}
/* -------------------------------------------------------------- */
