/* -------------------------------------------------------------- */
/* Example 4.2.4: Lagrange Interpolating Polynomials              */
/* -------------------------------------------------------------- */
#include "c:\nlib\util.h"

/* -------------------------------------------------------------- */
float Lagrange (float a,vector x,int n,int k) {
/* -------------------------------------------------------------- */

/* Description: Return kth Lagrange interpolating polynomial
		evaluated at a. */

   int		i;
   float	y = 1;
   for (i = 1; i <= n; i++)
      if (i != k)
         y *= (a - x[i])/(x[k] - x[i]);
   return y; }      

int main (void)
{
   int          m = 4,
   		n = 10*m+1,
		i,j,k;
   vector	u = vec (m+1,"");
   matrix	X = mat (m+1,n,""),
   		Y = mat (m+1,n,"");

   printf ("\nExample 4.2.4: Lagrange Interpolating Polynomials\n");		
   for (i = 1; i <= m; i++) 
      u[i] = i - 1;
   showvec ("Independent variables",u,m,0);
   for (i = 1; i <= m; i++)
      for (j = 1; j <= n; j++)
      {
      	 X[i][j] = u[1] + (u[m]-u[1])*(j-1)/(n-1);
         Y[i][j] = Lagrange (X[i][j],u,m,i);
      }
   for (j = 1; j <= m; j++)
      X[m+1][j] = j - 1;
   graphmm (X,Y,m+1,n,"Lagrange Interpolating Polynomials",
            "x","y","fig425",1);
   addlabel (.15,.8,"Q_1","fig425");
   addlabel (1.11,.8,"Q_2","fig425");
   addlabel (1.80,.8,"Q_3","fig425");
   addlabel (2.73,.8,"Q_4","fig425");
   wait();
   return 0;
 }
/* -------------------------------------------------------------- */




