/* -------------------------------------------------------------- */
/* Example 4.4.1 Polynomial Fit                                   */
/* -------------------------------------------------------------- */
#include "c:\nlib\util.h"
int  main (void)
{
   int          n = 9,
   		m = 10*n,
		i,j;
   float	d = 4,
                a;  		
   vector       x = vec (n,""),
                y = vec (n,""),
                w = vec (n,"");
   matrix       X = mat (2,m,""),
   		Y = mat (2,m,""),
                A = mat (3,n,"");

   printf ("\nExample 4.4.1: Polynomial Fit\n");             
   for (i = 1; i <= n; i++)
   {
      a = -d + 2*d*(i-1)/(n-1);
      x[i] = a;
      y[i] = 1/(1 + a*a);
      w[i] = 1;
   }
   showvec ("x",x,n,0);
   showvec ("y",y,n,0);
   polyfit (0,x,y,w,A,n,n-1,1);
   for (i = 1; i <= m; i++)
   {
      a = x[1] + (i-1)*(x[n] - x[1])/(m-1);
      X[1][i] = a;
      Y[1][i] = polyfit (a,x,y,w,A,n,n-1,0);
      j = MIN (i,n);
      X[2][i] = x[j];
      Y[2][i] = y[j];
   }
   graphmm (X,Y,2,m,"Polynomial Fit","x","y","fig441",1);
   wait();
   return 0;
}
/* -------------------------------------------------------------- */


