/* -------------------------------------------------------------- */
/* Example 4.5.3: Constant, Linear, and Quadratic Fits            */
/* -------------------------------------------------------------- */
#include "c:\nlib\util.h"
int main (void)
{
   int          n = 3,
		m = 10*n,
		i,j,k;
   float 	a;
   vector       x = vec (n,"0 1 2"),
                y = vec (n,"-3 -1 5"), 
                w = vec (n,"1 1 1");
   matrix       A = mat (3,n,""),
   		X = mat (4,m,""),
   		Y = mat (4,m,"");

   printf ("\nExample 4.5.3: Constant, Linear, and Quadratic Fits\n");
   showvec ("x",x,n,0);
   showvec ("y",y,n,0);
   showvec ("w",w,n,0);
   polyfit (0,x,y,w,A,n,n-1,1);
   for (i = 1; i <= m; i++)
   {
      a = x[1] + (i-1)*(x[n] - x[1])/(m-1);
      for (j = 1; j <= n; j++)
      {
         X[j][i] = a;
         Y[j][i] = polyfit (a,x,y,w,A,n,j-1,0);
         k = MIN (i,n);
      }   
      X[n+1][i] = x[k];
      Y[n+1][i] = y[k];
   }
   graphmm (X,Y,n+1,m,"Constant, Linear, and Quadratic Fits",
            "x","y","fig453",1);
   addlabel (0.7,0.60,"0","fig453");
   addlabel (0.7,-.50,"1","fig453");
   addlabel (0.7,-2.30,"2","fig453");
   wait();         
   return 0;
 }
/* -------------------------------------------------------------- */



