/* -------------------------------------------------------------- */
/* Example 4.5.4: Least Squares Fit with Noise                    */
/* -------------------------------------------------------------- */
#include "c:\nlib\util.h"
int main (void)
{
   int          n = 100,
		m = 3,
		i;
   float 	noise = 0.5,
		a;
		
   vector       x = vec (n,""),
                y = randvec (n,-noise,noise),
                w = vec (n,"");
   matrix       A = mat (3,m+1,""),
                X = mat (2,n,""),
                Y = mat (2,n,"");

/* Initialize arrays */

   printf ("\nExample 4.5.4: Least-Squares Fit with Noise\n");
   for (i = 1; i <= n; i++)
   {
      a = 3.2*(i-1)/(n-1);
      w[i] = 1; 	
      x[i] = a;
      y[i] += a*(a-1)*(a-3);
      X[2][i] = a;
      Y[2][i] = y[i];
   }
   polyfit (0,x,y,w,A,n,m,1); 
   showmat ("Coefficients",A,3,m+1,0);
      
/* Find least-squares fit */
   
   for (i = 1; i <= n; i++)
   {
      X[1][i] = x[i];
      Y[1][i] = polyfit (X[2][i],x,y,w,A,n,m,0);
   }
   graphmm (X,Y,2,n,"Least Squares Fit with Noise",
            "x","y","fig454",1);
   wait();         
   return 0;
 }
/* -------------------------------------------------------------- */



