/* -------------------------------------------------------------- */
/* Example 4.6.1: Two-Dimensional Bilinear Interpolation          */
/* -------------------------------------------------------------- */
#include "c:\nlib\util.h"

float f(float x,float y)
{
   return 0.1/(pow(x,2) + pow(y,2) + 0.1);
}	

int main (void)
{
   int          m = 9,
		n = 9,
		m1 = 8*m,
		n1 = 8*n,
		i,j;
   float	c = 1,
		a,b,z;
   vector	x = vec (m,""),
   		y = vec (n,""),
   		x1 = vec (m1,""),
   		y1 = vec (n1,"");
   matrix	Z = mat (m,n,""),
   		Z1 = mat (m1,n1,"");

   printf ("\nExample 4.6.1: Bilinear Interpolation\n"); 
   for (i = 1; i <= m; i++)
   {
      x[i] = -c + 2*c*(i-1)/(m-1);
      for (j = 1; j <= n; j++)
      {
         y[j] = -c + 2*c*(j-1)/(n-1);
         Z[i][j] = f(x[i],y[j]);
      }
   }

   showvec ("x",x,m,0);
   showvec ("y",y,m,0);
   for (i = 1; i <= m1; i++)
   {
      x1[i] = -c + 2*c*(i-1)/(m1-1);
      for (j = 1; j <= n1; j++)
      {
         y1[j] = -c + 2*c*(j-1)/(n1-1);
         Z1[i][j] = bilin (x1[i],y1[j],x,y,Z,m,n);
      }
   }
   plotxyz (x1,y1,Z1,m1,n1,"Interpolated Surface",
            "x","y","z","fig462"); 

   for (i = 1; i <= m1; i++) 
      for (j = 1; j <= n1; j++) 
         Z1[i][j] = f(x1[i],y1[j]);
   plotxyz (x1,y1,Z1,m1,n1,"Actual Surface","x","y","z","fig463");
   wait();
   return 0;
}
/* -------------------------------------------------------------- */



