/* ------------------------------------------------------------------- */
/* Example 4.7.2: Water Resource Management */
/* ------------------------------------------------------------------- */

#include "c:\nlib\util.h"

int main (void)
{
   int          m,                      /* number of x data points */
                n,                      /* number of y data points */
                q = 40,                 /* number of x plot points */
                r = 80,                 /* number of y plot points */ 	
                i,j;
   vector       x1 = vec (q,""),
                y1 = vec (r,""),
                x,y;
   matrix       Z1 = mat (q,r,""),
                Z;
   FILE         *f = fopen ("data472.m","r");		
   
/* Get depth data from data file */

   printf ("\nExample 4.7.2: Water Resource Management\n");
   x = getvec (f,&m);
   y = getvec (f,&n);
   Z = getmat (f,&m,&n);
   showvec ("x",x,m,0);
   showvec ("y",y,n,0);
   showmat ("Z",Z,m,n,0);

/* Evaluate surface using bilinear interpolation */
   
   for (i = 1; i <= q; i++)
   {
      x1[i] = x[1] + (x[m] - x[1])*(i-1)/(q - 1); 	
      for (j = 1; j <= r; j++)
      {
         y1[j] = y[1] + (y[n] - y[1])*(j-1)/(r - 1);
         Z1[i][j] = bilin (x1[i],y1[j],x,y,Z,m,n);
      }
   }   

/* Plot surface */

   plotxyz (x1,y1,Z1,q,r,"Interpolated Pond Depth",
            "x (m)","y (m)","z (m)","fig472.m");
   wait();
   return 0;
}
/* ------------------------------------------------------------------- */


