/* -------------------------------------------------------------- */
/* Example 4.7.3: Voltage Regulator Circuit */
/* -------------------------------------------------------------- */

#include "c:\nlib\util.h"

int main (void)
{
   int          n,			/* number of data points */
                q = 200,		/* number of plot points */	
                k,j;
   
   vector       x,i,c;

   matrix       X = mat (2,q,""),
                Y = mat (2,q,"");

   FILE 	*r = fopen ("data473.m","r");             
   
/* Get data, allocate space */

   printf ("\nExample 4.7.3: Voltage Regulator Circuit\n");
   x = getvec (r,&n);
   i = getvec (r,&n);
   c = vec (n,"");

/* Find cubic spline fit */ 
   
   spline (0,x,i,c,n,1);
   showvec ("x",x,n,0);
   showvec ("i",i,n,0);
   showvec ("Spline coefficients",c,n,0);

/* Plot curve and data */
   
   for (k = 1; k <= q; k++)
   {
      j = MIN (k,n);
      X[1][k] = x[1] + (x[n] - x[1])*(k-1)/(q-1);
      Y[1][k] = spline (X[1][k],x,i,c,n,0);
      X[2][k] = x[j];
      Y[2][k] = i[j];
   }
   graphmm (X,Y,2,q,"Zener Diode Characteristic",
            "x (V)","i (mA)","fig474",1);
   wait();
   return 0; 
}
/* -------------------------------------------------------------- */


