/* ------------------------------------------------------------------ */
/* Example 4.7.4: Nonlinear Friction Model */
/* ------------------------------------------------------------------ */

#include "c:\nlib\util.h"

int main (void)
{
   int          n = 11,                 /* number of data points */
                q = 10*n,               /* number of plot points */	
                i,j;
   vector       v = vec (n,"0 .1 .2 .3 .4 .5 .6 .7 .8 .9 1."),
                F = vec (n,"32 4 6.5 9 11.5 14 16.5 19 21.5 24 26.5"), 
                c = vec (n,"");
   matrix       X = mat (2,q,""),
                Y = mat (2,q,"");
   
/* Find cubic spline fit */

   printf ("\nExample 4.7.4: Nonlinear Friction Model\n");
   spline (0,v,F,c,n,1);
   showvec ("v",v,n,0);
   showvec ("F",F,n,0);
   showvec ("Spline coefficients",c,n,0);
   
/* Plot curve and data */
   
   for (i = 1; i <= q; i++)
   {
      j = MIN (i,n);
      X[1][i] = v[1] + (v[n] - v[1])*(i-1)/(q-1);
      Y[1][i] = spline (X[1][i],v,F,c,n,0);
      X[2][i] = v[j];
      Y[2][i] = F[j];
   }
   graphmm (X,Y,2,q,"Nonlinear Friction Model",
            "v (m/s)","p (N)","fig476.m",1);
   wait();
   return 0;
}
/* ------------------------------------------------------------------ */



