/*------------------------------------------------------------------*/
/* Example 5.5.1: Muller's method */
/*------------------------------------------------------------------*/
#include "c:\nlib\util.h"

complex f(complex x)
{
   complex	u;
   u = cmul(cmul(x,x),cexp(cmul(x,cnum(-0.5,0))));
   u.x -= 1; 
   return u;
}

int main (void)
{
   int		m = 100,
		i; 
   complex      x0 = {2.0,0},
		x1 = {6.0,0},
		x2 = {10.0,0},
		x;
   float	eps = 1.e-6;
   printf ("\nExample 5.5.1: Muller's Method\n");
   i = muller (x0,x1,x2,eps,m,&x,f);
   printf ("\nx = %.7f %+.7fj",x.x,x.y);
   printf ("\n|f(x)| = %.7f",cmag(f(x)));
   printf ("\nMuller iterations = %i\n",i);
   wait();
   return 0;
}
/*------------------------------------------------------------------*/

