/*------------------------------------------------------------------*/
/* Example 5.6.1: Newton's Method                                   */
/*------------------------------------------------------------------*/
#include "c:\nlib\util.h"

void f (vector x,int n,vector y)
{
   y[1] = x[1]*x[1]*exp(-x[1]/2) - 1;
}
void g (vector x,int n,matrix J)
{
   J[1][1] = x[1]*(2 - x[1]/2)*exp(-x[1]/2);
}

int main (void)
{
   int		m = 100,
                n = 1,
		i; 
   float	eps = 1.e-6;
   vector	x = vec (n,"1"),
		y = vec (n,"");

   printf ("\nExample 5.6.1: Newton's Method\n");
   i = newton (x,eps,n,m,f,g); 
   printf ("\nx = %.7f",x[1]);
   f(x,n,y); 
   printf ("\n|f(x)| = %.7f",vecnorm(y,n));
   printf ("\nNewton iterations = %i\n",i);
   wait();
   return 0;
}
/*------------------------------------------------------------------*/


