/*------------------------------------------------------------------*/
/* Example 5.9.2: Bacterial Chemostat                               */
/*------------------------------------------------------------------*/

#include "c:\nlib\util.h"

void f (vector x,int n,vector y)
{

/* Bacterial chemostat */

   float	gamma = 5.0f,
		delta = 1.0f; 	

   y[1] = gamma*x[1]*x[2] - x[1]*(1 + x[2]);
   y[2] = -x[1]*x[2] + (delta - x[2])*(1 - x[2]);
}

float g (float x,float y)
{
/* Error surface g(x) = ||f(x)||^2 */

   float	x1[3],y1[3];
   
   x1[1] = x;
   x1[2] = y;
   f(x1,2,y1);
   return  (float) sqrt(inner (y1,y1,2));
}

int main (void)
{
   int          m = 50,			/* maximum iterations */
   		n = 2,			/* number of equations */
                i;			/* number of iterations */	

   float	eps = 1.e-6f;		/* error tolerance */
                
   vector 	x = vec (n,"1.0 0.1");	/* initial condition */
                
/* Compute and display steady-state solution */

   printf ("\nExample 5.9.2: Bacterial Chemostat\n");
   i = newton (x,eps,n,m,f,NULL);
   shownum ("Number of iterations",(float) i);
   showvec ("Steady-state solution",x,n,0);

/* Plot error surface g(x) = ||f(x)||^2 */

   plotfun (0,3,-1,1.5,
            "The Chemostat Error Surface g(x) = ||f(x)||^2",
            "x_1","x_2","g(x)",g,"fig592");
   wait();
   return 0; 
}
/*------------------------------------------------------------------*/

