/*------------------------------------------------------------------*/
/* Example 5.9.4: Suspension Cable                                  */
/*------------------------------------------------------------------*/

#include "c:\nlib\util.h"

float	L;				/* cable length (m) */

void f (vector x, int n,vector y)
{

/* Sag in suspension cable */

   float	a = 100.0f,		/* span (m) */
                q;

   q = x[1]/a;             
   y[1] = (float) (a*(1 + (8./3.)*pow(q,2) - (32./5.)*pow(q,4) +
          (256./7.)*pow(q,6)) - L);
}

int main (void)
{
   int          r = 100,		/* maximum iterations */
   		n = 1,			/* number of equations */
                i,			/* number of iterations */	
		j,k;
		
   float    	a = 100.0f,		/* cable span (m) */\
		m = 1200.0f,		/* supported mass (kg) */
		x0 = 0.0f,		/* sag lower bound (m)_ */
                x1 = a,			/* sag upper bound (m) */
                eps = 1.e-5f,		/* error tolerance */
                g = 9.78f,		/* acceleration due to gravity */
                w,			/* cable load (N/m) */
                T;			/* cable tension at supports */

   vector y = vec(n,"");
                
   vector	x = vec (n,"");		/* cable sag (m) */
                
/* Compute iterations i, cable sag x, and tension T */   

   printf ("\nExample 5.9.4: Suspension Cable\n");
   w = m*g/a;
   shownum ("Load (N/m)",w);
   for (j = 1; j <= 10; j++)
   {  
      L = a + 5*j;
      x[1] = a/2;
      i = newton (x,eps,n,r,f,NULL);
      if (j == 5) k = i;
      T = (float) ((w*a/2)*sqrt(1 + pow(a/(4*x[1]),2)));
      printf ("\n %.0f & %.2f & %.1f \\\\",L,x[1],T);
   }
   shownum ("Iterations",(float) k);
   return 0;
}
/*------------------------------------------------------------------*/


