/*------------------------------------------------------------------*/
/* Example 6.3.1: Golden section search                             */
/*------------------------------------------------------------------*/
#include "c:\nlib\util.h"

float f (vector x,int n)
{
   return -10*pow(x[1],3)*exp(-2*x[1]);
}

int main (void)
{
   int		n = 1,
   		p = 200,
   		r = 0,
   		s = 0,
		i,err;
   float	a,b,c,eps,
                mu = 0,
		h = 1,
		dx = 4;	
   vector	x = vec(n,""),
		d = vec(n,"1"),
                t = vec (p,""),
                y = vec (p,""); 

/* Find a three-point pattern */

   printf ("\nExample 6.3.1: Golden Section Search\n");
   i = bracket (h,x,d,mu,n,r,s,&a,&b,&c,&err,f,NULL,NULL);
   printf ("\n\nFunction evaluations = %i",i);
   printf ("\nThree-point pattern = (%.7f,%.7f,%.7f).",a,b,c);

/* Reduce interval of uncertainty */    

   eps = sqrt(epsilon());
   i = golden (x,d,a,c,eps,mu,n,r,s,&x[1],f,NULL,NULL);
   printf ("\nOptimal x = %.7f",x[1]);
   printf ("\nf(%g) = %.7f",x[1],f(x,n));
   printf ("\nFunction evaluations = %i",i);
   
/* Graph the function */

   for (i = 1; i <= p; i++)
   {
      t[i] = (i-1)*dx/(p-1);
      x[1] = t[i];
      y[i] = f(x,n);
   }
   graphxy (t,y,p,"Minimization of a Unimodal Function",
            "y","F(y)","fig632");
   wait();
   return 0;
 } 
/*------------------------------------------------------------------*/
   




