/*------------------------------------------------------------------*/
/* Example 6.4.1: Steepest Descent Method */
/*------------------------------------------------------------------*/

#include "c:\nlib\util.h"

float 	lambda[2] = {1,1};		/* weights */
	r[2] 	  = {3,2};		/* minimum */

float f (vector x,int n)
{
   float 	y = 0;
   int		i;
   for (i = 0; i < n; i++)
      y += lambda[i]*pow(x[i+1]-r[i],2);
   return y;
}
   
void g (vector x,int n,vector df)
{
   int		i;
   for (i = 1; i <= n; i++)
      df[i] = 2*lambda[i-1]*(x[i] - r[i-1]);
}

int main (void)
{
   int		n = 2,
   		m = 2000,
   		p = 50,
   		r = 4,
   		v = 1,
   		ev,i,j;
   float	eps = 1.e-4,
		d = 5;
   vector	x = vec(n,""),
                x1 = vec (p,"");
   matrix	Y = mat (p,p,""); 

/* Find a minimum */

   printf ("\nExample 6.4.1: Steepest Descent Method\n");
   for (i = 1; i <= r; i++)
   {
      lambda[0] = pow(10,i-1);
      zerovec (x,n);
      printf ("\n\nIterations = %i",conjgrad(x,eps,n,m,v,&ev,f,g));
      printf ("\nFunction evaluations = %i",ev);
      printf ("\nEigenvalues  = (%g,%g)",lambda[0],lambda[1]);
      printf ("\nOptimal x    = [%.7f,%.7f]",x[1],x[2]);
      printf ("\nf(x)         = %.7f",f(x,n));
      pause (""); 
   }

/* Plot the objective function */

   lambda[0] = pow(10,r-1); 
   for (i = 1; i <= p; i++) 
      x1[i] = (i-1)*d/(p-1);
   for (i = 1; i <= p; i++)
      for (j = 1; j <= p; j++)
      {
      	 x[1] = x1[i];
      	 x[2] = x1[j];
         Y[i][j] = f(x,n);
      }
   plotxyz (x1,x1,Y,p,p,
            "Objective Function with Ill-Conditioned Hessian Matrix",
            "x_1","x_2","f(x)","fig641");
   wait();
   return 0;
} 
/*------------------------------------------------------------------*/

   
   


