/*------------------------------------------------------------------*/
/* Example 6.7.1: Penalty Functions */
/*------------------------------------------------------------------*/

#include "c:\nlib\util.h"
	
int main (void)
{
   int		p = 201,
   		m = 4,
   		i,j;
   float	a = 0.5,
		b = 3.0,
		c = 3.5,	
		mu = 1;
   vector	x = vec(p,"");
   matrix	Q = mat (m,p,""); 

/* Construct Family of Penalty Functions for a <= x <= b */

   printf ("\nExample 6.7.1: Penalty Functions\n"); 
   for ( j = 1; j <= m; j++)
   {
      mu = 2*mu;
      for (i = 1; i <= p; i++)
      {
         x[i] = c*(i - 1)/(p - 1);
         Q[j][i] = mu*(pow(MIN(0,x[i]-a),2) + pow(MIN(0,b-x[i]),2));
      }
   }
   graphxm (x,Q,m,p,
            "The Penalty Term in Example 6.7.1",
            "x_1","Q(x)","fig671");
   addlabel (0.10,0.40,"1","fig671");
   addlabel (0.10,0.76,"2","fig671");
   addlabel (0.10,1.55,"4","fig671");
   addlabel (0.10,3.00,"8","fig671");
   wait();
   return 0;
}
/*------------------------------------------------------------------*/
   

