/*------------------------------------------------------------------*/
/* Example 6.7.2: Constrained Optimization                          */
/*------------------------------------------------------------------*/

#include "c:\nlib\util.h"

float	a = 1,			/* coordinates of minimum */
	b = 2,	
	c = 3;
	
float f (vector x,int n)
{
   return pow(x[1]-a,2) + pow(x[2]-b,2) + pow(x[3]-c,2);
}
   
void p (vector x,int n,int r,vector y)
{
   y[1] = x[1] + x[2] - b;
}

void  q(vector x,int n,int s,vector y)
{
   y[1] = x[2] - x[3] - c;
}

int main (void)
{
   int		n = 3,
                r = 1,
                s = 1, 
   		m = 1000,
		i,ev;
   float	eps = 1.e-4,
                mu;
   vector	x = vec(n,""),
                y = vec(2,"");

/* Unconstrained */

   printf ("\nExample 6.7.2: Constrained Minimization\n");
   mu = prompt ("Enter penalty parameter mu",0,1000,100);
   zerovec (x,n);
   i = penalty (x,eps,mu,n,0,0,m,&ev,f,NULL,NULL);
   p(x,n,r,y);
   q(x,n,r,y+r);
   printf
      ("\n none & %i & %.6f & %.6f & %.6f & %.6f & %.6f & %.6f \\\\",
       i,x[1],x[2],x[3],f(x,n),y[1],y[2]);
   printf ("\n & & & & & & & \\\\");
       
/* p(x) = 0 */

   zerovec (x,n);
   i = penalty (x,eps,mu,n,r,0,m,&ev,f,p,NULL);
   p(x,n,r,y);
   q(x,n,r,y+r);
   printf
      ("\n equality & %i & %.6f & %.6f & %.6f & %.6f & %.6f & %.6f \\\\",
        i,x[1],x[2],x[3],f(x,n),y[1],y[2]);
   printf ("\n & & & & & & & \\\\");
   
/* q(x) >= 0 */

   zerovec (x,n);
   i = penalty (x,eps,mu,n,0,s,m,&ev,f,NULL,q);
   p(x,n,r,y);
   q(x,n,r,y+r);
   printf
      ("\n inequality & %i & %.6f & %.6f & %.6f & %.6f & %.6f & %.6f \\\\",
        i,x[1],x[2],x[3],f(x,n),y[1],y[2]);
   printf ("\n & & & & & & & \\\\");

/* p(x) = 0, q(x) >= 0 */

   zerovec (x,n);
   i = penalty (x,eps,mu,n,r,s,m,&ev,f,p,q);
   p(x,n,r,y);
   q(x,n,r,y+r);
   printf
   ("\n both & %i & %.6f & %.6f & %.6f & %.6f & %.6f & %.6f \\\\",
    i,x[1],x[2],x[3],f(x,n),y[1],y[2]);
   wait();
   return 0;
}
/*------------------------------------------------------------------*/
   





