/*------------------------------------------------------------------*/
/* Example 7.2.1: Step Size Selection */
/*------------------------------------------------------------------*/

/* #define float double */
#include "c:\nlib\util.h"
float f (float x)
{
   return exp(x)/(1 + x*x);
}	
   
int main (void)
{
   float	a = 0,
                h,d,de,d2,d2e;
   int		k;

   printf ("\nExample 7.2.1: Step Size Selection\n");
   for (k = 0; k <= 9; k++)
   {
      h = pow(10,-k);	
      d  = deriv (a,h,3,0,0,f);
      de = deriv (a,h,3,0,1,f); 
      d2 = deriv2(a,h,3,0,0,f);
      d2e = deriv2(a,h,3,0,1,f); 
      printf ("%9.1e & %12.7f & %12.7f & %12.7f & %12.7f \\\\ \n",
               h,d,de,d2,d2e);
      if ((k == 3) || (k == 6))
         printf ("\\hline\n");           
   }

   printf ("\nMachine epsilon (float): %12.2e\n",epsilon());
   wait();
   return 0;
}
/*------------------------------------------------------------------*/
   

