/*------------------------------------------------------------------*/
/* Figure 7.3.1: Differentiation of Noisy Data
/*------------------------------------------------------------------*/

#include "c:\nlib\util.h"

int		q = 256;
float		h = 1;
vector		y;

float	f1 (float z)
{
   float	T = 64;
   return exp(-z/T)*sin(2*PI*z/T);
}
	
float	f2 (float x)
{
   int	k = MAX(1,MIN(q,1 + x/h));
   return y[k];
}
	
int main (void)
{
   int		n = 2,
		m = -1,
		i;
   float	dn = 0.002;
   vector       t = vec (q,""),
                noise = vec(q,""); 
   matrix       D = mat (2,q,"");

/* Construct signals */
   
   printf ("\nExample 7.3.1: Differentiation of Noisy Data\n");
   y = vec (q,"");
   randinit (0);
   for (i = 1; i <= q; i++)
   {
      t[i] = (i - 1)*h;	
      noise[i] = randg (0,dn);
      y[i] = f1(t[i]) + noise[i];
   }
   graphvec (y,q,"A Noise-Corrupted Signal","k","y","fig731");
	
/* Compute derivatives */

   for (i = 1; i <= q; i++)
   {
      D[1][i] =  deriv (i,h,n,m,0,f1);
      D[2][i] =  deriv (i,h,n,m,0,f2); 
   }
   graphxm (t,D,2,q,"Derivative of Noise-Corrupted Signal",
            "k","y''","fig732");
   wait();
   return 0;  
} 
/*------------------------------------------------------------------*/

