/*------------------------------------------------------------------*/
/* Example 7.4.1: Newton-Cotes Formulas */
/*------------------------------------------------------------------*/

#include "c:\nlib\util.h"

float	f (float x)
{
   return exp(x)/(exp(1) - 1);
}
	
int main (void)
{
   int		N = 10,
                n = 1,
		i;
   float	a = 0,
                b = 1,
                y0,y1,y2;
   printf ("\nExample 7.4.1: Newton-Cotes Formulas\n");
   for (i = 1; i <= N; i++)
   {
      n *= 2;
      y0 = midpoint (a,b,n/2,f);
      y1 = trapint (a,b,n,f);
      y2 = simpson (a,b,n,f);
      printf ("\n %10i & %12.7f & %12.7f & %12.7f \\\\",n,y0,y1,y2);
   }
   printf ("\n\nExact value = %12.7f\n",1.0);
   wait();
   return 0;
}
/*------------------------------------------------------------------*/
      
