/*------------------------------------------------------------------*/
/* Example 7.8.2: Monte Carlo Integration                           */
/*------------------------------------------------------------------*/

#include "c:\nlib\util.h"

float	f (vector x,int m)
{
   return 2*x[2]/pow(1+x[1],2);
}

int main (void)
{
  int		m = 2,
		N = 5,
		n,i;
   float	y0 = 0.5,
		y1,y2,e1,e2;
   vector	a = vec (m,""),
   		b = vec (m,"1 1");
   randinit (1000);

   printf ("\nExample 7.8.2: Monte Carlo Integration\n");
   for (i = 0; i < N; i++)
   {
      n = pow(10,i);
      y1 = monte (a,b,m,n,f);
      e1 = 100*(y1-y0)/y0;
      y2 = monte (a,b,m,n,f);
      e2 = 100*(y2-y0)/y0;
      printf ("\n %8i & %12.7f & %12.7f & %12.7f & %12.7f \\\\",
               n,y1,e1,y2,e2);
   }
   wait();
   return 0;
}
/*------------------------------------------------------------------*/

