/*------------------------------------------------------------------*/
/* Example 8.8.1: Boundary Value Problem                            */
/*------------------------------------------------------------------*/

#include "c:\nlib\util.h"

float g (float x,float y,float dy)
{
   return (sin(PI*x) - 6*y*y*dy);
}

int main (void)
{
   int          n       = 3,
                m       = 49,
                k,p;
   float        alpha   = 0,	
                beta    = 1.0,
                a       = 2.0,
                b       = -1,
                eps     = 0,
                E;
   vector       x       = vec (m+2,"");
   matrix       Y       = mat (n,m+2,"");

/* Solve boundary value problem */

   printf ("\nExample 8.8.1: Boundary Value Problem\n");
   for (k = 1; k <= n; k++) 
      bvp (alpha,beta,a,b,eps,m,k,x,Y[k],&E,g);
   showmat ("Y",Y,n,m+2,1);
   graphxm (x,Y,n,m+2,
            "Solution to a Nonlinear Boundary Value Problem",
            "x","y","fig883");
   addlabel (0.4,0.55,"1","fig883");
   addlabel (0.4,0.18,"2","fig883");
   addlabel (0.4,-0.10,"3","fig883");
   wait();
   return 0;
}
/*------------------------------------------------------------------*/
   



   
