/*------------------------------------------------------------------*/
/* Example 9.3.4: Heat Flow in a Rod                                */
/*------------------------------------------------------------------*/

#include "c:\nlib\util.h"

float	a = 1;                 		/* maximum x */

float f (float x) 			/* Initial condition */
{
   return (2*x + sin(2*PI*x));
}

float g (float t,int k) 		/* Boundary conditions */
{
   return f((k-1)*a);
}
      
int main (void)
{
   int          m = 50,                 /* t precision */		
 	        n = 39,                 /* x precision */
 	        c1 = 0,			/* boundary condition type */
 	        c2 = 0,			/* boundary condition type */
 	        i,j;
   float	T = 6.0e3,              /* maximum t */ 
                beta = 1.0e-5,          /* thermal diffusivity */
                dt,dx,gamma;	 
   vector	t = vec (m+1,""),	/* time grid values */
   		x = vec (n,"");		/* space grid values */
   matrix       u = mat (m+1,n,"");     /* solution */
 
/* Initialize */

   printf ("\nExample 9.3.4: Heat Flow in a Rod\n");
   dt = T/m;
   dx = a/(n+1);
   gamma = beta*dt/(dx*dx);
   shownum ("gamma",gamma);
   heat1 (T,a,m,n,beta,c1,c2,t,x,u,f,g);  
   plotxyz (t,x,u,m+1,n,"Heat Flow in a Thin Rod",
            "t (sec)","x (m)","u (^oC)","fig932");
   wait();
   return 0;
}
/*------------------------------------------------------------------*/
   


