/*------------------------------------------------------------------*/
/* Example 9.4.1: Heat Flow in a Plate                              */
/*------------------------------------------------------------------*/

#include "c:\nlib\util.h"

float	a = 4,                  /* maximum x */
	b = 4;			/* maximum y */ 
        
float g (float t,float x,float y) 		/* boundary value */
{
   return (exp(y)*cos(x) - exp(x)*cos(y));
}

int main (void)
{
   char		*title = "Plate Temperature: t = 10.000";	
   int          m = 20,                 /* t precision */		
 	        n = 19,                 /* x precision */
 	        p = 19,			/* y precision */
 	        i,j;
   float	T = 1.e4,		/* final time */
		beta = 1.0e-4,          /* thermal diffusivity */
                dt,dx,dy,gx,gy;	 
   vector	x = vec (n,""),		/* x grid values */
   		y = vec (p,"");		/* y grid values */
   matrix       U = mat (n,p,"");       /* solution */
 
/* Initialize */

   printf ("\nExample 9.4.1: Heat Flow in a Plate\n"); 
   T = prompt ("Enter final time",0,T,T/2);
   dt = T/m;
   dx = a/(n+1);
   dy = b/(p+1);
   gx = beta*dt/(dx*dx);
   gy = beta*dt/(dy*dy);
   shownum ("gamma_x",gx);
   shownum ("gamma_y",gy);
   printf ("\nSolving heat equation ... ");
   heat2 (T,a,b,m,n,p,beta,x,y,U,NULL,g);
   sprintf (title,"Plate Temperature (t = %.0f sec)",T);
   if (T < 2000)
      plotxyz (x,y,U,n,p,title,"x (m)","y (m)","u (^oC)","fig941");
   else
      plotxyz (x,y,U,n,p,title,"x (m)","y (m)","u (^oC)","fig942");
   wait();
   return 0;
}  
/*------------------------------------------------------------------*/

         
      


