/*------------------------------------------------------------------*/
/* Example 9.6.1: Vibrating Membrane                                */
/*------------------------------------------------------------------*/

#include "c:\nlib\util.h"

float	a = 2,                  /* maximum x */
	b = 2;			/* maximum y */ 
        
float f (float x,float y) 			/* Initial value */ 
{
   return 0.1*sin(PI*x)*sin(PI*y/2);
}

int main (void)
{
   char		*title = "Membrane Displacement: t = 10.000";
   int          m = 40,                /* t precision */		
 	        n = 39,                /* x precision */
 	        p = 39,                /* y precision */
 	        i,j;
   float	T = 1.8,		/* final time */
		beta = 0.25,            /* gain */
                dx,dy;	 
   vector	x = vec (n,""),		/* x grid values */
   		y = vec (p,"");		/* y grid values */
   matrix       U = mat (n,p,"");        /* solution */
 
/* Initialize */

   printf ("\nExample 9.6.1: Vibrating Membrane\n");
   T = prompt ("Enter final time",0,INFINITY,T);
   dx = a/(n+1);
   dy = b/(p+1);
   wave2 (T,a,b,m,n,p,beta,x,y,U,f,NULL);
   sprintf (title,"Membrane Displacement (t = %.1f sec)",T);
   if (T < .5) 
      plotxyz (x,y,U,n,p,title,"x (m)","y (m)","u (m)","fig961");
   else if (T < 1.5)
   {
      plotxyz (x,y,U,n,p,title,"x (m)","y (m)","u (m)","fig962");
      putstr0 ("axis([0 2 0 2 -0.1 0.1])","fig962.m",0);
   }   
   else  
      plotxyz (x,y,U,n,p,title,"x (m)","y (m)","u (m)","fig963");
   wait();
   return 0;
}
/*------------------------------------------------------------------*/
      
