/*--------------------------------------------------------------------*/
/* Example 9.7.1: Heated Rod                                          */
/*--------------------------------------------------------------------*/

#include "c:\nlib\util.h"

float f (float x)
{
   return (float) (30 + 10*(1 - cos(PI*x)));
}

int main (void)
{
  int           m = 49,                 /* t precision */		
                n = 40;                 /* x precision */
  float         T = 120.0f,             /* maximum t */
                a = 2.0f,               /* maximum x */ 
                beta = 0.005f,          /* thermal diffusivity */
                c1 = 1.0f,              /* Neumann constraint */
                c2 = 1.0f,              /* Neumann constraint */
                dt,dx;	 
   vector       t = vec (m+1,""),       /* t grid values */
                x = vec (n,"");         /* x grid values */
   matrix       U = mat (m+1,n,"");     /* solution */
 
/* Initialize */

   printf ("\nExample 9.7.1: Heated Rod\n");
   dt = T/m;
   dx = a/(n+1);
   shownum ("gamma",beta*dt/(dx*dx));
   heat1 (T,a,m,n,beta,c1,c2,t,x,U,f,NULL);  
   shownum ("Steady-state temperature (deg C)",U[m+1][n]);
   plotxyz (t,x,U,m+1,n,"Heat Flow along an Insulated Rod",
            "t (sec)","x (m)","u (^oC)","fig971");
   wait();
   return 0;
}
/*--------------------------------------------------------------------*/


      


