/*------------------------------------------------------------------*/
/* Example 9.7.4: Twisted Bar                                       */
/*------------------------------------------------------------------*/

#include "c:\nlib\util.h"

float        a = 3.0f,		         /* width (cm) */
             b = 5.0f; 	                 /* length (cm) */ 
		
float f (float x,float y)
{
   return -2;
}             

int main (void)
{
   int		m = 25,			/* number of x grid points */
		n = 25,			/* number or y grid points */
		q = 500,		/* maximum number of iterations */	
                r,   			/* number of iterations */
                i;
                
   float	eps = 1.e-5f,        	/* error tolerance */
		alpha;			/* relaxation parameter */
		
   vector	x = vec (m,""),		/* x axis grid points (cm) */
		y = vec (n,"");		/* y axis grid points (cm) */	

   matrix	U = mat (m,n,"");	/* electrostatic potential (V) */
    
/* Solve Poisson equation */

   printf ("\nExample 9.7.4: Twisted Bar\n");
   r = poisson (a,b,m,n,q,eps,&alpha,x,y,U,f,NULL);
   shownum ("Relaxation parameter alpha",alpha);
   shownum ("Number of iterations",(float) r);
   plotxyz (x,y,U,m,n,"Torsional Function of a Twisted Bar",
            "x (cm)","y (cm)","u (cm^2)","fig974");
   wait();
   return 0;
}
/*------------------------------------------------------------------*/

