/* -------------------------------------------------------------- */
/* Example 4.1.2: Circadian Rhythm in Body Temperature            */
/* -------------------------------------------------------------- */
#include "c:\nlib\util.h"
int main (void)
{
   char         *fname = "data412.m";	
   int          n,m,i,j,p=4;
   float	a;
   vector	x,y,c;
   matrix       X,Y;
   FILE		*f;

/* Get data */

   printf ("\nExample 4.1.2: Circadian Rhythm in Body Temperature\n");
   if ((f = fopen (fname,"r")) == NULL)
   {
      printf ("\nThe file %s does not exist.",fname);
      exit(1);
   }
   else
   {
      x = getvec (f,&n);
      showvec ("x",x,n,0);
      y = getvec (f,&n);
      showvec ("y",y,n,0);
      fclose (f);
   }

/* Perform cubic spline fit */
   
   m = 10*n; 
   c = vec (n,"");
   X = mat (2,m,"");
   Y = mat (2,m,"");
   spline (0,x,y,c,n,1);

/* Plot curve and data */    

   for (i = 1; i <= m; i++)
   {
      a = x[1] + (i-1)*(x[n] - x[1])/(m-1);
      X[1][i] = a;
      Y[1][i] = spline (a,x,y,c,n,0);
      j = MIN (i,n);
      X[2][i] = x[j];
      Y[2][i] = y[j];
   }
   graphmm (X,Y,2,m,"Daily Cycle in Body Temperature",
            "time (hr.)","temperature (deg. F)",
            "fig412",1);
   wait();
   return 0;
}
/* -------------------------------------------------------------- */


