       %-------------------------------------------------------------------
       % Example a1.10.1: Partial Differential Equations
       %-------------------------------------------------------------------

       % Initialize

       clc                 % clear command window 
       clear               % clear variables
       a = 2;              % maximum x
       b = 2;              % maximum y
       tol = 1.e-4;        % error tolerance
       m = 20;             % x precision
       n = 20;             % y precision
       q = 250;            % maximum SOR iterations 
       g = inline ('cos(pi*(x+y))','x','y');

       % Compute solution

       fprintf ('Example a1.10.1: Partial Differential Equations\n');
       [alpha,r,x,y,U] = poisson (a,b,m,n,q,tol,'',g);

       % Display results

       show ('Optimal relaxation parameter',alpha)
       show ('Number of SOR iterations',r)
       plotxyz (x,y,U,'Steady-State Temperature','x (m)','y (m)','u (^oC)')
       %-------------------------------------------------------------------

