       %----------------------------------------------------------------
       % Example a1.5.1: Curve Fitting
       %----------------------------------------------------------------

       % Initialize

       clc                       % clear command window
       clear                     % clear variables
       n = 24;                   % number of data points
       p = 10*n;                 % number of plot points
       b = 4;                    % plot range
       x = linspace (0,b,n)';
       y = sin(pi*x) ./ (1 + x.*x);

       % Compute least-squares fits

       fprintf ('Example a1.5.1: Curve Fitting\n');
       for i = 1 : 3
          m = 3*i - 1;
          a = polyfit (x,y,m);
          X(:,i) = linspace (0,b,p)';
          Y(:,i) = polyval (a,X(:,i));
       end

       % Add data points

       for j = 1 : p   
          k = min ([n,j]);
          X(j,4) = x(k);
          Y(j,4) = y(k);
       end   

       % Graph

       graphxy (X,Y,'Least Squares Polynomials','x','y','s')
       %----------------------------------------------------------------

