%----------------------------------------------------------------
% Example 10.4.1: Target detection
%----------------------------------------------------------------

% Initialize

   clc
   clear
   N = 512;
   M = 256;
   d = 200;
   alpha = 0.05;
   beta = 0.05;
   randinit (1000);

% Construct signals

   fprintf ('Example 10.4.1: Target Detection\n');
   t = [0 : N-1]';
   x = randg (N,1,0,beta); 
   y = randg (M,1,0,1);
   for i = 1 : N
      if (i > d) & (i <= d+M)
         x(i) = x(i) + alpha*y(i-d);
      end
   end
   graphxy (t,x,'Received Signal','k','x(k)') 

% Compute cross correlation

   pxy = crosscor (x,y);
   graphxy (t,pxy,'Normalized Cross Correlation','i',...
            '\rho_{xy}(i)')
%----------------------------------------------------------------



