%----------------------------------------------------------------
% Example 10.5.2: Convolution 
%----------------------------------------------------------------

% Initialize

   clc
   clear
   q = 512;
   p = 50;
   a = 1.0;
   b = q/3;
   randinit (50);

% Construct signals 

   fprintf ('Example 10.5.2: Convolution\n');
   t = [0 : q-1]';
   h = zeros (q,1);
   u = zeros (q,1);
   for i = 1 : q
      if i <= p
         h(i) = 1.0/p;
      end
      u(i) = exp(-t(i)/b)*sin(2*pi*t(i)/b) + randg(1,1,0,a);
   end

% Convolve

   y = convolve (h,u);
   graphxy (t,u,'Input','k','u(k)') 
   graphxy (t,y,'Output','k','y(k)')
%----------------------------------------------------------------


