%----------------------------------------------------------------
% Example 10.6.1: FIR filter 
%----------------------------------------------------------------

% Initialize

   clc
   clear
   q = 1024;
   p = 20;
   fs = 2000;
   fl = 200;
   fh = 600;
   fn = fs/2;
   randinit (100);

% Construct filter and compute output

   fprintf ('Example 10.6.1: FIR Filter\n');
   b = fir ('funf1061',p);
   u = randg (q,1,0,1);
   y = convolve (u,b);

% Display results

   [A,phi,f] = freqrsp (u,y,fs);
   graphxy (f(1:q/2),A(1:q/2),'Filter Magnitude Response','f (Hz)','A')
   [A,phi,f] = spectra (u,fs);
   graphxy (f(1:q/2),A(1:q/2),'White Noise Input Magnitude Spectrum',...
            'f (Hz)','A')
   [A,phi,f] = spectra (y,fs);
   graphxy (f(1:q/2),A(1:q/2),'Output Magnitude Spectrum',...
            'f (Hz)','A')
%----------------------------------------------------------------

   

   
 
