%----------------------------------------------------------------
% Example 10.7.1: Two-dimensional FFT 
%----------------------------------------------------------------

% Initialize

   clc
   clear
   m = 64;
   n = m;
   dx = 1.0/8.0;
   dy = 1.0/10.0;
   x = zeros(m,1);
   y = zeros(n,1);
   f = inline ('exp(-y)*sin(pi*x)','x','y');
   
% Construct surface

   fprintf ('Example 10.7.1: Two-Dimensional FFT\n');
   disp ('Contructing surface ... ')
   for k = 1 : m
      x(k) = (k-1)*dx;	
      for i = 1 : n;
      	 y(i) = (i-1)*dy;
         Z(k,i) = f(x(k),y(i));
      end
   end
   plotxyz (x,y,Z,'Two-Dimenional Signal','x','y','z')

% Compute FFT
   
   A = abs(dft2(Z,1));
   for k = 1 : m
      x(k) = (k-1)/(m*dx);	
      for i = 1 : n
         y(i) = (i-1)/(n*dy);
      end
   end
   plotxyz (x(1:m/2),y(1:n/2),A(1:m/2,1:n/2),'FFT of Signal',...
            'f_x','f_y','A')
%----------------------------------------------------------------
