%-----------------------------------------------------------------------
% Example 10.9.3: Band Pass Filter  
%-----------------------------------------------------------------------

% Initialize

   clc                      % clear screen
   clear                    % clear variables
   p = 25;                  % select filter order
   r = 2*p + 1;             % number of terms 
   n = 512;                 % number of samples  
   fs = 1000;               % sampling frequencies  
   x   = zeros (r,1);       % filter state 
   u   = zeros (n,1);       % unit pulse input  		
   y   = zeros (n,1);       % pulse response 	

% Find coefficients 
                
   fprintf ('Example 10.9.3: Band Pass Filter\n\n');
   b = fir ('funf1093',p);

% Compute pulse response and magnitude response 

   u(1) = 1;
   for i = 1 : n
      [x,y(i)] = arma (u(i),b,x,0,r-1);
   end
   [A,phi,f] = freqrsp (u,y,fs);
   graphxy (f(1:n/2),A(1:n/2),'Filter Magnitude Response','f (Hz)','A')
%-----------------------------------------------------------------------

