%-----------------------------------------------------------------------
% Example 2.7.3: DC Bridge Circuit 
%-----------------------------------------------------------------------

% Initialize 

   clc                  % clear screen
   clear                % clear variables
   n = 3;               % number of nodes
   E  = 12;             % applied voltage
   Gs = 1/10;           % source conductance
   GL = 1/1000;         % load conductance
   G1 = 1/220;          % bridge conductances 
   G2 = 1/330;
   G3 = 1/470;
   G4 = 1/560;
   A = zeros (n,n);
   b = zeros (n,1);

% Initialize A and b 

   fprintf ('Example 2.7.3: DC Bridge Circuit\n');
   A(1,1) = Gs + G1 + G1;
   A(1,2) = -G1;
   A(1,3) = -G2;
   A(2,1) = -G1;
   A(2,2) = G1 + G3 + GL;
   A(2,3) = -GL;
   A(3,1) = -G1;
   A(3,2) = -GL;
   A(3,3) = G2 + G4 + GL;
   b(1) = Gs*E;
   show ('A',A)
   show ('b',b)
   
% Find node voltages 

   show ('K(A)',condnum(A,0))
   v = gauss (A,b); 
   show ('v',v)
   show ('||r(v)||',residual(A,b,v))
%-----------------------------------------------------------------------

