%-----------------------------------------------------------------------
% Example 2.7.4: Mass-Spring-Damper System 
%-----------------------------------------------------------------------

   clear
   n = 4;
   m1 = 15;
   m2 = 30;
   k1 = 3.2;
   k2 = 2.4;
   b = 0.5;
   F = 1.2;
   d = 0.5;
   x = zeros (n,1);
   y = zeros (n,1);
   A = zeros (n,n);

% Initialize A and y 

   fprintf ('Example 2.7.4: Mass-Spring-Damper System\n');
   A(1,2) =  1; 
   A(2,1) = -(k1+k2)/m1;
   A(2,2) = -b/m1;
   A(2,3) = k2/m1;
   A(3,4) = 1;
   A(4,1) = k2/m2;
   A(4,3) = -k2/m2;
   y(4) = -F/m2;
   show ('A',A)
   show ('y',y)
   
% Find positions and velocities 

   show ('K(A)',condnum(A,0))
   x = gauss (A,y); 
   show ('x',x)
   show ('||r(x)||',residual(A,y,x))
%-------------- --------------------------------------------------------
