%-----------------------------------------------------------------------
% Example 3.9.1: Chemical Absorption Transients 
%-----------------------------------------------------------------------

   clear
   n = 4;               % number of stages 
   a = 0.72;            % slope 	
   K = 1.63;            % gas to liquid ratio  
   tau = 1.86;          % stage liquid residence time 
   delta = a*K;         % stripping factor 
   p = 1;               % decay percentage 	
   T = zeros (n,1);     % decay times
   lambda = zeros(n,1);	% eigenvalues 	
   A = zeros (n,n);
   
% Initialize A 

   fprintf ('Example 3.9.1: Chemical Absorption Transients\n');
   for i = 1 : n
      A(i,i) = -(1 + delta);
      if i < n
         A(i,i+1) = 1;
         A(i+1,i) = delta;
      end
   end
   show ('A',A);
   
% Find eigenvalues and decay times 


   lambda = eig (A);
   show ('lambda',lambda)
   t = abs(trace(A) - sum(lambda));
   show ('Trace check',t) 
   for i = 1 : n
      T(i) = (log(p/100))/real(lambda(i));
   end
   show ('T (sec)',T)
%-----------------------------------------------------------------------


