%-----------------------------------------------------------------------
% Example 3.9.2: Population Growth Model 
%-----------------------------------------------------------------------

% Initialize 

   clc                              % clear screen
   clear                            % clear variables
   n = 5;                           % number of stages 
   alpha = [1.1 1.5 2.2 2.7 1.3]';  % birth vector 
   beta = [0.4 0.1 0.1 0.5]';       % death vector 
   A = zeros (n,n);                 % growth coefficient matrix 
   tol = 1.e-6;                     % error tolerance   

% Compute A 

   fprintf ('Example 3.9.2: Population Growth Model\n');
   for i = 1 : n
      A(1,i) = alpha(i);
      if i < n
         A(i+1,i) = beta(i);
      end
   end
   show ('A',A)
   
% Find dominant eigenvalue and eigenvector 

   [c,x,k] = powereig (A,tol,50,1);
   show ('Power method iterations',k)
   show ('Dominant eigenvalue',c)
   show ('Dominant eigenvector',x)
%-----------------------------------------------------------------------



