%-----------------------------------------------------------------------
% Example 3.9.3: Telescope Position Control  
%-----------------------------------------------------------------------

   clear
   n = 3;                 % order of system 
   Ra = 10;               % armature resistance 
   La = 0.1;,             % armature inductance 
   kb = 0.1;,             % back emf constant 
   kt = 0.32;             % torque constant 
   b = 0.1;               % friction coefficient 
   J = 2;		           % moment of inertia 
   kc = [100 200 400];    % controller gains 
   lambda = zeros(n,1);	  % eigenvalues 	
   A = zeros(n,n);
   
% Initialize A 

   fprintf ('Example 3.9.3: Telescope Position Control\n');
   A(1,2) = 1;
   A(2,2) = -b/J;
   A(2,3) = kt/J;
   A(3,2) = -kb/La;
   A(3,3) = -Ra/La;
   show ('A',A)
   
% Find eigenvalues  

   for i = 1 : n
      A(3,1) = -kc(i)/La;
      lambda = eig(A);
      show ('gain',kc(i))
      show ('lambda',lambda)
      t = abs(trace(A) - sum(lambda));
      show ('Trace check',t)
   end
%-----------------------------------------------------------------------




