%-----------------------------------------------------------------------
% Example 4.7.3: Voltage Regulator Circuit
%-----------------------------------------------------------------------

% Initialize

   clc                  % clear screen 
   clear                % clear variables
   q = 200;             % number of plot points 	
   X = zeros (q,2);
   Y = zeros (q,2);

% Get data for diode I-V characteristic

   fprintf ('Example 4.7.3: Voltage Regulator Circuit\n');
   data473              % get data for zener diode
   show ('x',x);
   show ('i',i);
   n = length (x);

% Compute spline and graph curve with data 
   
   for k = 1 : q
      j = min ([k,n]);
      X(k,1) = x(1) + (x(n) - x(1))*(k-1)/(q-1);
      X(k,2) = x(j);
      Y(k,2) = i(j);
   end
   Y(:,1) = spline (x,i,X(:,1));
   graphxy (X,Y,'Zener Diode Characteristic','x (V)','i (mA)','s')
%-----------------------------------------------------------------------

