%----------------------------------------------------------------------
% Example 4.7.4: Nonlinear Friction Model 
%----------------------------------------------------------------------

   clear
   n = 11;		
   q = 10*n;		
   v = [0 .1 .2 .3 .4 .5 .6 .7 .8 .9 1]';
   F = [32 4 6.5 9 11.5 14 16.5 19 21.5 24 26.5]';
   X = zeros (q,2);
   Y = zeros (q,2);
   
% Display data

   fprintf ('Example 4.7.4: Nonlinear Friction Model\n'); 
   show ('v',v)
   show ('F',F)
   
% Compute curve and plot
   
   for i = 1 : q
      j = min ([i,n]);
      X(i,1) = v(1) + (v(n) - v(1))*(i-1)/(q-1);
      X(i,2) = v(j);
      Y(i,2) = F(j);
   end
   Y(:,1) = spline (v,F,X(:,1));
   graphxy (X,Y,'Nonlinear Friction Model','v (m/s)','p (N)','s')
%----------------------------------------------------------------------
