%------------------------------------------------------------------------
% Example 5.9.4: Suspension Cable 
%------------------------------------------------------------------------

% Initialize 

   clc                           % clear screen
   clear                         % clear variables
   global L a                    % used by funf594.m
   a   = 100;                    % cable span (m) 
   x0  = a/2;                    % initial guess at cable sag
   m   = 1200;                   % supported mass (kg) 
   g   = 9.78;                   % acceleration due to gravity 
   tol = 1.e-4;                  % relative error tolerance
   h   = fopen ('e594.dat','w'); 
                
% Compute cable sag x, and tension T/   

   fprintf ('Example 5.9.4: Suspension Cable\n');
   w = m*g/a;
   show ('Load (N/m)',w);
   for j = 1 : 10 
      L = a + 5*j;
      [x,i] = newton (x0,tol,100,'funf594');
      if j == 5 
         k = i;
      end
      T = (w*a/2)*sqrt(1 + (a/(4*x))^2);
      fprintf (h,'\n %.0f & %.2f & %.1f \\\\',L,x,T);
   end
   show ('Iterations',k);
   fclose (h);
%------------------------------------------------------------------------

