%------------------------------------------------------------------------
% Example 6.9.4: Container Design 
%------------------------------------------------------------------------

% Initialize

   clc
   clear
   global alpha beta
   alpha = 80;             % area of sheet (cm^2)
   beta  = 3;              % maximum height (cm) 
   n = 3;                  % number of variables 
   m = 10;                 % maximum iterations 
   tol = 1.0e-4;           % error tolerance 
   mu = 40;                % penalty parameter 
   x = [1 1 1]';           % initial guess 

% Find optimal box size 

   fprintf ('Example 6.9.4: Container Design\n');
   mu = prompt ('Enter penalty parameter mu: ',0.01,1000,100);
   disp ('Finding optimal box size ... ')
   [x,ev,i] = penalty (x,mu,tol,m,'funf694','funp694','funq694');

% Display results 

   show ('Iterations',i)
   show ('Function evaluations',ev)
   show ('Container dimensions x',x)
   show ('Container volume',-funf694(x))
   show ('||p(x)||',norm(funp694(x),inf))
%------------------------------------------------------------------------
