%-----------------------------------------------------------------------
% Example 7.9.1: Change in Enthalpy 
%-----------------------------------------------------------------------
   clc
   clear
   m = 11;        % number of data points 
   c = 0;         % central difference 
   f = 1.e5;      % conversion factor  
   vg = 1.673;    % specific volume (gas) 
   vf = 0.00104;  % specific volume (liquid) 
   dT = 10;       % temperature spacing 
   T0 = 100;      % temperature point  		
   
% Find numerical derivative, dp/dT, at T = 100 

   fprintf ('Example 7.9.1: Change in Enthalpy\n');
   show ('3-point dp/dT',deriv (T0,dT,3,c,0,'funf791'))
   show ('5-point dp/dT',deriv (T0,dT,5,c,0,'funf791'))
   show ('3-point extrapolated dp/dT',deriv (T0,dT,3,c,1,'funf791'))
   s = deriv (T0,dT,5,c,1,'funf791');
   show ('5-point extrapolated dp/dT',s)

% Find change in enthalpy 

   dh = 373.15*(vg - vf)*f*s;
   show ('Change in enthalpy (kJ/kg)',dh/1000)
%-----------------------------------------------------------------------
