%-----------------------------------------------------------------------
% Example 7.9.4: Link of Robotic Arm 
%-----------------------------------------------------------------------

% Initialize

   clc                       % clear screen 
   clear                     % clear variables
   global L r                % used by funf794.m
   L   = 0.9;                % length of link 		
   r = [0.1 0.02];           % hole radii
   n = 2;                    % dimension of integral 
   p = 10;                   % number of runs 
   q = 500;                  % number of random points 
   J = 0;                    % moment of inertia 
   a = [-r(1)  ; -r(1)];     % limits on x (m)
   b = [L-r(1) ;  r(1)];     % limits on y (m)
   randinit(1000);

% Compute moment of inertia of link use average of p runs  

   fprintf ('Example 7.9.4: Link of Robotic Arm\n\n');
   for i = 1 : p
       y = monte (a,b,q,'funf794');
       fprintf ('Run %i of %i = %g\n',i,p,y);
       J = J + y;
   end    
   J = J/p;
   show ('Moment of inertia J (kg-m^2)',J);
%-----------------------------------------------------------------------
