%-----------------------------------------------------------------------
% Example 8.9.2: Cantilever Beam 
%-----------------------------------------------------------------------

% Initialize

   clc
   clear
   global L                    
   L     = 2;         	    % length of thin beam 
   n     = 2;               % dimension of system
   m     = 100;             % number of solution points
   tol   = 1.e-6;           % error tolerance
   q     = 5000;            % maximum function evaluations
   alpha = 0;               % initial distance 
   beta  = L;               % final distance 
   x0    = [0 0]';          % initial state 
   
% Solve equations

   fprintf ('Example 8.9.2: Cantilever Beam\n');
   [z,X,e,k] = bsext (x0,alpha,beta,m,tol,q,'funf892');

% Display results

   show ('Number of scalar function evaluations',k);   
   show ('Maximum truncation error',e);
   show ('Maximum deflection (cm)',-100*X(m,1));
   graphxy (z,X(:,1),'Beam Deflection','z (m)','y (m)')
%-----------------------------------------------------------------------
