%-----------------------------------------------------------------------
% Example 8.9.4: Turbulent Flow and Chaos, Example 8.9.4 
%-----------------------------------------------------------------------

% Initialize

   clc
   clear
   n       = 3;             % system dimension 
   m       = 4000;          % solution points
   q       = 80000;         % maximum function evaluations
   t0      = 0;             % initial time 
   t1      = 30;            % final time 
   tol     = 0.5e-4;        % error bound 
   x0      = [1 0 20]';     % initial state 

% Solve system

   fprintf ('Example 8.9.4: Turbulent Flow and Chaos\n');
   [t,X,e,k] = rkf (x0,t0,t1,m,tol,q,'funf894');

% Display results

   show ('Number of scalar function evaluations',k);   
   show ('Maximum truncation error',e);
   graphxy (X(:,1),X(:,3),'Chaotic Motion',...
            'x_1','x_3')
%-----------------------------------------------------------------------

