%-------------------------------------------------------------------
% Example 9.6.1: Vibrating Membrane 
%-------------------------------------------------------------------

% Initialize

   clc
   clear
   a = 2;            % maximum x 
   b = 2;            % maximum y 
   m = 20;           % t precision 		
   n = 19;           % x precision 
   p = 19;           % y precision 
   T = 2.0;          % final time 
   beta = 0.25;      % gain 
 
% Initial value function

   f = inline ('0.1*sin(pi*x)*sin(pi*y/2)','x','y');

% Solve wave equation

   fprintf ('Example 9.6.1: Vibrating Membrane\n');
   T = prompt ('Enter final time',0,T,T);
   [x,y,U] = wave2 (T,a,b,m,n,p,beta,f,'');
   caption = sprintf ('Membrane Displacement: t = %.3f',T);
   plotxyz (x,y,U,caption,'x','y','u');
%-------------------------------------------------------------------

      
