%-----------------------------------------------------------------------
% Example 9.7.1: Heated Rod  
%-----------------------------------------------------------------------

% Initialize

   clc
   clear
   m    = 49;                 % t precision 		
   n    = 40;                 % x precision 
   T    = 120;                % maximum t 
   a    = 2;                  % maximum x  
   beta = 0.005;              % thermal diffusivity 
   c    = [1 1]';             % Neumann constraints 
   t    = zeros (m+1,1);      % t grid values 
   x    = zeros (n,1);        % x grid values 
   U    = zeros (m+1,n);      % solution 

% boundary value 

   f = inline ('30 + 10*(1 - cos(pi*x))','x');

% Compute solution
 
   fprintf ('Example 9.7.1: Heated Rod\n');
   dt = T/m;
   dx = a/(n+1);
   show ('gamma',beta*dt/(dx*dx))
   [t,x,U] = heat1 (T,a,m,n,beta,c,f,'');  
   show ('Steady-state temperature (deg C)',U(m+1,n))
   plotxyz (t,x,U,'Heated Rod','t (sec)','x (m)','u (^oC)')
%-----------------------------------------------------------------------
      


