%-----------------------------------------------------------------------
% Example 9.7.4: Twisted Bar 
%-----------------------------------------------------------------------

% Initialize 

   clc                  % clear screen
   clear                % clear variables
   a = 3;               % width (cm) 
   b = 5;               % length (cm) 
   m = 25;              % number of x grid points 
   n = 25;              % number or y grid points 
   q = 100;             % maximum number of iterations 	
   tol = 5.e-5;         % error tolerance 

% Right-hand side function

   f = inline ('-2','x','y');
    
% Solve Poisson equation 

   fprintf ('Example 9.7.4: Twisted Bar\n');
   [alpha,r,x,y,U] = poisson (a,b,m,n,q,tol,f,'');
   show ('Relaxation parameter alpha',alpha)
   show ('Number of iterations',r)
   plotxyz (x,y,U,'Twisted Bar','x (cm)','y (cm)','u (cm^2)')
%-----------------------------------------------------------------------
