%-----------------------------------------------------------------------
% Example 10.8.2: LMS method
%-----------------------------------------------------------------------

% Initialize

   clc                      % clear screen
   clear                    % clear variables
   p      = 512;
   n1     = 3;
   m1     = 3;
   n2     = 0;
   m2     = 32;
   r1     = n1 + m1 + 1;
   r2     = n2 + m2 + 1;
   mu     = 1/(m2+1);
   theta1 = [-.5 .6 -.3 1. -2. 8. -4.]'; 
   theta2 = zeros(r2,1);
   x1     = zeros(r1,1);
   x2     = zeros(r2,1);
   Y = zeros (p,2);
   t = zeros (p,1);

% Identify system  

   fprintf ('Example 10.8.2: LMS Method\n'); 
   show ('mu',mu);
   u = randu (p,1,-1,1);
   t = [0 : p-1]';
   fprintf ('\nIdentifying parameters ...\n');
   for i = 1 : p
      [x1,Y(i,1)]      = arma (u(i),theta1,x1,n1,m1);
      [theta2,x2,e(i)] = lms  (u(i),Y(i,1),x2,theta2,mu,m2);
   end
   graphxy (t,e,'Error','k','e(k)')
         
% Compare responses 
   
   x1 = zeros (r1,1);
   x2 = zeros (r2,1);
   u = randu (p,1,-1,1);
   for i = 1 : p;
      [x1,Y(i,1)] = arma (u(i),theta1,x1,n1,m1);
      [x2,Y(i,2)] = arma (u(i),theta2,x2,n2,m2);
   end
   graphxy (t(1:50),Y(1:50,:),'Responses','k','y(k)')
%----------------------------------------------------------------
   


