%----------------------------------------------------------------------
% Example 4.1.1: Variation in Gravity with Latitude  
%----------------------------------------------------------------------

% Initialize
 
   clc
   clear
   p = 4;
   data411               % Get data x,y
   n = length(x);
   m = 10*n; 
   X = zeros (m,2);
   Y = zeros (m,2);

% Perform least-squares fit of degree p 

   fprintf ('Example 4.1.1: Variation in Gravity with Latitude\n');
   show ('x',x)
   show ('y',y)
   a = polyfit (x,y,p);

% Plot curve and data     

   X(:,1) = linspace (x(1),x(n),m)';
   Y(:,1) = polyval (a,X(:,1));
   for i = 1 : m
      j = min (i,n);
      X(i,2) = x(j);
      Y(i,2) = y(j);
   end
   graphxy (X,Y,'Variation in Gravity with Latitude',...
            'latitude (deg.)','g (m/s^2)','s');
%----------------------------------------------------------------------


