%----------------------------------------------------------------------
% Example 4.4.1 Cubic Spline Fit                                   
%----------------------------------------------------------------------

% Initialize
 
   clc
   clear
   n = 9;
   m = 10*n;
   d = 4;
   x = linspace (-d,d,n)';
   y = zeros(n,1);
   X = zeros (m,2);
   Y = zeros (m,2);

% Find fit and plot

   fprintf ('Example 4.4.2: Cubic Spline Fit\n');             
   for i = 1 : n
      y(i) = 1/(1 + x(i)^2);
   end
   show ('x',x)
   show ('y',y) 
   X(:,1) = linspace (x(1),x(n),m)';
   Y(:,1) = spline (x,y,X(:,1));
   for i = 1 : m
      j = min (i,n);
      X(i,2) = x(j);
      Y(i,2) = y(j);
   end
   graphxy (X,Y,'Cubic Spline Fit','x','y','s')
%----------------------------------------------------------------------



