%----------------------------------------------------------------------
% Example 4.6.1: Two-Dimensional Bilinear Interpolation          
%----------------------------------------------------------------------

% Initialize
 
   clc
   clear
   m = 9;
   n = 9;
   m1 = 8*m;
   n1 = 8*n;
   c = 1;
   x  = linspace (-c,c,m)';
   y  = linspace (-c,c,n)';
   x1 = linspace (-c,c,m1)';
   y1 = linspace (-c,c,n1)';
   Z  = zeros (m,n);
   Z1 = zeros (m1,n1);
   fun461 = inline ('0.1/(x^2 + y^2 + 0.1)','x','y');

% Cumpute surface at grid points

   fprintf ('Example 4.6.1: Bilinear Interpolation\n'); 
   for i = 1 : m
      for j = 1 : n
         Z(i,j) = fun461(x(i),y(j));
      end
   end

% Intepolated surface

   Z1 = bilin(x,y,Z,x1,y1);
   plotxyz (x1,y1,Z1,'Interpolated Surface','x','y','z') 

% Actual surface

   hwbar = waitbar (0,'Evaluating Actual Surface');
   for i = 1 : m1
      waitbar (i/m1);
      for j = 1 : n1
         Z1(i,j) = fun461(x1(i),y1(j));
      end
   end
   close (hwbar);
   plotxyz (x1,y1,Z1,'Actual Surface','x','y','z')
%----------------------------------------------------------------------




