%------------------------------------------------------------------
% Example 6.5.1: Conjugate Gradient Method 
%------------------------------------------------------------------

% Initialize

   clc
   clear
   n   = 2;
   m   = 1000;
   p   = 50;
   v   = n;
   tol = 1.e-5;
   d   = 2;
   x   = zeros(n,1);
   x1  = zeros (p,1);
   x2  = zeros (p,1);
   Y   = zeros (p,p); 

% Find a minimum 

   fprintf ('Example 6.5.1: Conjugate Gradient Method\n');
   [x,ev,j] = conjgrad (x,tol,v,m,'funf651');
   fprintf ('\nIterations = %g',j);
   fprintf ('\nFunction evaluations = %g',ev);
   fprintf ('\nOptimal x    = [%.7f,%.7f]',x);
   fprintf ('\nf(x)         = %.7f\n',funf651(x));
   
% Plot the objective function 

   for i = 1 : p
      x1(i) = (i-1)*d/(p-1);
      x2(i) = (i-1)*d/(p-1);
   end
   for i = 1 : p
      for j = 1 : p
      	 x(1) = x1(i);
      	 x(2) = x2(j);
         Y(i,j) = funf651(x);
      end
   end
   plotxyz (x1,x2,Y,'','x_1','x_2','f(x)')


   

