%------------------------------------------------------------------
% Example 6.7.2: Constrained Optimization                          
%------------------------------------------------------------------
   clc
   clear
   global a b c
   a = 1;			% coordinates of minimum 
   b = 2;	
   c = 3;
   n = 3;
   m = 1000;
   tol = 1.e-4;

% Unconstrained 

   fprintf ('Example 6.7.2: Constrained Minimization\n');
   mu = prompt ('Enter penalty parameter mu',0,1000,100);
   x = zeros(n,1);
   [x,ev,i] = penalty (x,mu,tol,m,'funf672','','');
   fprintf ('\nconstraint   k     x(1)     x(2)     x(3)');
   fprintf ('     f(x)     p(x)     q(x)')
   fprintf ('\n-----------------------------------------');
   fprintf ('----------------------------');  
   fprintf... 
      ('\n   none   %4g  %8.5f %8.5f %8.5f %8.5f %8.5f %8.5f',...
       i,x,funf672(x),funp672(x),funq672(x));
       
% p(x) = 0 

   x = zeros (n,1);
   [x,ev,i] = penalty (x,mu,tol,m,'funf672','funp672','');
   fprintf...
      ('\n equality   %2g  %8.5f %8.5f %8.5f %8.5f %8.5f %8.5f',...
       i,x,funf672(x),funp672(x),funq672(x));
   
% q(x) >= 0 

   x = zeros (n,1);
   [x,ev,i] = penalty (x,mu,tol,m,'funf672','','funq672');
   fprintf...
      ('\ninequality  %2g  %8.5f %8.5f %8.5f %8.5f %8.5f %8.5f',...
       i,x,funf672(x),funp672(x),funq672(x));

% p(x) = 0, q(x) >= 0 

   x = zeros (n,1);
   [x,ev,i] = penalty (x,mu,tol,m,'funf672','funp672','funq672');
   fprintf...
      ('\n   both   %4g  %8.5f %8.5f %8.5f %8.5f %8.5f %8.5f',...
       i,x,funf672(x),funp672(x),funq672(x));
   fprintf ('\n-----------------------------------------');
   fprintf ('----------------------------\n');  
   wait
%------------------------------------------------------------------
   





