%------------------------------------------------------------------
% Example 7.2.1: Step Size Selection 
%------------------------------------------------------------------
   clc
   clear 
   a = 0;
   f = inline ('exp(x)/(1 + x*x)','x');
   fprintf ('Example 7.2.1: Step Size Selection\n');
   fprintf ('\n     h          f''           fe''');
   fprintf ('          f''''          fe''''\n');
   fprintf ('-------------------------------------------------------------\n');
   for k = 0 : 9
      h = 10^(-k);	
      d  = deriv (a,h,3,0,0,f);
      de = deriv (a,h,3,0,1,f); 
      d2 = deriv2(a,h,3,0,0,f);
      d2e = deriv2(a,h,3,0,1,f); 
      fprintf ('%9.1e %12.7f %12.7f %12.7f %12.7f\n',h,d,de,d2,d2e);
   end
   fprintf ('-------------------------------------------------------------\n');
   fprintf ('\nMachine epsilon (double): %12.2e\n',eps);
   wait
%------------------------------------------------------------------

   

