%------------------------------------------------------------------
% Figure 7.3.1: Differentiation of Noisy Data
%------------------------------------------------------------------
   clc
   clear 
   global q h y
   q = 256;
   h = 1;
   y = zeros (q,1); 
   n = 2;
   m = -1;
   dn = 0.002;
   t = zeros (q,1);
   noise = randg(q,1,0,dn);
   D = zeros (q,2);
   f1 = inline ('exp(-z/64)*sin(pi*z/32)','z');
   randinit (0);

% Construct signals 
   
   fprintf ('\nExample 7.3.1: Differentiation of Noisy Data\n');
   for i = 1 : q
      t(i) = (i - 1)*h;	
      y(i) = f1(t(i)) + noise(i);
   end
   graphmat (y,'Noisy Function','k','y')
	
% Compute derivatives 

   for i = 1 : q
      D(i,1) =  deriv (i,h,n,m,0,f1);
      D(i,2) =  deriv (i,h,n,m,0,'funf731'); 
   end
   graphxy (t,D,'Derivative','k','y''')
%------------------------------------------------------------------


