%------------------------------------------------------------------
% Example 7.3.2: Differentiation of Filtered Noisy Data 
%------------------------------------------------------------------
   clc
   clear 
   global q h z
   q = 256;
   h = 1;
   z = zeros (q,1);
   p = 3;
   e = 0;
   n = 2;
   m = -1;
   dn = 0.002;
   fc = 0.5; 
   t = zeros (q,1);
   y = zeros (q,1); 
   noise = randg (q,1,0,dn);
   b = zeros (2*p+1,1);
   v = zeros (2*p+1,1);
   D = zeros (q,2);
   f1 = inline ('exp(-z/64)*sin(pi*z/32)','z');
   randinit (0);

% Construct signals 

   fprintf ('Example 7.3.2: Differentiation of Filtered Noisy Data\n');
   for i = 1 : q
      t(i) = (i - 1)*h;	
      y(i) = f1(t(i)) + noise(i);
   end

% Filter the signal 

   b = fir ('fung732',p);
   show ('filter coefficients',b)
   for i = 1 : q
      [v,z(i)] = arma (y(i),b,v,0,2*p);
   end
   
% Compute derivatives 

   for i = 1 : q
      D(i,1) = deriv  (i,h,n,m,e,f1);
      D(i,2) = deriv  (i,h,n,m,e,'funf732');
   end
   graphxy (t,D,'Derivative','k','z''')
%------------------------------------------------------------------

   


