%------------------------------------------------------------------
% Example 7.4.1: Newton-Cotes Formulas 
%------------------------------------------------------------------
   clc
   clear 
   f = inline ('exp(x)/(exp(1) - 1)','x');
   N = 10;
   n = 1;
   a = 0;
   b = 1;
   fprintf ('Example 7.4.1: Newton-Cotes Formulas\n');
   fprintf ('\n   n     midpoint    trapezoid     simpson\n');
   fprintf ('-------------------------------------------\n');    
   for i = 1 : N
      n  = 2*n;
      y0 = midpoint (a,b,n/2,f);
      y1 = trapint  (a,b,n,f);
      y2 = simpson  (a,b,n,f);
      fprintf ('%4i %12.7f %12.7f %12.7f\n',n,y0,y1,y2);
   end
   fprintf ('-------------------------------------------\n');    
   fprintf ('\nExact value = %12.7f\n',1.0);
   wait   
