%------------------------------------------------------------------
% Example 7.8.2: Monte Carlo Integration                           
%------------------------------------------------------------------
   clc
   clear
   m = 2;
   N = 4;
   y0 = 0.5;
   a = zeros (m,1);
   b = ones (m,1);
   f = inline ('2*x(2)/((1 + x(1))^2)','x');
   randinit (2000);
   fprintf ('\nExample 7.8.2: Monte Carlo Integration\n');
   fprintf ('\n   n      I(D)        |e|         I(D)        |e|\n');
   fprintf ('----------------------------------------------------\n'); 
   for i = 0 : N-1
      n = 10^i;
      y1 = monte (a,b,n,f);
      e1 = 100*(y1-y0)/y0;
      y2 = monte (a,b,n,f);
      e2 = 100*(y2-y0)/y0;
      fprintf ('%4i %11.7f %11.7f %11.7f %11.7f\n',n,y1,e1,y2,e2);
   end
   fprintf ('----------------------------------------------------\n'); 
   wait
%------------------------------------------------------------------


