%------------------------------------------------------------------
% Example 8.4.1: Runge-Kutta-Fehhberg Method 
%------------------------------------------------------------------
   clc
   clear
   n = 2;
   p = 3;
   m = 100;
   alpha = 0;
   beta = 16;
   q = 5000;
   x0 = [0.5 0.5]';
   t = linspace (alpha,beta,m)';
   x = zeros (n,1);
   Y = zeros (m,p);
   h = beta - alpha;

% Solve the system using different error bounds 

   fprintf ('Example 8.4.1: Runge-Kutta-Fehlberg Method\n');
   for j = 1 : p
      tol = 10^(-(3+j));
      x = x0;
      for k = 1 : m-1
         [x,h,e,r] = rkf0 (x,t(k),t(k+1),h,tol,q,'funf832');
         Y(k,j) = h;
      end
   end
        
% Display results 

   graphxy (t(1:m-1),Y(1:m-1,:),'Step Sizes','t','h')
%------------------------------------------------------------------

   
