%-------------------------------------------------------------------
% Example 9.2.2: Steady State Temperature 
%-------------------------------------------------------------------

% Initialize

   clc
   clear
   m = 29;                 % x precision 		
   n = 29;                 % y precision 
   q = 500;                % maximum iterations 
   a = 4;                  % maximum x 
   b = 4;                  % maximim y  
   tol = 1.e-4;		   % error bound  
   x = zeros (m,1);		
   y = zeros (n,1);
   U = zeros (m,n);
   g = inline ('exp(y)*cos(x) - exp(x)*cos(y)','x','y');

% Find solution

   fprintf ('Example 9.2.2: Steady State Temperature\n');
   [alpha,r,x,y,U] = poisson (a,b,m,n,q,tol,'',g);
   show ('Number of iterations',r)
   show ('Optimal relaxation parameter',alpha)
   du = 0;
   for i = 1 : m
      for j = 1 : n
         du = max(du,abs(U(i,j) - g(x(i),y(j))));
      end
   end
   show ('maximum error',du)
   plotxyz (x,y,U,'Steady-State Temperature','x','y','u')
%-------------------------------------------------------------------


   


