function y = funf591 (v) 
%------------------------------------------------------------------------
% Redlich-Kwong equation of state 
%------------------------------------------------------------------------
   R = 0.08314;         % universal gas constant (bar-m^3/kmol-K) 
   T = 393.15;          % tempurature (K) 
   a = 182.23;          % bar-m^6K^.5/kmol^2 
   b = 0.06242;         % m^3/kmol 
   p = 30.0;
   y = p - (R*T/(v - b) - a/(v*(v + b)*sqrt(T)));
%------------------------------------------------------------------------

