function dx = funf891 (t,x)
%-----------------------------------------------------------------------
% Description: Stirred tank reactor, Example 8.9.1 
%-----------------------------------------------------------------------
   q     = 10;        % flow rate (m^3/min) 
   V     = 2;         % mixture volume (m^3) 
   alpha = 2.6;       % reaction rate (moles/min) 
   u1    = 3.2;       % feed concentration 1 (moles/m^3) 
   u2    = 4.8;       % feed concentration 2 (moles/m^3) 

   b  = q/V;
   dx = [ b*(u1 - x(1)) - alpha*x(1)*x(2);
          b*(u2 - x(2)) - alpha*x(1)*x(2);
         -b*x(3) + alpha*x(1)*x(2) ];
