function r = quadroot (a,b,c)
%------------------------------------------------------------------------
% Usage:       r = quadroot(a,b,c);
%
% Description: Find the roots of ax^2 + bx + c.
%              Return in the vector r.
%------------------------------------------------------------------------
   if (abs(a) < eps)
      r = -c/b;
   else
      r = zeros (2,1);
      r(1) = (-b + sqrt(b*b - 4*a*c))/(2*a);
      r(2) = (-b - sqrt(b*b - 4*a*c))/(2*a);
   end
%------------------------------------------------------------------------

