function y = args (x,a,b,k,f)
%-----------------------------------------------------------------------
% Usage:       y = args (x,a,b,k,f) 
%
% Description: Check to see if a scalar calling argument is out of range
%
% Inputs:      x = scalar to be checked
%              a = minimum value of x
%              b = maximum value of x
%              k = argument number
%              f = string containing function name
%
% Outputs:     y = x saturated to the interval [a,b]
%-----------------------------------------------------------------------
if x < a
   y = a;
   fprintf ('\nArgument %i of function %s was too low.  Its value',k,f)
   fprintf ('\nwas set to %g.\n',y)
elseif x > b  
   y = b;
   fprintf ('\nArgument %i of function %s was too high.  Its value',k,f)
   fprintf ('\nwas set to %g.\n',y)
else
   y = x;
end
%-----------------------------------------------------------------------


