function x = gauss (A,b)
%----------------------------------------------------------------
% Usage:       x = gauss (A,b)
%
% Description: Solve linear algebraic system, Ax = b, using
%              Gaussian elimination. 
%
% Inputs:      A = m by n coefficient matrix 
%              b = m by 1 right-hand side vector
%
% Outputs:     x = n by 1 solution vector
%
% Note:        A must be of full rank.  If m ~= n, then the
%              minimum least-squares solution of Ax = b is
%              computed.
%----------------------------------------------------------------
   chkvec (b,2,'gauss');
   x = A\b;
%----------------------------------------------------------------

