function [p,q] = getmax (A) 
% ---------------------------------------------------------------------- 
% Usage:       [p,q] = getmax (A)
%
% Description: Find the row p and column q of the element of the
%              n by n matrix A above the diagonal whose magnitude
%              is largest.
%
% Inputs:       A = n by n matix
%
% Outputs::     p = row of maximum element above diagonal
%               q = column of maximum element above diagonal 
% ---------------------------------------------------------------------- 

   p = 1;
   q = 2;
   n = size(A,1);
   a = abs (A(p,q));
   for i = 1 : n-1
      for j = i+1 : n
         if abs(A(i,j)) > a 
            p = i;
            q = j;
            a = abs (A(p,q));
         end
      end
   end
