function graphfun (a,b,caption,xaxis,yaxis,f)
%----------------------------------------------------------------
% Usage:       graphfun (a,b,caption,xaxis,yaxis,f)
%
% Description: Graph the function f over the interval [a,b]
%
% Inputs:      a       = lower limit for independent variable 
%              b       = upper limit for independent variable 
%              caption = string containing graph title
%              xaxis   = string containing x-axis label
%              yaxis   = string containing y-axis label
%              f       = string specifying function name 
%----------------------------------------------------------------
   n = 101;
   x = [a : (b - a)/(n-1) : b]';
   for i = 1 : n
      y(i) = feval(f,x(i));
   end   
   figure
   zoom on
   box on 
   plot (real(x),real(y))
   title (caption)
   xlabel (xaxis)
   ylabel (yaxis)
   wait
%----------------------------------------------------------------

