function graphmat (Z,caption,xaxis,yaxis,zaxis)
%----------------------------------------------------------------
% Usage:       plotmat (Z,caption,xaxis,yaxis,zaxis)
%
% Description: Plot a matrix as a surface
%
% Inputs:      Z       = m by n matrix containing dependent 
%                        variables
%              caption = string containing graph title
%              xaxis   = string containing x-axis label
%              yaxis   = string containing y-axis label
%              zaxis   = string containing z-axis label
%----------------------------------------------------------------
   figure
   box off
   mesh (real(Z'))
   title (caption)
   xlabel (xaxis)
   ylabel (yaxis)
   zlabel (zaxis)
   wait
%----------------------------------------------------------------

