function plotxyz (x,y,Z,caption,xaxis,yaxis,zaxis)
%----------------------------------------------------------------
% Usage:       plotxyz (x,y,Z,caption,xaxis,yaxis,zaxis)
%
% Description: Plot a surface
%
% Inputs:      x       = m by 1 vector containing first
%                        independent variable
%              y       = n by 1 vector containing second
%                        independent variable
%              Z       = m by n matrix containing dependent
%                        variable
%              caption = string containing graph title
%              xaxis   = string containing x-axis label
%              yaxis   = string containing y-axis label
%              zaxis   = string containing z-axis label
%----------------------------------------------------------------
   chkvec (x,1,'plotxyz');
   chkvec (y,2,'plotxyx');
   figure
   box off
   mesh (real(x),real(y),real(Z'))
   title (caption)
   xlabel (xaxis)
   ylabel (yaxis)
   zlabel (zaxis)
   wait
%----------------------------------------------------------------

