function A = randg (m,n,mu,sigma)
%-----------------------------------------------------------------------
% Usage:       A = randg (m,n,mu,sigma)
%
% Description: Generate a matrix of random numbers with a
%              Gaussian distribution
%
% Inputs:      m     = number of rows of A
%              n     = number of columns of A
%              mu    = mean of random numbers
%              sigma = standard deviation of random numbers 
%         
% Outputs:     A = m by n matrix of Gaussian random numbers
%                  with mean mu and standard deviation sigma
%-----------------------------------------------------------------------
   x1 = randu (m,n,0,1);
   x2 = randu (m,n,0,1);
   A = sqrt(-2*log(x1)).*cos(2*pi*x2);
   A = sigma*(A - mu);
%-----------------------------------------------------------------------




