function r = residual (A,b,x)
%----------------------------------------------------------------
% Usage:       r = residual (A,b,x)
%
% Description: Compute the infinity norm of the residual error
%              vector r = ||b - Ax||.
%
% Inputs:      A = m by n coefficient matrix 
%              b = m by 1 right-hand side vector
%              x = n by 1 solution vector
%----------------------------------------------------------------
   chkvec (b,2,'residual');
   chkvec (x,3,'residual'); 
   r = norm (b - A*x,inf);
%----------------------------------------------------------------

