function show (s,A)
%----------------------------------------------------------------
% Usage:       show (s,A)
%
% Description: Display a matrix on the console screen
%
% Inputs:      s = string containing variable name (e.g. 'A')
%              A = matrix to be displayed
%----------------------------------------------------------------

   global fname9999
   if isempty(fname9999)
      fname9999 = 'out.m'; 
   end
   gname = 'out.lat';

% Display matrix A

   screen = 1;
   list (screen,s,A);

% Prompt for disposition of A

   c = input ('1 => Save, 2 => Append, Enter => continue: ');
   if (c >= 1) & (c <= 3)

% Try create legal variable name 

      k = 1;
      j = 1;
      while (k <= length(s)) & j
         if isletter(s(k)) | ((s(k) >= '0') & (s(k) <= '9')) | s(k) == '_'
            k = k + 1;
         else
            j = 0;
         end
      end
      v = s(1:k-1); 

% Get file name

      s = sprintf ('Enter file name in single quotes <''%s''>: ',fname9999);
      f = input(s);
      if isempty(f)
         f = fname9999; 
      end
      if f(length(f)) ~= 'm'
         f = strcat (f,'.m');
      end
      fname9999 = f;

% Save data

     if     c == 1
        putmat (A,v,f,1)
     elseif c == 2
        putmat (A,v,f,0)
     elseif c == 3
        latex (gname,v,A)
     end

  end
%----------------------------------------------------------------

