%----------------------------------------------------------------
% Usage:       browse_v
%
% Description: Create an array of strings, nlib_view, that
%              contains the names and descriptions of the 
%              examples and functions to be viewed from 
%              Chapters 1-10 and Appendix 1.
%----------------------------------------------------------------
nlib_exam = [...
'e181     Example 1.8.1   Estimating PI by Throwing Darts       '
'e182     Example 1.8.2   Monte Carlo Integration               '
'funf182    Function funf182: Integrand                         '   
'                                                               '
'e222     Example 2.2.2   Gauss-Jordan Elimination              ' 
'e223     Example 2.2.3   Singular A                            ' 
'e225     Example 2.2.5   Matrix Inverse                        '
'e231    .Example 2.3.1   Gaussian Elimination                  '
'e232     Example 2.3.2   Matrix Determinant                    '
'e241    .Example 2.4.1   LU Factorization                      '
'e242     Example 2.4.2   LU Decomposition                      '
'e251    .Example 2.5.1   Ill Conditioning                      '
'e252     Example 2.5.2   Norms                                 '
'e253     Example 2.5.3   Condition Number                      '
'e254     Example 2.5.4   Equilibration                         '
'e255     Example 2.5.5   Approximate Condition Number          '
'e261    .Example 2.6.1   Jacobi Iterative Method               '
'e262     Example 2.6.2   Gauss-Seidel Iterative Method         '
'e263     Example 2.6.3   Successive Under-Relaxation Method    '
'e264     Example 2.6.4   Successive Over-Relaxation Method     '
'e271    .Example 2.7.1   Chemical Absorption Process           '
'e272     Example 2.7.2   Planar Truss                          '
'e273     Example 2.7.3   DC Bridge Circuit                     '
'e274     Example 2.7.4   Mass-Spring-Damper System             '
'                                                               '
'e322     Example 3.2.2   Characteristic Polynomial             '
'e331    .Example 3.3.1   Power Method                          '
'e332     Example 3.3.2   Inverse Power Method                  '
'e341    .Example 3.4.1   Jacobi Method                         '
'e351    .Example 3.5.1   Householder                           '
'e361    .Example 3.6.1   QR Method                             '
'e371    .Example 3.7.1   Eigenvectors                          '
'e391    .Example 3.9.1   Chemical Absorption Transients        '
'e392     Example 3.9.2   Population Growth Model               '
'e393     Example 3.9.3   Telescope Position Control            '
'e394     Example 3.9.4   Rotating Masses and Torsional Springs '
'                                                               '
'e411     Example 4.1.1   Variation in Gravity with Latitude    '
'data411    Data data411: Gravity measurements                  '
'e412     Example 4.1.2   Circadian Rhythm in Body Temperature  '
'data412    Data data412: Temperature measurements              '
'e421    .Example 4.2.1   Piecewise-Linear Fit                  '
'e422     Example 4.2.2   Quadratic Polynomial Fit              '
'e423     Example 4.2.3   Condition Number of Vandermonde Matrix'
'e424     Example 4.2.4   Lagrange Interpolating Polynomials    '
'funf424    Function funf424: Lagrange polynomial               '   
'e441    .Example 4.4.1   Polynomial Fit                        '
'e442     Example 4.4.2   Cubic Spline Fit                      '
'e451    .Example 4.5.1   Straight-Line Fit                     '
'e453     Example 4.5.3   Constant, Linear and Quadratic Fits   '
'e454     Example 4.5.4   Least-Squares Fit with Noise          '
'e461    .Example 4.6.1   Bilinear Interpolation                '
'e471    .Example 4.7.1   Pressure-Temperature Curves           '
'e472     Example 4.7.2   Water Resource Management             '
'data472    Data data472: Pond depth measurements               '
'e473     Example 4.7.3   Voltage Regulator Circuit             '
'data473    Data data473: Zener diode measurements              '
'e474     Example 4.7.4   Nonlinear Friction Model              '
'                                                               '
'e521     Example 5.2.1   Bisection Method                      '
'funf521    Function funf521: Tunnel diode characteristic       '   
'e522     Example 5.2.2   False Position Method                 '
'e532    .Example 5.3.2   Contraction Mapping Method            '
'e533     Example 5.3.3   Aitken Extrapolation                  '
'e541    .Example 5.4.1   Secant Method                         '
'e551    .Example 5.5.1   Muller Method                         '
'e561    .Example 5.6.1   Newton Method                         '
'e571    .Example 5.7.1   Quadratic Formula                     '
'e575     Example 5.7.5   Polynomial Roots                      '
'e581    .Example 5.8.1   Newton Vector Method                  '
'funf581    Function funf581: Nonlinear algebraic system        '   
'e591    .Example 5.9.1   Propane Cylinder                      '
'funf591    Function funf591: Redlich-Kwong model               '   
'e592     Example 5.9.2   Bacterial Chemostat                   '
'funf592    Function funf592: Bacterial chemostat model         '   
'e593     Example 5.9.3   Industrial High-Temperature Oven      '
'e594     Example 5.9.4   Suspension Cable                      '
'funf594    Function funf594: Cable sag model                   '   
'                                                               '
'e631     Example 6.3.1   Golden Section Search                 '
'e641    .Example 6.4.1   Steepest Descent                      '
'funf641    Function funf641: Quadratic objective               '   
'e651    .Example 6.5.1   Conjugate Gradient                    '
'funf651    Function funf651: Fourth order objective            '   
'e661    .Example 6.6.1   Davidon-Fletcher-Powell               '
'funf661    Function funf661: Rational objective                '   
'e671    .Example 6.7.1   Penalty Functions                     '
'e672     Example 6.7.2   Constrained Minimization              '
'funf672    Function funf672: Objective function                '   
'funp672    Function funp672: Equality constraint               '   
'funq672    Function funq672: Inequality constraint             '   
'e681    .Example 6.8.1   Simulated Annealing                   '
'funf681    Function funf681: Rational trigonometric objective  '   
'e691    .Example 6.9.1   Heat Exchanger                        '
'funf691    Function funf691: Curve fit objective               '   
'fung691    Function fung691: Heat exchanger model              '   
'e692     Example 6.9.2   Transportation Planning               '
'funf692    Function funf692: Shipping cost objective           '   
'funp692    Function funp692: Shipping equality constraints     '   
'funq692    Function funq692: Shipping inequality constraints   '   
'e693     Example 6.9.3   Maximum Power Extraction              '
'funf693    Function funf693: Power extraction objective        '   
'funp693    Function funp693: Circuit equality constraint       '   
'funr693    Function funr693: Source resistance characteristic  '   
'e694     Example 6.9.4   Container Design                      '
'funf694    Function funf694: Volume objective                  '   
'funp694    Function funp694: Area equality constraint          '   
'funq694    Function funq694: Area inequality constraint        '   
'                                                               '
'e721     Example 7.2.1   Step Size Selection                   '
'e731    .Example 7.3.1   Derivative of Noisy Data              '
'funf731    Function funf731: Noise-corrupted signal            '   
'e732     Example 7.3.2   Derivative of Filtered Noisy Data     '
'funf732    Function funf732: Noise-corrupted signal            '   
'fung732    Function fung732: Filter magnitude response         '   
'e741    .Example 7.4.1   Newton-Cotes                          '
'e751    .Example 7.5.1   Romberg                               '
'e771    .Example 7.7.1   End Point Singularity                 '
'e772     Example 7.7.2   Infinite Limit of Integration         '
'e782    .Example 7.8.2   Monte Carlo Integration               '
'e791    .Example 7.9.1   Change in Enthalpy                    '
'funf791    Function funf791: Pressure-temperature curve        '   
'e792     Example 7.9.2   Dam Design                            '
'funf792    Function funf792: Volume integrand                  '   
'fung792    Function fung792: Force integrand                   '   
'data792    Data data792: Pond depth measurements               '
'e793     Example 7.9.3   RC Network                            '
'e794     Example 7.9.4   Link of Robotic Arm                   '
'funf794    Function funf794: Inertia integrand                 '   
'                                                               '
'e831     Example 8.3.1   Runge-Kutta Methods                   '
'e832     Example 8.3.2   Fourth-Order Runge-Kutta Method       '
'funf832    Function funf832: Predator-prey model               '   
'e841    .Example 8.4.1   Runge-Kutta-Fehlberg Method           '
'e851    .Example 8.5.1   Predictor-Corrector Method            '
'funf851    Function funf851: Second-order linear system        '   
'e861    .Example 8.6.1   Extrapolation Method                  '
'funf861    Function funf861: Third-order linear system         '   
'e872    .Example 8.7.2   Stiff Differential Equations          '
'e881     Example 8.8.1   Boundary Value Problem                '
'e891    .Example 8.9.1   Chemical Reactor                      '
'funf891    Function funf891: Stirred tank reactor model        '   
'e892     Example 8.9.2   Cantilever Beam                       '
'funf892    Function funf892: Beam deflection model             '   
'e893     Example 8.9.3   Phase-Locked Loop                     '
'funp893    Function funp893: PLL model                         '   
'funu893    Function funu893: Periodic input                    '   
'e894     Example 8.9.4   Turbulent Flow and Chaos              '
'funf894    Function funf894: Lorenz attractor system           '   
'                                                               '
'e922     Example 9.2.2   Steady State Temperature              '
'e934    .Example 9.3.4   Heat Flow in a Rod                    '
'funf934    Function funf934: Initial condition                 '   
'fung934    Function fung934: Boundary conditions               '   
'e941    .Example 9.4.1   Heat Flow in a Plate                  '
'e953    .Example 9.5.3   Vibrating String                      '
'funf953    Function funf953: Initial value                     '   
'fung953    Function fung953: Initial derivative                '   
'funv953    Function funv953: Exact solution                    '   
'e961    .Example 9.6.1   Vibrating Membrane                    '
'e971    .Example 9.7.1   Heated Rod                            '
'e972     Example 9.7.2   Plate Deflection                      '
'funp972    Function funp972: First forcing term                '   
'funq972    Function funq972: Second forcing term               '   
'e973     Example 9.7.3   Electrostatic Field                   '
'funf973    Function funf973: Charge distribution               '   
'e974     Example 9.7.4   Twisted Bar                           '
'                                                               '
'e1041    Example 10.4.1  Target Detection                      '
'e1052   .Example 10.5.2  Convolution                           '
'e1061   .Example 10.6.1  FIR Filter Design                     '
'funf1061   Function funf1061: Magnitude response               '
'e1071   .Example 10.7.1  Two-Dimensional FFT                   '
'e1081   .Example 10.8.1  ARMA Model                            '
'e1082    Example 10.8.2  LMS Method                            '
'e1091   .Example 10.9.1  Heat Exchanger Frequency Response     '
'e1092    Example 10.9.2  Flag Pole Motion                      '
'data1092   Data data1092: Deflection measurements              '
'e1093    Example 10.9.3  Band Pass Filter                      '
'funf1093   Function funf1093: Magnitude response               '
'e1094    Example 10.9.4  Helicopter Noise                      '
'                                                               '
'a121     Example a1.2.1  Tabular Display                       '
'a122     Example a1.2.2  Family of Curves                      '
'a123     Example a1.2.3  Surface Plot                          '
'a124     Example a1.2.4  Utility Functions                     '
'a131    .Example a1.3.1  Linear Algebraic Systems              '
'a141    .Example a1.4.1  Eigenvalues and Eigenvectors          '
'a151    .Example a1.5.1  Curve Fitting                         '
'a161    .Example a1.6.1  Root Finding                          '
'a171    .Example a1.7.1  Optimization                          '
'funa171    Function funa171: Curve fit objective               '
'a181    .Example a1.8.1  Numerical Integration                 '
'a191    .Example a1.9.1  Ordinary Differential Equations       '
'funa191    Function funa191: van der Pol oscillator            '
'a1101   .Example a1.10.1 Partial Differential Equations        '
'a1111   .Example a1.11.1 Digital Signal Processing             '
'funa1111   Function funa1111: Magnitude response               '];
