%----------------------------------------------------------------
% Usage:       browse_f
%
% Description: This creates an array of strings, nlib_fun, that
%              contains the module numbers, names, and 
%              descriptions of the functions in the NLIB toolbox. 
%----------------------------------------------------------------
nlib_fun = [...
'1  browse    : NLIB example browser                                  '
'1  show     .: display matrix in command window                      '
'1  prompt    : prompt for number in specified range                  '
'1  wait      : display message and wait for key                      '
'1  graphmat .: graph columns of matrix as family of curves           '
'1  graphfun  : graph function of one variable                        '
'1  graphxy   : graph matrix Y vs matrix X                            '
'1  plotmat  .: plot matrix Z as a surface                            '
'1  plotfun   : plot function of two variables                        '
'1  plotxyz   : plot matrix Z vs x and y                              '
'1  randinit .: initialize random number generator                    '
'1  randu     : uniformly distributed random matrix                   '
'1  randg     : Gaussian random matrix                                '
'1  norm     .: Holder norm of vector x (built-in)                    '
'1  args      : check user calling arguments                          ' 
'1  putmat    : write matrix to file                                  '
'1  nlibpath  : append NLIB to the Matlab path                        '
'1  chkvec   .: check to see if a matrix is a column vector           '
'1  chkfun    : check to see if a function returns a column vector    '
'1  list      : display matrix on screen                              '  
'1  startup   : Matlab startup file                                   '
'                                                                     '
'2  rank      : rank of matrix (built-in)                             '
'2  gauss    .: Gaussian elimination of Ax = b                        '
'2  lufac    .: LU factorization of matrix                            '
'2  lusub     : LU substitution                                       '
'2  ludec     : LU decomposition of Ax = b                            '
'2  det      .: determinant of matrix (built-in)                      '
'2  inv       : inverse of matrix (built-in)                          '         
'2  condnum   : condition number of matrix                            '
'2  residual  : norm of residual error vector                         '
'2  trifac   .: LU factorization of tridiagonal matrix                '
'2  trisub    : tridiagonal substitution                              '
'2  tridec    : decomposition of tridiagonal Ax = b                   '
'2  sr       .: successive relaxation iterative method                '  
'                                                                     '
'3  poly      : characteristic polynomial (built-in)                  '
'3  house    .: Householder transformation to upper Hessenberg form   '
'3  jacobi   .: Jacobi method for symmetric matrices                  '
'3  qr       .: orthogonal-triangular QR factorization (built-in)     '
'3  eig      .: eigenvalues and eigenvectors (built-in)               '
'3  powereig .: dominant eigenvalue and eigenvector                   '
'3  svd      .: singular value decomposition (built-in)               '
'3  trace    .: trace of matrix (built-in)                            '
'                                                                     '
'4  interp1   : piecewise-linear interpolation (built-in)             '
'4  spline   .: cubic spline interpolation (built-in)                 '
'4  polyfit  .: least-squares polynomial (built-in)                   '
'4  polyval   : polynomial evaluation (built-in)                      '
'4  polynom   : polynomial evaluation using reversed coefficients     '  
'4  bilin    .: two-dimensional bilinear interpolation                '
'                                                                     '
'5  bisect    : bisection root-finding method                         '
'5  falsepos  : false position root-finding method                    '
'5  aitken   .: contraction mapping with Aitken extrapolation         '
'5  secant   .: secant root-finding method                            '
'5  muller   .: Muller root-finding method                            '
'5  jacobian .: Jacobian matrix of partial derivatives                '
'5  newton   .: Newton method for nonlinear algebraic systems         '
'5  roots    .: polynomial roots                                      ' 
'                                                                     '
'6  bracket   : find three-point pattern                              '
'6  golden    : golden section line search                            ' 
'6  conjgrad .: conjugate gradient unconstrained minimization         '
'6  dfp      .: Davidon-Fletcher-Powell unconstrained minimization    '
'6  penalty  .: penalty function constrained minimization             '
'6  fmu       : generalized objective function                        '
'6  gradfmu   : gradient of generalized objective function            '
'6  anneal   .: simulated annealing global minimization               '
'6  funannea  : equality constraint for simulated annealing           ' 
'                                                                     '
'7  deriv     : first order numerical derivatives                     '
'7  deriv2    : second order numerical derivatives                    '
'7  trapint  .: trapezoid rule integration                            '
'7  simpson   : Simpson 1/3 rule integration                          '
'7  midpoint  : midpoint rule integration                             '
'7  romberg   : Romberg variable order integration                    '
'7  gausquad  : Gaussian guadrature integration                       ' 
'7  monte    .: Monte Carlo multidimensional integration              ' 
'                                                                     '
'8  rkfstep   : Runge-Kutta-Fehlberg fourth-fifth order step          '
'8  rkf0      : Runge-Kutta-Fehlberg variable step size method        '
'8  rkf       : Runge-Kutta-Fehlberg variable step size driver        '
'8  predcorr .: predictor-corrector multistep method                  '
'8  bsext0   .: Bulirsch-Stoer variable order extrapolation method    '
'8  bsext     : Bulirsch-Stoer variable order extrapolation driver    '
'8  stiff0   .: Semi-implicit extrapolation method for stiff systems  '
'8  stiff     : Semi-implicit extrapolation deriver for stiff systems '
'8  ftstiff   : Partial derivatives with respect to t                 '
'8  fxstiff   : Partial derivatives with respect to x                 '
'8  bvp      .: two-point boundary value problem solver               '
'                                                                     '
'9  poisson   : Poisson/Laplace equation                              '
'9  heat1    .: one-dimensional heat/diffusion equation               '
'9  heat2     : two-dimensional heat/diffusion equation               '
'9  wave1    .: one-dimensional wave equation                         '
'9  wave2     : two-dimensional wave equation                         '
'                                                                     '
'10 dft       : fast Fourier transform (FFT)                          '
'10 dft2      : two-dimensional FFT                                   '
'10 spectra  .: magnitude spectrum of a signal                        '
'10 convolve .: discrete convolution of two signals                   '
'10 crosscor .: normalized cross correlation of two signals           '
'10 fir      .: FIR digital filter design                             '
'10 freqrsp   : frequency response from input and output signals      '
'10 arma     .: auto-regressive moving average (ARMA) model           '
'10 getarma   : identify ARMA model using least squares fit           '
'10 lms      .: adaptive least-squares identification of MA model     '];


