function y = getfun (f)
%----------------------------------------------------------------
% Usage:       y = getfun (f)
%
% Description: Check to see that whether or not a given function
%              f is present as an inline function or as an
%              M-file.  
%
% Inputs:      f = string containing name of inline or M-file
%                  function, or empty string.
%
% Outputs:     y = true if f is an inline function or an M-file
%                  function.  False if f is an empty string.
%----------------------------------------------------------------
   y = isa (f,'inline');
   if ~y
      y = ~strcmp(f,'');
   end
%----------------------------------------------------------------


