function x = prompt (s,a,b,df)
%----------------------------------------------------------------
% Usage:       x = prompt (s,a,b,df)
%
% Description: Prompt the user for a number in a specified range.
%
% Inputs:      s  = prompt string
%              a  = lower limit for response
%              b  = upper limit for response (b >= a)
%              df = default response (a <= df <= b)
%
% Outputs:     x = value entered by user  
%----------------------------------------------------------------
q = sprintf ('%s (%g to %g, default: %g): ',s,a,b,df);
x = a - 1;
while ((x < a) | (x > b))
   x = input (q);
   if isempty(x)
      x = df;   
   end
end   
%----------------------------------------------------------------

