function A = randu (m,n,a,b)
%-----------------------------------------------------------------------
% Usage:       A = randu (m,n,a,b)
%
% Description: Generate a matrix with uniformly distributed 
%              random numbers
%
% Inputs:      m = number of rows of A
%              n = number of columns of A
%              a = lower limit of random numbers
%              b = upper limit of random numbers 
%         
% Outputs:     A = m by n matrix of random numbers
%                  unformly distributed over [a,b]
%-----------------------------------------------------------------------
   A = a + (b - a)*rand(m,n); 
%-----------------------------------------------------------------------


