/*------------------------------------------------------------------*/
/* File:        util.h */

/* Description: Include this file to insert the NLIB header file and
                source files. By using this include file, there is
                no need to use a compiled library.  This is more
                portable than nlib.h, but it generates larger .exe
                files (about 50 %) and it takes somewhat longer to
                compile. */
/*-------------------------------------------------------------------*/

/* NLIB header file */

#include "c:\nlib\nlib.h"

/* Core module, main-program support */

#include "c:\nlib\nlib.c"       /* NLIB core functions */
#include "c:\nlib\show.c"       /* tabular display */
#include "c:\nlib\draw.c"       /* graphical display */	

/* Application modules (Chapters 2-10) */

#include "c:\nlib\linear.c"     /* linear algebraic systems, 2 */	
#include "c:\nlib\eigen.c"      /* eigenvalues and eigenvectors */	
#include "c:\nlib\curves.c"     /* curve fitting */	
#include "c:\nlib\roots.c"      /* root finding */	
#include "c:\nlib\optim.c"      /* optimizaition */	
#include "c:\nlib\integ.c"      /* differentiation and integrition */	
#include "c:\nlib\ode.c"        /* ordinary differential equations */	
#include "c:\nlib\pde.c"        /* partial differential equations */	
#include "c:\nlib\dsp.c"        /* digital signal processing */	

