/*----------------------------------------------------------------*/
/* Description: NLIB Example Browser
/*----------------------------------------------------------------*/

#include "opengl.h"
#include "c:\nlib\util.h"
#include <conio.h>
#include <direct.h>

/* Globals */

#define WW 640             // window width
#define WH 480             // window height

   int      
        boxw = WW/9,
      	boxh = WH/24,
        mexam,
        nexam,
		mview,
		nview,
		mfig,
		nfig,
		mmod,
		nmod,
		win0,
        CDsource = 0,
        nlib_error = 0,
		CDhelp = 0; 
   
   svector
        nlib_exam,
        nlib_view,
		nlib_fig,
		nlib_mod;

   char 
	    nlibdir[81] = "c:\\nlib", 
        editor[81]  = "Write ",
		painter[81] = "Pbrush ",  
        CDdrive[11] = "e",
		compiler[4] = "vc ";

/* Prototypes */

void myInit  (void);
void display (void);
void left_menu (int id);
void mouse (int button, int state, int x, int y);
void bar (int k,char *title);
int  getitem (int x,int y);
void show_str (int x,int y,char *s);
void helpmenu (int id);

void runmenu  (int id){};
void viewmenu (int id){};
void drawmenu (int id){};
void compmenu (int id){};
void msgbox (int x,int y,char *msg);

/*-----------------------------------------------------------------*/
void myInit (void) 
/*-----------------------------------------------------------------*/
{
/* Description: Initialize the view volume and colors */

    FILE    *f;
    int     k;
    char    s[81];

/* Set Attributes */
	
    glClearColor (1,1,1,0);            /* white background */
    glClear (GL_COLOR_BUFFER_BIT);	   /* clear window */
    glColor3f (0,0,0);                 /* draw in black */
	
/* Select orthographic projection */
	    
    glMatrixMode (GL_PROJECTION);
    glLoadIdentity ();
    glOrtho (0,WW,0,WH,-1,1);
    glMatrixMode (GL_MODELVIEW);

/* Get NLIB directory from environment */

	if (getenv("NLIBDIR") != NULL)
		strcpy (nlibdir,getenv("NLIBDIR"));

/* Read in example run data */
    
	nlib_error = 0;
	strcpy (s,nlibdir);
	strcat (s,"\\browse_r.c"); 
    f = fopen (s,"r");
	if (f == NULL)
	   nlib_error = 1;
	else
	{
       nlib_exam = getsvec (f,&mexam,&nexam);
       fclose(f);
	   for (k = 1; k <= mexam; k++)
	       nlib_exam[k][nexam-3] = 0;
    }
    
/* Read in example view data */
    
	strcpy (s,nlibdir);
	strcat (s,"\\browse_v.c"); 
    f = fopen (s,"r");
	if (f == NULL)
	   nlib_error = 2;
	else
	{
       nlib_view = getsvec (f,&mview,&nview);
       fclose(f);
	   for (k = 1; k <= mview; k++)
	       nlib_view[k][nview-3] = 0;
    }

/* Read in figure data */
		
	strcpy (s,nlibdir);
	strcat (s,"\\browse_f.c"); 
	f = fopen (s,"r");
	if (f == NULL)
	   nlib_error = 3;
	else
	{
       nlib_fig = getsvec (f,&mfig,&nfig);
       fclose(f);
	   for (k = 1; k <= mfig; k++)
	       nlib_fig[k][nfig-3] = 0;
    }

/* Read in help data */

	strcpy (s,nlibdir);
	strcat (s,"\\browse_m.c"); 
	f = fopen (s,"r");
	if (f == NULL)
	   nlib_error = 4;
	else
	{
       nlib_mod = getsvec (f,&mmod,&nmod);
       fclose(f);
       for (k = 1; k <= mmod; k++)
    	   nlib_mod[k][nmod-3] = 0;
    }

/* Read in settings */

	strcpy (s,nlibdir);
	strcat (s,"\\browse_e.c"); 
	f = fopen (s,"r");
	if (f == NULL)
	   nlib_error = 5;
	else
	{
        fscanf (f,"%s",editor);
		strcat (editor," ");
		fscanf (f,"%s",CDdrive);
		fscanf (f,"%s",compiler);
		strcat (compiler," ");
		fscanf (f,"%d",&CDsource);
		fclose(f);
    }

}

/*-----------------------------------------------------------------*/
void msgbox (int x,int y,char *msg)
/*-----------------------------------------------------------------*/
{

// Draw the text msg at coordinates (x,y) */

	int    
		 i,j;

    glColor3f (0.0,0.0,1.0f);
	glRasterPos2i (x,y);
	i = 0;
	j = 0;
    while (msg[i])
    {
        if (msg[i] == '\n')
        {
			i++;
			j++;
			glRasterPos2i (x,y-13*j);
		}
		glutBitmapCharacter (GLUT_BITMAP_8_BY_13,msg[i++]);
	}
	glColor3f (1.0,1.0,1.0);
}


/*----------------------------------------------------------------*/
void run_exam (int id)
/*----------------------------------------------------------------*/
{
	char   s[81],r[81];
	int    i,j;
    FILE   *f;

/* Switch to NLIB example directory */

    strcpy (s,nlibdir);
	s[2] = 0;
	system (s);
    strcpy (s,nlibdir);
	strcat (s,"\\exam_c");
	chdir (s);

/* Select source directory */

	if (CDsource)
    {
		strcpy (s,CDdrive);
		strcat (s,":\\nlib");
	}
	else
		strcpy (s,nlibdir);
	strcat (s,"\\bin\\");
	j = strlen(s);

	i = 0;
	while (nlib_exam[id][i+1] != ' ')
	{
		s[j+i] = nlib_exam[id][i+1];
		i++;
	}
	s[j+i] = 0;

    /* Check to see if file is there */
	
    strcpy (r,s);
	strcat (r,".exe");
	f = fopen (r,"r");
	if (f == NULL)
		nlib_error = 6;
    else 
	{
		fclose(f);
		system(s);
        wait();
	}
    glClear (GL_COLOR_BUFFER_BIT);
}

/*----------------------------------------------------------------*/
void help_mod (int id)
/*----------------------------------------------------------------*/
{
	char   s[81];
	int    i,j;

	strcpy (s,editor);
    strcat (s,nlibdir);
	strcat (s,"\\");
	j = strlen(s);
	i = 0;
	while (nlib_mod[id][i+1] != ' ')
	{
		s[j+i] = nlib_mod[id][i+1];
		i++;
	}
	s[j+i] = 0;
	
	system(s);
	
    glClear (GL_COLOR_BUFFER_BIT); 
	glFlush();
	 
  }

/*----------------------------------------------------------------*/
void view_exam (int id)
/*----------------------------------------------------------------*/
{
   	char   s[81];
	int    i,j;

    strcpy (s,editor);
    strcat (s,nlibdir);
	strcat (s,"\\exam_c\\");
	j = strlen(s);
	i = 0;
	while (nlib_view[id][i+1] != ' ')
	{
		s[j+i] = nlib_view[id][i+1];
		i++;
	}
	s[j+i] = 0;
	if (nlib_view[id][1] == 'e')
    	strcat (s,".c");
	else
		strcat (s,".m");
	system(s);
	
    glClear (GL_COLOR_BUFFER_BIT); 
	glFlush();
}


/*----------------------------------------------------------------*/
void draw_fig (int id)
/*----------------------------------------------------------------*/
{
	char   s[81];
	int    i,j;

	strcpy (s,painter);
    if (CDsource)
    {
		strcat (s,CDdrive);
		strcat (s,":\\nlib");
	}
	else
		strcat (s,nlibdir);
	strcat (s,"\\figures\\");
	j = strlen(s);
	for (i = 0; i <= 9; i++)
		s[j+i] = nlib_fig[id][i+1];
	s[j+10] = 0;
	system(s);
    wait();

    glClear (GL_COLOR_BUFFER_BIT);
}

/*----------------------------------------------------------------*/
void comp_exam (int id)
/*----------------------------------------------------------------*/
{
	char   s[81];
	int    i,j;

/* Switch to NLIB exam directory */

    strcpy (s,nlibdir);
	s[2] = 0;
	system (s);
    strcpy (s,nlibdir);
	strcat (s,"\\exam_c");
	chdir (s);

/* Compile selected example */

	strcpy (s,compiler);
    strcat (s," ");
	strcat (s,nlibdir);
	strcat (s,"\\exam_c\\");
	j = strlen(s);
	i = 0;
	while (nlib_exam[id][i+1] != ' ')
	{
		s[j+i] = nlib_exam[id][i+1];
		i++;
	}
	s[j+i] = 0;
	system(s);

/* Clean up */

	strcpy (s,"del ");
	strcat (s,nlibdir);
	strcat (s,"\\exam_c\\*.obj");
	system (s);

	wait();
    glClear (GL_COLOR_BUFFER_BIT);
}


/*----------------------------------------------------------------*/
void left_menu (int id)
/*----------------------------------------------------------------*/
{
	if (id == 2)
		exit(0);
}

/*----------------------------------------------------------------*/
void helpmenu (int id)
/*----------------------------------------------------------------*/
{
	char     s[81];

	switch (id)
	{
	case 1:

		strcpy (s,editor);
	    strcat (s,nlibdir);
		strcat (s,"\\updates.txt");
		system (s);
		break;

	case 2:

		strcpy (s,editor);
		strcat (s,nlibdir);
		strcat (s,"\\vcompile.txt");
		system (s);
		break;

	case 3:

		strcpy (s,editor);
		strcat (s,nlibdir);
		strcat (s,"\\bcompile.txt");
		system (s);
		break;

	case 4:

		strcpy (s,editor);
		strcat (s,nlibdir);
		strcat (s,"\\readme.txt");
		system (s);
		break;

	}
}

/*----------------------------------------------------------------*/
void setmenu (int id)
/*----------------------------------------------------------------*/
{
	char     s[81];
	FILE     *f;

	switch (id)
	{
	    case 1:

			strcpy (editor,"Write ");
			break;

		case 2:

			strcpy (editor,"Notepad ");
			break;

		case 3:

			strcpy (editor,"Edit ");
			break;

		case 4:

			strcpy (compiler,"vc ");
			break;

		case 5:

			strcpy (compiler,"bc ");
			break;

		case 6:

			CDsource = 1 - CDsource;
			CDhelp = CDsource ? 1 : 0;
			display();
			break;

	}

/* Save configuration information in browse_e.c */

	strcpy (s,nlibdir);
	strcat (s,"\\browse_e.c"); 
	f = fopen (s,"w");
    fprintf (f,"%s\n",editor); 
	fprintf (f,"%s\n",CDdrive);
	fprintf (f,"%s\n",compiler);
    fprintf (f,"%d",CDsource); 
	fclose(f);
}

/*-----------------------------------------------------------------*/
void display (void) 
/*-----------------------------------------------------------------*/
{
    char
		   s[81];
    int    
		   x = (WW - 28*8)/2,
		   y = WH/2 + 13;

 	glClear (GL_COLOR_BUFFER_BIT);
//	glPushAttrib(GL_ALL_ATTRIB_BITS);


    bar (1,"Run");
	bar (2,"View");
	bar (3,"Draw");
    bar (4,"Compile"); 
    bar (5,"Settings");
	bar (6,"Help");
    bar (7,"Exit");

    if (nlib_error > 0)
    {
		switch(nlib_error)
        {
		    case 1:

			msgbox(x,y,"Could not open browse_r.c.\n" 
				       "Click right button to clear.");
			break;
			
		    case 2:

            msgbox(x,y,"Could not open browse_v.c\n"
				       "Click right button to clear.");
			break;

		    case 3:

            msgbox(x,y,"Could not open browse_f.c\n" 
				       "Click right button to clear.");

		    case 4:

            msgbox(x,y,"Could not open browse_m.c\n" 
				       "Click right button to clear.");

		    case 5:

            msgbox(x,y,"Could not open browse_e.c\n" 
				       "Click right button to clear.");
			break;

			case 6:

			msgbox(x-4,y,"File not found! Try Settings/Run\n"
				      "from CD. Click right button to clear."); 
		
		}
	} 

	if (CDhelp)
    {
		strcpy (s,"Please insert distribution CD in drive ");
        strcat (s,CDdrive);
		strcat (s,"\nClick right button to clear.");
		msgbox ((WW-41*8)/2,y,s); 
	}

 	glFlush();
//	glPopAttrib();
}   


/*-----------------------------------------------------------------*/
void mouse (int button, int state, int x, int y) 
/*-----------------------------------------------------------------*/
{
   if ((button == GLUT_RIGHT_BUTTON) & (state == GLUT_DOWN))
   {
	   nlib_error = 0;
	   CDhelp = 0;
	   display();
   }
}   	
   
/*-----------------------------------------------------------------*/
void bar (int k,char *title)
/*-----------------------------------------------------------------*/
{

// Draw main menu item k

	int    
		 i,j;
    double
		 lightgray = 0.7,
		 darkgray = 0.3;

// Draw button

	glColor3f (lightgray,lightgray,lightgray);
	glBegin(GL_POLYGON);
		glVertex2i((k-1)*boxw,WH);
	    glVertex2i((k-1)*boxw,WH-boxh);
		glVertex2i(k*boxw,WH-boxh);
		glVertex2i(k*boxw,WH);
    glEnd();

// Draw border

    glColor3f (darkgray,darkgray,darkgray);
	glBegin(GL_LINE_LOOP);
		glVertex2i((k-1)*boxw,WH);
	    glVertex2i((k-1)*boxw,WH-boxh);
		glVertex2i(k*boxw,WH-boxh);
		glVertex2i(k*boxw,WH);
    glEnd();

// Label button

	j = strlen(title);
    glColor3f (0.0,0.0,0.8f);
    glRasterPos2i (k*boxw-boxw/2-8*j/2,WH-boxh/2-3);
	i = 0;
    while (title[i])
		glutBitmapCharacter (GLUT_BITMAP_8_BY_13,title[i++]);
	glColor3f (1.0,1.0,1.0);
}


/*-----------------------------------------------------------------*/
int getitem (int x,int y)
/*-----------------------------------------------------------------*/
{
// Return index of main menu item if mouse is over it

   int k;
   if ((y > WH) || (y < (WH-boxh)))
	   return 0;
   else
	   k = 1 + x/boxw;
   if (k > 4)
	   k = 0;
   return k;
}
 
/*-----------------------------------------------------------------*/
int main (int argc, char** argv) {
/*-----------------------------------------------------------------*/

	char
		s[81];

    int
 	   run_menu,
	   view_menu,
	   draw_menu,
	   help_menu,
       comp_menu,
       set_menu, 

	   run_exam_menu[12],
	   view_exam_menu[12],
       draw_fig_menu[12],
	   comp_exam_menu[12],
       help_module_menu, 
	   i,j;

/* Set up display mode and window */

   glutInit (&argc, argv);
   glutInitDisplayMode (GLUT_SINGLE | GLUT_RGB);
   glutInitWindowSize (WW,WH);
   glutInitWindowPosition (0,0);
   win0 = glutCreateWindow ("                                             "
	                      "NLIB Example Browser (C)");

/* Set up world coordinates and callbacks */
   
   myInit();
   glutDisplayFunc (display);
   glutMouseFunc (mouse);

// Run examples menu
 
   for (i = 1; i <= 9; i++)
   {

	   run_exam_menu[i] = glutCreateMenu (run_exam);
	   {
		   for (j = 1; j <= mexam; j++)
			   if ((nlib_exam[j][1] == 'e') &&
				   (nlib_exam[j][2] == ('0'+i)) &&
				   (nlib_exam[j][3] != '0'))
				   glutAddMenuEntry (nlib_exam[j]+10,j);
       }
   }
   run_exam_menu[10] = glutCreateMenu (run_exam);
   for (j = 1; j <= mexam; j++)
	   if ((nlib_exam[j][2] == '1') && 
		   (nlib_exam[j][3] == '0'))
		   glutAddMenuEntry (nlib_exam[j]+10,j);

   run_exam_menu[11] = glutCreateMenu (run_exam);
   for (j = 1; j <= mexam; j++)
	   if ((nlib_exam[j][1] == 'a') && 
		   (nlib_exam[j][2] == '2'))
		   glutAddMenuEntry (nlib_exam[j]+10,j);
   
   run_menu = glutCreateMenu (runmenu);
   for (i = 1; i <= 11; i++)
   {
	   if (i <= 10)
		   sprintf (s,"Chapter %d",i);
	   else
		   sprintf (s,"Appendix 2");
	   glutAddSubMenu (s,run_exam_menu[i]);
   }

// View Examples Menu

   for (i = 1; i <= 9; i++)
   {
	   view_exam_menu[i] = glutCreateMenu (view_exam);
	   {
		   for (j = 1; j <= mview; j++)
			   if (((nlib_view[j][1] == 'e') &&
				    (nlib_view[j][2] == ('0'+i)) &&
				    (nlib_view[j][3] != '0')) ||
				   ((nlib_view[j][1] == 'd') &&
				    (nlib_view[j][5] == ('0'+i)) &&
				    (nlib_view[j][6] != '0')))
				   glutAddMenuEntry (nlib_view[j]+10,j);
       }
   }
   view_exam_menu[10] = glutCreateMenu (view_exam);
   for (j = 1; j <= mview; j++)
	   if (((nlib_view[j][2] == '1') && 
		    (nlib_view[j][3] == '0')) ||
		   ((nlib_view[j][5] == '1') &&
		    (nlib_view[j][6] == '0')))
		   glutAddMenuEntry (nlib_view[j]+10,j);

   view_exam_menu[11] = glutCreateMenu (view_exam);
   for (j = 1; j <= mview; j++)
	   if ((nlib_view[j][1] == 'a') && 
		   (nlib_view[j][2] == '2'))
		   glutAddMenuEntry (nlib_view[j]+10,j);
   
   view_menu = glutCreateMenu (viewmenu);
   for (i = 1; i <= 11; i++)
   {
	   if (i <= 10)
		   sprintf (s,"Chapter %d",i);
	   else
		   sprintf (s,"Appendix 2");
	   glutAddSubMenu (s,view_exam_menu[i]);
   }

// Draw Figures Menu

   for (i = 1; i <= 9; i++)
   {
	   draw_fig_menu[i] = glutCreateMenu (draw_fig);
	   {
		   for (j = 1; j <= mfig; j++)
			   if ((nlib_fig[j][4] == ('0'+i)) &&
				   (nlib_fig[j][5] != '0'))
				   glutAddMenuEntry (nlib_fig[j]+10,j);
       }
   }
   draw_fig_menu[10] = glutCreateMenu (draw_fig);
   for (j = 1; j <= mfig; j++)
	   if ((nlib_fig[j][4] == '1') && 
		   (nlib_fig[j][5] == '0'))
		   glutAddMenuEntry (nlib_fig[j]+10,j);

   draw_fig_menu[11] = glutCreateMenu (draw_fig);
   for (j = 1; j <= mfig; j++)
	   if ((nlib_fig[j][4] == 'a') && 
		   (nlib_fig[j][5] == '2'))
		   glutAddMenuEntry (nlib_fig[j]+10,j);
   
   draw_menu = glutCreateMenu (drawmenu);
   for (i = 1; i <= 11; i++)
   {
	   if (i <= 10)
		   sprintf (s,"Chapter %d",i);
	   else
		   sprintf (s,"Appendix 2");
	   glutAddSubMenu (s,draw_fig_menu[i]);
   }

// Help Menu

   help_module_menu = glutCreateMenu (help_mod);
   for (i = 1; i <= mmod; i++)
		glutAddMenuEntry (nlib_mod[i]+1,i);
  
   help_menu = glutCreateMenu (helpmenu);
   glutAddSubMenu ("NLIB Modules",help_module_menu);
   glutAddMenuEntry ("NLIB Updates",1);
   glutAddMenuEntry ("Visual C++ Compiler",2);
   glutAddMenuEntry ("Borland C++ Compiler",3);
   glutAddMenuEntry ("Readme.txt",4);
   
// Compile examples menu
 
   for (i = 1; i <= 9; i++)
   {

	   comp_exam_menu[i] = glutCreateMenu (comp_exam);
	   {
		   for (j = 1; j <= mexam; j++)
			   if ((nlib_exam[j][1] == 'e') &&
				   (nlib_exam[j][2] == ('0'+i)) &&
				   (nlib_exam[j][3] != '0'))
				   glutAddMenuEntry (nlib_exam[j]+10,j);
       }
   }
   comp_exam_menu[10] = glutCreateMenu (comp_exam);
   for (j = 1; j <= mexam; j++)
	   if ((nlib_exam[j][2] == '1') && 
		   (nlib_exam[j][3] == '0'))
		   glutAddMenuEntry (nlib_exam[j]+10,j);

   comp_exam_menu[11] = glutCreateMenu (comp_exam);
   for (j = 1; j <= mexam; j++)
	   if ((nlib_exam[j][1] == 'a') && 
		   (nlib_exam[j][2] == '2'))
		   glutAddMenuEntry (nlib_exam[j]+10,j);
   
   comp_menu = glutCreateMenu (compmenu);
   for (i = 1; i <= 11; i++)
   {
	   if (i <= 10)
		   sprintf (s,"Chapter %d",i);
	   else
		   sprintf (s,"Appendix 2");
	   glutAddSubMenu (s,comp_exam_menu[i]);
   }
   
// Settings Menu

   set_menu = glutCreateMenu (setmenu);
   glutAddMenuEntry ("Select Wordpad editor",1);
   glutAddMenuEntry ("Select Notepad editor",2); 
   glutAddMenuEntry ("Select Edit editor",3);
   glutAddMenuEntry ("Select Visual C++ compiler",4);
   glutAddMenuEntry ("Select Borland C++ compiler",5);
   glutAddMenuEntry ("Run from CD (on/off)",6); 
   glutAddMenuEntry ("Exit",5); 
   
// Attach submenus to main menu

   glutCreateMenu (left_menu);
   glutAddSubMenu ("Run",run_menu);
   glutAddSubMenu ("View",view_menu);
   glutAddSubMenu ("Draw",draw_menu);
   glutAddSubMenu ("Compile",comp_menu);
   glutAddSubMenu ("Settings",set_menu);
   glutAddSubMenu ("Help",help_menu);
   glutAddMenuEntry ("Exit",2);
   glutAttachMenu   (GLUT_LEFT_BUTTON);
   
/* Look for events */
   
   glutMainLoop();
   return 0;
}
/*----------------------------------------------------------------*/



 
