/* -------------------------------------------------------------------- */
/* Program:     help.c */
/* -------------------------------------------------------------------- */

/* Usage:       help NLIB
                help modname

   Description: Provide help documentation for NLIB C library or
                specified NLIB module. */

#include "c:\nlib\util.h"


/* -------------------------------------------------------------------- */
void moverel (int x,int y)
/* -------------------------------------------------------------------- */
{
   int    i;
   for (i = 0; i < y; i++)
      putchar ('\n');
   for (i = 0; i < x; i++)
      putchar (' ');
} 	

/* -------------------------------------------------------------------- */
void clrscr_(void)
/* -------------------------------------------------------------------- */
{
   moverel (0,24);
}	

/* -------------------------------------------------------------------- */
void blank (char *x,int n)
/* -------------------------------------------------------------------- */
{
   int    k;
   for (k = 0; k < n; k++)
      x[k] = ' ';
   x[n] = 0;
}   
   

/* -------------------------------------------------------------------- */
void	box (svector s,int m,int n) 
/* -------------------------------------------------------------------- */
{
/* Usage:       box (s,m,n);
 
   Description: Display an array of strings of length enclosed in a
                box centered on the screen.

   On entry:    s = m by 1 vector of strings of length n
                m = number of strings
                n = length of strings */
                
   int     k,j,n1,n2,
           x = (76 - n)/2,
           y = (22 - m)/2;
   

   clrscr_();
   fflush (stdin);   

   n1 = strlen(s[1]);
   n2 = strlen(s[1]);
   for (k = 1;k <= m; k++)
   {
       n1 = MIN(n1,strlen(s[k]));
       n2 = MAX(n2,strlen(s[k]));
   }	
   if ((n1 < n) || (n2 > n))
   {   
      printf ("\nString lengths range from %d to %d!",n1,n2);
      wait();
   }   
   
   moverel (x,0);
   putchar (NW);
   for (j = 0; j < (n+2); j++)
      putchar (HBAR);
   putchar (NE);

   for (k = 1; k <= m; k++)
   {
       moverel (x,1);
       putchar (VBAR);
       putchar (' ');
       printf ("%s",s[k]);
       putchar (' ');
       putchar (VBAR);
   }    
             
   moverel (x,1);
   putchar (SW);
   for (j = 0; j < (n+2); j++)
      putchar (HBAR);
   putchar (SE);
   moverel (x,(24-m)/2);
}

/* -------------------------------------------------------------------- */
int main (int argc,char* argv[]) {
/* -------------------------------------------------------------------- */

   char
           *nlibdir = "c:\\nlib",
           editor[81] = "Write",
           s[81],
           p[81];
           
   int
           i,n1 = 19;

   FILE
           *f;

   svector
           v = svec (2,n1,         
               "Usage: help NLIB   "
               "       help modname");
                
/* Check calling arguments */

   if ((argc <= 1) || ((argc == 2) && argv[1][0] == '?'))
   {
      box(v,2,n1);
      exit(0);
   }  

/* Get editor */

   if (getenv("NLIBDIR") != NULL)
      nlibdir = getenv("NLIBDIR");
   strcpy (s,nlibdir);
   strcat (s,"\\browse_e.c");
   f = fopen (s,"r");
   fscanf (f,"%s",editor);
   fclose (f);

/* Display selected file */

   strcpy (s,editor);
   strcat (s," ");
   strcpy (p,argv[1]);
   for (i = 0; i < strlen(p); i++)
      p[i] = tolower(p[i]);
   if      (strcmp(p,"nlib") == 0)
      strcat (p,".txt");
   else if (strstr(p,".c") == NULL)
      strcat (p,".c");
   
   strcat (s,p);
   system (s);

/* Finalize */

   clrscr_();
   return 0;
}


