/* -------------------------------------------------------------------- */
/* File:    setup.c */
/* -------------------------------------------------------------------- */

/* Description: This is the installation program for installing NLIB
                from the distribution CD.  This program uses <dos.h>
                and <conio.h> and is NOT ANSI C compatible. */

#define DEBUG 0
                
#include "c:\nlib\util.h"
#include <direct.h>
#include <dos.h>
#include <conio.h>

char     source[10]     = "e:\\nlib";
char     boot[3]        = "c:";
char	 dest[3]	= "c:";
char     nlibdir[81]    = "c:\\nlib";                          
char     matdir[81]     = "c:\\matlab";                          

int     CDsource = 0;

void signon      (void);
int  gettype     (void);
void getnlib     (void);
void getsrc      (void);
void savecfg     (void);
char copymlab    (void);
void getmlab     (void);
void upstart     (void); 
int  cpystart    (void);
void cpyfile	 (char *f1,char *f2); 
void delfile	 (char *f);
void matdone     (void);
int  matcheck    (void);
void copyc       (void);
void getboot     (void);
int  upauto      (void);
void upbat       (char *b); 
void cdone       (void);
int  ccheck      (void);
void uninstall   (void);
void deldir      (char *d);
void showstat    (void);

void showstat (void)
{
   printf ("\nsource  = %s",source);
   printf ("\nboot    = %s",boot);
   printf ("\ndest    = %s",dest);
   printf ("\nnlibdir = %s",nlibdir);
   printf ("\nmatdir  = %s",matdir);
   wait();
}	

void moverel (int x,int y)
{
   int    i;
   for (i = 0; i < y; i++)
      putchar ('\n');
   for (i = 0; i < x; i++)
      putchar (' ');
} 	

void clrscr_(void)
{
   moverel (0,24);
}	

void blank (char *x,int n)
{
   int    k;
   for (k = 0; k < n; k++)
      x[k] = ' ';
   x[n] = 0;
}   

/* -------------------------------------------------------------------- */
void	box (svector s,int m,int n) 
/* -------------------------------------------------------------------- */
{
/* Usage:       box (s,m,n);
 
   Description: Display an array of strings of length enclosed in a
                box centered on the screen.

   On entry:    s = m by 1 vector of strings of length n
                m = number of strings
                n = length of strings */
                
   int     k,j,n1,n2,
           x = (76 - n)/2,
           y = (22 - m)/2;
   

   clrscr_();
   fflush (stdin);   

   n1 = strlen(s[1]);
   n2 = strlen(s[1]);
   for (k = 1;k <= m; k++)
   {
       n1 = MIN(n1,strlen(s[k]));
       n2 = MAX(n2,strlen(s[k]));
   }	
   if ((n1 < n) || (n2 > n))
   {   
      printf ("\nString lengths range from %d to %d!",n1,n2);
      wait();
   }   
   
   moverel (x,0);
   putchar (NW);
   for (j = 0; j < (n+2); j++)
      putchar (HBAR);
   putchar (NE);

   for (k = 1; k <= m; k++)
   {
       moverel (x,1);
       putchar (VBAR);
       putchar (' ');
       printf ("%s",s[k]);
       putchar (' ');
       putchar (VBAR);
   }    
             
   moverel (x,1);
   putchar (SW);
   for (j = 0; j < (n+2); j++)
      putchar (HBAR);
   putchar (SE);
   moverel (x,(23-m)/2);
   printf ("=> ");
}

/* -------------------------------------------------------------------- */
void	signon (void) 
/* -------------------------------------------------------------------- */
{
/* Purpose: Display sign on message with version number v. */

   char
           q[81];
           
   int
           n1 = 27;

   svector
           s = svec (3,n1,
                     "NLIB Installation Utility  "
                     "       Version 1.1         "
                     "Press Enter to continue ...");  

   box (s,3,n1);
   getchar();
}

/* -------------------------------------------------------------------- */
int gettype (void) 
/* -------------------------------------------------------------------- */
{
/* Usage:       k = gettype();
  
   Description: Prompt for the type of installation

   On exit:     k = type of installation to perform:

                    1 => Install MATLAB toolbox
                    2 => Install C library
                    3 => Exit */

   int
           m = 5,
           n = 39,
           k;
                    
   svector
           s = svec (m,n,
               "1 => Install MATLAB toolbox    (0.7 MB)"
               "2 => Install C library (2.1 to 42.0 MB)"
               "3 => Exit                              "
               "                                       "
               "Please choose one of the above:        ");

   do
   {
      box (s,m,n);
      k = getchar() - '0';
   } 
   while ((k < 1) || (k > 3));
   return k;   
}

/* -------------------------------------------------------------------- */
void      getnlib (void) 
/* -------------------------------------------------------------------- */
{
/* Purpose: Prompt for the path for the NLIB directory */

   char
           q[81],
           blanks[81];
           
   int
           n1 = 56,
           n2 = 44,
           k;
           
   svector
           s = svec (5,n1,
               "Enter the complete path for the NLIB directory starting "
               "with the drive letter. The path c:\\nlib is recommended. "
               "Press Enter to select the current value.                "
               "                                                        "
               "Current value:                                          "),
           u = svec (2,n2,
               "The NLIB path must include the drive letter."
               "Press Enter to continue ...                 "); 

   strcpy (s[5]+ 15,nlibdir);
   blank(blanks,n1-strlen(s[5]));
   strcat (s[5],blanks); 
   box (s,5,n1);
   gets (q);

   
   if (strlen(q) > 0) 
      if (strstr(q,":") == NULL)
      {
         box (u,2,n2);
         getchar();
      }
      else
      {
         strncpy (nlibdir,q,80);
         strncpy (dest,nlibdir,2);
      }
}

/* -------------------------------------------------------------------- */
void getsrc (void) {
/* -------------------------------------------------------------------- */

/* Purpose: Prompt for the source drive. */

   char
          blanks[60],q[10],c;

   int
          n1 = 51,
          n2 = 33,
          n;
          
   svector
           s = svec (5,n1,
               "Enter the drive containing the NLIB distribution CD"
               "(A to Z). Press Enter to select the current value. "
               "                                                   "
               "Current value:                                     "),
           u = svec (2,n2,
               "Place distribution CD in drive  ."
               "Press Enter to continue ...      "); 

   s[4][15] = toupper(source[0]);
   s[4][16] = 0; 
   blank(blanks,n1-strlen(s[4]));
   strcat (s[4],blanks); 

   do
   {
      box (s,4,n1);
      gets(q);
      c = toupper(q[0]);
      n = strlen(q);
   }
   while (((c < 'A') || (c > 'Z')) && (n > 0));
   
   if (n > 0)
   {
      strcpy (source," :\\nlib");
      source[0] = c;
   }
   
   if (DEBUG)
      showstat();
   u[1][n2-2] = toupper(source[0]);
   box (u,2,n2);
   getchar();
}

/* -------------------------------------------------------------------- */
void savecfg (void) 
/* -------------------------------------------------------------------- */
{
/* Purpose: Save the configuration file browse_e.c

            Contents:  Line 1 => name of text editor
                       Line 2 => CD drive letter
                       Line 3 => C compiler
                       Line 4 => source number for bin and figures */
                       
   char    q[256],r[81],editor[81],compiler[10],CDdrive[10];
   FILE   *f;
   int k;

/* Read configuration file */ 
   
   strcpy (q,nlibdir);
   strcat (q,"\\browse_e.c");
   f = fopen (q,"r");
   fscanf (f,"%s",editor);
   fscanf (f,"%s",CDdrive);
   fscanf (f,"%s",compiler);
   fscanf (f,"%d",&k);
   fclose(f);

/* Write configuration file */ 
   
   f = fopen (q,"w");
   fprintf (f,"%s\n","Write");
   fprintf (f,"%c\n",source[0]);
   fprintf (f,"%s\n","vc");
   fprintf (f,"%d",CDsource);
   fclose(f);   
}   


/* -------------------------------------------------------------------- */
char copymlab (void) 
/* -------------------------------------------------------------------- */
{
/* Purpose: Copy the MATLAB files from the distribution CD. */

  char
          c,q[80];

  int
          n1 = 59;

  svector s = svec (2,n1,
          "This will copy the MATLAB toolbox from drive D to directory"
          "c:\nlib.  Is this correct (y/n)?                           ");                                   

  s[1][45] = toupper(source[0]);
  strcpy (s[2],nlibdir);
  strcat (s[2],". Is this correct (y/n)?");
  blank (q,n1-strlen(s[2]));
  strcat (s[2],q);
  box (s,2,n1);
  
  c = toupper (getchar());
  if (c == 'Y')
  {

/* Copy MATLAB toolbox files */     

     clrscr_();
     strncpy (dest,nlibdir,2);
     system (dest);          
     strcpy (q,"md ");
     strcat (q,nlibdir);
     system (q);
     strcat (q,"\\toolbox");
     system (q);
     strcpy (q,"copy ");
     strcat (q,source);
     strcat (q,"\\toolbox ");
     strcat (q,nlibdir);
     strcat (q,"\\toolbox");
     printf ("\nCopying MATLAB toolbox files to %s\\toolbox ... \n\n",
             nlibdir);
     system (q);
     
/* Copy MATLAB example files */     

     strcpy (q,"md ");
     strcat (q,nlibdir);
     strcat (q,"\\exam_mat");
     system (q);
     strcpy (q,"copy ");
     strcat (q,source);
     strcat (q,"\\exam_mat ");
     strcat (q,nlibdir);
     strcat (q,"\\exam_mat");
     printf ("\nCopying MATLAB examples to %s\\exam_mat ... \n\n",
             nlibdir);
     system (q);

/* Copy MATLAB problem files */     

     strcpy (q,"md ");
     strcat (q,nlibdir);
     strcat (q,"\\prob_mat");
     system (q);
     strcpy (q,"copy ");
     strcat (q,source);
     strcat (q,"\\prob_mat ");
     strcat (q,nlibdir);
     strcat (q,"\\prob_mat");
     printf ("\nCopying MATLAB selected problems to %s\\prob_mat ... \n\n",
             nlibdir);
     system (q);


/* Copy MATLAB user files */     

     strcpy (q,"md ");
     strcat (q,nlibdir);
     strcat (q,"\\user_mat");
     system (q);
     strcpy (q,"copy ");
     strcat (q,source);
     strcat (q,"\\user_mat ");
     strcat (q,nlibdir);
     strcat (q,"\\user_mat");
     printf ("\nCopying MATLAB user example files to %s\\prob_mat ... \n\n",
             nlibdir);
     system (q);

/* Copy data files */     

     strcpy (q,"md ");
     strcat (q,nlibdir);
     strcat (q,"\\data");
     system (q);
     strcpy (q,"copy ");
     strcat (q,source);
     strcat (q,"\\data ");
     strcat (q,nlibdir);
     strcat (q,"\\data");
     printf ("\nCopying problem data files to %s\\data ... \n\n",
             nlibdir);
     system (q);

/* Copy some root files */     

     printf ("\nCopying root files to %s\n\n",nlibdir);
     strcpy (q,"copy ");
     strcat (q,source);
     strcat (q,"\\readme.txt ");
     strcat (q,nlibdir);
     system (q);
     strcpy (q,"copy ");
     strcat (q,source);
     strcat (q,"\\user_mat.txt ");
     strcat (q,nlibdir);
     system (q);
     strcpy (q,"copy ");
     strcat (q,source);
     strcat (q,"\\setup.exe ");
     strcat (q,nlibdir);
     system (q);
   }

   else
      c = 'N';   
   return c;
}

/* -------------------------------------------------------------------- */
void      getmlab (void) 
/* -------------------------------------------------------------------- */
{
/* Purpose: Prompt for the path for the MATLAB directory */

   char
           q[60],
           blanks[60];
           
   int
           n1 = 57,
           n2 = 46,
           k;
           
   svector
           s = svec (5,n1,
               "Enter the complete path for the MATLAB directory starting"
               "with the drive letter. Press Enter to select the current "
               "value.                                                   "
               "                                                         " 
               "Current value:                                           "),
           u = svec (2,n2,
               "The MATLAB path must include the drive letter."
               "Press Enter to continue ...                   "); 

   strcpy (s[5]+ 15,matdir);
   blank(blanks,n1-strlen(s[5]));
   strcat (s[5],blanks); 
   box (s,5,n1);
   gets (q);
   
   if (strlen(q) > 0) 
      if (strstr(q,":") == NULL)
      {
         box (u,2,n2);
         getchar();
      }
      else
         strncpy (matdir,q,60);
}

/* -------------------------------------------------------------------- */
void	upstart (void) 
/* -------------------------------------------------------------------- */
{
/* Description: Update the NLIB directory lines in startup.m */

   char
            q[256],r[256],s[256],*p;

   int
            n = 256;
   FILE
            *f,*g;
 
   strcpy (q,nlibdir);
   strcpy (r,nlibdir);
   strcat (q,"\\toolbox\\startup.m");
   strcat (r,"\\toolbox\\temp.m");
   f = fopen (q,"r");
   g = fopen (r,"w");

   while (!feof(f))
   {
      fgets (s,n,f);
      if ((p = strstr(s,"path")) != NULL)
         if ((p = strstr(s,"toolbox")) != NULL)
         {
            strcpy (s,"     path(path,'");
            strcat (s,nlibdir);
            strcat (s,"\\toolbox')    % add toolbox to path\n");
         }
         else if ((p = strstr(s,"exam_mat")) != NULL)
         {
            strcpy (s,"     path(path,'");
            strcat (s,nlibdir);
            strcat (s,"\\exam_mat')   % add exam_mat to path\n");
         }
         else if ((p = strstr(s,"prob_mat")) != NULL)
         {
            strcpy (s,"     path(path,'");
            strcat (s,nlibdir);
            strcat (s,"\\prob_mat')   % add prob_mat to path\n");
         }
         else if ((p = strstr(s,"user_mat")) != NULL)
         {
            strcpy (s,"     path(path,'");
            strcat (s,nlibdir);
            strcat (s,"\\user_mat')   % add user_mat to path\n");
         }

      if ((p = strstr(s,"cd ")) != NULL)
      {
         strcpy (s,"     cd ");
         strcat (s,nlibdir);
         strcat (s,"\\user_mat             % working directory\n");
      }
      if (!feof(f))
         fputs (s,g);
   }
   fclose (f);
   fclose (g);
   cpyfile (r,q);
   delfile (r);
}

/* -------------------------------------------------------------------- */
int	cpystart (void) 
/* -------------------------------------------------------------------- */
{
/* Description: Copy the MATLAB startup.m file */

   char
            c,q[81],r[81],u[81],v[81],loc[81],blanks[81];
   int
            n1 = 53,
            n2 = 50,
            n3 = 50, 
            n  = 256;
   FILE
            *f;

   svector
           s = svec (3,n1,         
               "The original MATLAB startup.m file will be saved as  "
               "startup.sav. The file startup.m will then be updated."
               "Press Enter to continue or Q to quit ...             "),
              
           w = svec (5,n2,
               "The backup file startup.sav already exists. Please"
               "enter the desired name for the backup file.  Press"
               "Enter for the current value.                      "
               "                                                  "
               "Current value: startup.tmp                        "),

           z = svec (4,n3,         
               "The directory c:\\matlab\\toolbox\\local             "
               "was not found.  Make sure that MATLAB is installed"
               "and the MATLAB path is correct. Press Enter to    "
               "continue ...                                      ");
               
   box(s,3,n1);
   c = toupper(getchar());
   
   if (c != 'Q')
   {
   
/* Update startup.m in toolbox to include new NLIB directory */

      upstart(); 

/* Back up the original in startup.sav */

      strcpy (loc,matdir);
      strcat (loc,"\\toolbox\\local");
      strcpy (q,loc);
      strcat (q,"\\version.m");
      f = fopen (q,"r");
      if (f != NULL)
      {
         fclose(f);
         strcpy (q,loc);
         strcat (q,"\\startup.m");
         f = fopen (q,"r");
         if (f != NULL)
         {
            fclose (f);
            strcpy (r,loc);
            strcat (r,"\\startup.sav");
            f = fopen (r,"r");
            if (f == NULL)
               cpyfile (q,r);
            else
            {
               fclose (f);
               box(w,5,n2);
               gets (u);
               strcpy(v,loc);
               strcat(v,"\\");
               if (strlen(u) > 0)
                  strcat (v,u);
               else
                  strcat (v,"startup.tmp");   
               cpyfile(q,v);
            }
         }
      }   
      else
      {

         strcpy (z[1]+ 14,loc);
         blank(blanks,n3-strlen(z[1]));
         strcat (z[1],blanks); 
         box(z,4,n3);
         getchar();
         if (DEBUG)
            showstat();
         return 0;
      }      
      
/* Update startup.m in the MATLAB bin directory */ 

      strcpy (q,"copy ");                           
      strcat (q,nlibdir);
      strcat (q,"\\toolbox\\startup.m ");
      strcat (q,loc);
      strcat (q,"\\startup.m");
      system (q);
      return 1;
   }
   else
      return 0;
}

/* -------------------------------------------------------------------- */
void cpyfile (char *f1,char *f2) 
/* -------------------------------------------------------------------- */
{
/* Purpose: Copy from file f1 to file f2 */

   char      q[81];
   strcpy (q,"copy ");
   strcat (q,f1);
   strcat (q," ");
   strcat (q,f2);
   system (q);
}

/* -------------------------------------------------------------------- */
void delfile (char *f) 
/* -------------------------------------------------------------------- */
{
/* Purpose: Delete file f */

   char      q[81];
   strcpy (q,"del ");
   strcat (q,f);
   system (q);
}

/* -------------------------------------------------------------------- */
void matdone (void) 
/* -------------------------------------------------------------------- */
{
/* Purpose: Installation of MATLAB toolbox is complete */

   char
           q[81]; 
   int
           n1 = 56;

   svector
           s = svec (8,n1,
           "The installation of the MATLAB toolbox to the directory "
           "c:\\nlib is complete.  To run/view examples enter        "
           "the following NLIB Example Browser command from the     "
           "MATLAB command window:                                  "
           "                                                        "
           "browse                                                  "
           "                                                        "
           "Press Enter to continue ...                             "); 

   strcpy (s[2],nlibdir);
   strcat (s[2]," is complete. To run/view examples enter");
   blank (q,n1-strlen(s[2]));
   strcat (s[2],q);
   box(s,8,n1);
   getchar();
}

/* -------------------------------------------------------------------- */
int matcheck (void) 
/* -------------------------------------------------------------------- */
{
/* Purpose: Return true if the MATLAB files have been installed in
            the nlib directory. */
            
   char
          s[256];
   FILE
          *f;
       
   strcpy (s,nlibdir);
   strcat (s,"\\toolbox\\startup.m");
   f = fopen (s,"r");
   return ((f == NULL) ? 0 : 1);
}

/* -------------------------------------------------------------------- */
void copyc (void) 
/* -------------------------------------------------------------------- */
{
/* Purpose: Copy the C library files from the distribution CD. */

  char
          c,d,q[256],r[81],editor[81],compiler[10],CDdrive[10];

  int
          n1 = 54,
          n2 = 55,
          n3 = 53,
          k;
          
  svector
          s = svec (2,n1,
          "This will copy the C library from drive D to directory"
          "c:\nlib.  Is this correct (y/n)?                      "),

          t = svec (3,n2,
          "Do you want to copy the 21.6 MB of compiled C example  "
          "files, and the 18.9 MB of C example figure files (y/n)?"
          "NOTE: They can instead be run directly from the CD.    ");

  FILE   *f;

          
  s[1][40] = toupper(source[0]);
  strcpy (s[2],nlibdir);
  strcat (s[2],". Is this correct (y/n)?");
  blank (q,n1-strlen(s[2]));
  strcat (s[2],q);

  do {

     box (s,2,n1);
     d = toupper (getchar());

     if (d == 'Y')
     {

/* Copy main NLIB directory files */     

        clrscr_();
        strncpy (dest,nlibdir,2);
        system (dest);          
        strcpy (q,"md ");
        strcat (q,nlibdir);
        system (q);
        strcpy (q,"copy ");
        strcat (q,source);
        strcat (q," ");
        strcat (q,nlibdir);
        printf ("\nCopying NLIB root files to %s ... \n\n",nlibdir);
        system (q);
     
/* Copy C example files */     

        strcpy (q,"md ");
        strcat (q,nlibdir);
        strcat (q,"\\exam_c");
        system (q);
        strcpy (q,"copy ");
        strcat (q,source);
        strcat (q,"\\exam_c ");
        strcat (q,nlibdir);
        strcat (q,"\\exam_c");
        printf ("\nCopying C examples to %s\\exam_c ... \n\n",nlibdir);
        system (q);
        
/* Create user directory */     

        strcpy (q,"md ");
        strcat (q,nlibdir);
        strcat (q,"\\user_c");
        system (q);

/* Copy data files */     

        strcpy (q,"md ");
        strcat (q,nlibdir);
        strcat (q,"\\data");
        system (q);
        strcpy (q,"copy ");
        strcat (q,source);
        strcat (q,"\\data ");
        strcat (q,nlibdir);
        strcat (q,"\\data");
        printf ("\nCopying problem data files to %s\\data ... \n\n",
                nlibdir);
        system (q);
        
/* Copy bin and figures directory (.exe and .bmp files) */     

        box (t,3,n2);
        c = toupper (getchar());
        if (c == 'Y') 
        {

/* bin directory */
        
           CDsource = 0;
           strcpy (q,"md ");
           strcat (q,nlibdir);
           strcat (q,"\\bin");
           system (q);
           strcpy (q,"copy ");
           strcat (q,source);
           strcat (q,"\\bin ");
           strcat (q,nlibdir);
           strcat (q,"\\bin");
           printf ("\nCopying compiled C examples to %s\\bin ... \n\n",nlibdir);
           system (q);

/* figures directory */

           strcpy (q,"md ");
           strcat (q,nlibdir);
           strcat (q,"\\figures");
           system (q);
           strcpy (q,"copy ");
           strcat (q,source);
           strcat (q,"\\figures ");
           strcat (q,nlibdir);
           strcat (q,"\\figures");
           printf ("\nCopying C figure files to %s\\figures ... \n\n",nlibdir);
           system (q);
        }   
        else
           CDsource = 1;

/* Save configuration in browse_e.c */

     savecfg();
     if (DEBUG)
        showstat();
     }

  }
  while ((d != 'Y') && (d != 'N'));

}

/* -------------------------------------------------------------------- */
void getboot     (void) {
/* -------------------------------------------------------------------- */

/* Purpose: Prompt for the boot (operating system) drive. */

   char
            q[10],c;
   int
            n1 = 52,
            n;
   svector
            s = svec (4,n1,
                "Enter the boot drive containing the operating system"
                "(A to Z).  Press Enter to select current value.     "
                "                                                    "
                "Current value: C                                    ");

   s[4][15] = toupper(boot[0]);
   do
   {
      box (s,4,n1);
      gets(q);
      c = toupper(q[0]);
      n = strlen(q);
   }
   while (((c < 'A') || (c > 'Z')) && (n > 0));
   
   if (n > 0)
   {
      strcpy (boot," :");	
      boot[0] = c;
   }
}

/* -------------------------------------------------------------------- */
int upauto (void) {
/* -------------------------------------------------------------------- */

/* Purpose: Update autoexec.bat and back up the original in
            autoexec.sav */

   char
                c,*p,r[256],s[256],t[256],q[256],u[256],d[256];
   int
                n1 = 56,
                n2 = 51,
                n = 256,
                pathup = 0,
                i,j,plen;
   FILE
                *f,*g,*h;         
   svector
           v = svec (3,n1,         
               "This will configure the environment for the C version of"
               "NLIB assuming that the boot drive is C and NLIB is in   "
               "c:\\nlib.  Are these settings correct (y/n)?             "),

           w = svec (5,n2,
               "The backup file autoexec.sav already exists. Please"
               "enter the desired name for the backup file.  Press "
               "Enter for the current value.                       "
               "                                                   "
               "Current value: autoexec.tmp                        ");

   v[2][37] = toupper(boot[0]);
   strcpy (v[3],nlibdir);
   strcat (v[3],". Are these setting correct (y/n)?");
   blank (q,n1-strlen(v[3]));
   strcat (v[3],q);

   do
   {
      box (v,3,n1);
      c = toupper (getchar());
 
      if (c == 'Y')
      {
   
/* Search for autoexec.bat */

         strcpy (q,boot);
         strcat (q,"\\autoexec.bat");
         f = fopen (q,"r");
         if (f == NULL)
         {
            f = fopen (q,"w");
            fputs ("prompt $p$g\n",f);
            strcpy (s,"path ");
            strcat (s,nlibdir);
            strcat (s,";\n");
            fputs (s,f);
            fclose (f);
         }
      
/* Back up the original in autoexec.sav */

         else
         {
            fclose (f);
            strcpy (u,boot);
            strcat (u,"\\autoexec.sav");
            f = fopen (u,"r");
            if (f == NULL)
               cpyfile (q,u);
            else
            {
               fclose (f);
               box(w,5,n2);
               gets (r);
               strcpy(u,boot);
               strcat(u,"\\");
               if (strlen(r) > 0)
                  strcat (u,r);
               else
                  strcat (u,"autoexec.tmp");   
               cpyfile(q,u);
             }
         }    

/* Put autoexec changes in file nlibenv.bat in NLIB directory */

         strcpy (s,nlibdir);
         strcat (s,"\\nlibenv.bat");
         h = fopen (s,"w");
         fputs ("@echo off\n",h);
         fputs ("rem NLIB environment is temporarily configured.\n",h);
         strcpy (t,"set NLIBDIR=");
         strcat (t,nlibdir);
         strcat (t,"\n");
         fputs (t,h);
         strcpy (r,"set path=%NLIBDIR%;%PATH%\n");
         fputs (r,h);
         fclose (h);
       
/* Insert changes into autoexec.bat before any call to vcvars32 */

         f = fopen (q,"r");
         strcpy (u,nlibdir);
         strcat (u,"\\temp.bat");
         g = fopen (u,"w");
         
         while (!feof(f))
         {
            fgets (s,n,f);
            strcpy (d,s);
            for (i = 0; i < strlen(d); i++)
               d[i] = tolower(d[i]);
            p = strstr (d,"vcvars32"); 
            if (p != NULL)
            {
               fputs (t,g);
               fputs (r,g);
               pathup = 1;
            }
            if (!feof(f) && (strstr(s,"NLIBDIR") == NULL))
                fputs (s,g);
         }
         if (!pathup)
         {
            fputs (t,g);
            fputs (r,g);
         }
         fclose (f);
         fclose (g);
         cpyfile (u,q);
         delfile (u);
      }
   }
   while ((c != 'Y') && (c != 'N'));
   return ((c == 'Y') ? 1 : 0);
}
   

/* -------------------------------------------------------------------- */
void	upbat (char *b) 
/* -------------------------------------------------------------------- */
{
/* Description: Update the set NLIBDIR line in batch file b */

   char     q[256],r[256],s[256],*p;
   int      n = 256;
   FILE     *f,*g;
 
   strcpy (q,nlibdir);
   strcpy (r,nlibdir);
   strcat (q,"\\");
   strcat (q,b);
   strcat (r,"\\temp.bat");
   f = fopen (q,"r");
   g = fopen (r,"w");

   while (!feof(f))
   {
      fgets (s,n,f);
      p = strstr (s,"NLIBDIR="); 
      if (p != NULL)
      {
         strcpy (s,"  set NLIBDIR=");
         strcat (s,nlibdir);
         strcat (s,"\n");
      }
      if (!feof(f))
         fputs (s,g);
   }
   fclose (f);
   fclose (g);
   cpyfile (r,q);
   delfile (r);
}


/* -------------------------------------------------------------------- */
void cdone (void) 
/* -------------------------------------------------------------------- */
{
/* Purpose: Installation of C library is complete */

   char
           q[81]; 
   int
           n1 = 55;

   svector
           s = svec (9,n1,
           "The installation of the C library to the directory     "
           "c:\\nlib is complete. To make the changes to the        "
           "path and the environment take effect, you MUST reboot  "
           "the PC. You can then run/view examples by executing    "
           "the following NLIB Example Browser program:            "
           "                                                       "
           "browse                                                 "
           "                                                       " 
           "Press Enter to continue ...                            ");
           
   strcpy (s[2],nlibdir);
   strcat (s[2]," is complete. To make the changes to the");
   blank (q,n1-strlen(s[2]));
   strcat (s[2],q);
   box(s,9,n1);
   getchar();

/* Make temporary change to environment for now */

   strcpy (q,"set nlibdir=");
   strcat (q,nlibdir);
   system (q);

}

/* -------------------------------------------------------------------- */
int ccheck (void) 
/* -------------------------------------------------------------------- */
{
/* Purpose: Return true if the C library files have been installed in
            the nlib directory. */
            
   char
          s[256];
   FILE
          *f;
       
   strcpy (s,nlibdir);
   strcat (s,"\\nlib.h");
   f = fopen (s,"r");
   if (f != NULL)
   {
      fclose(f);
      return 1;
   }   
   else
      return 0;
}


/* -------------------------------------------------------------------- */
void deldir (char *d)
/* -------------------------------------------------------------------- */
{
/* Description: Delete subdirectory d of the NLIB directory.  If
                d == "", remove the NLIB directory */

   char
           q[81];

/* Check if directory exists */

   if (1)
   {
   
/* Delete contents */

      strcpy (q,"del ");
      strcat (q,nlibdir);
      if (strlen(d) > 0)
      {
         strcat (q,"\\");
         strcat (q,d);
      }   
      system (q);

/* Remove directory */   

      strcpy (q,"rd ");
      strcat (q,nlibdir);
      if (strlen(d) > 0)
      {
         strcat (q,"\\");
         strcat (q,d);
      }   
      system (q);
   }
}        

/* -------------------------------------------------------------------- */
void uninstall   (void)
/* -------------------------------------------------------------------- */
{
/* Description: Remove the NLIB directory and all of its contents */

   char
           c,q[81],r[81];

   int
           n1 = 58,
           n2 = 40;

   FILE
           *f;
 
   svector
           v = svec (2,n1,         
               "This will delete the following directory and all of its   "
               "contents: c:\\nlib. Is this correct (y/n)?                "),
           u = svec (2,n2,
               "Do you want to restore autoexec.bat with"
               "autoexec.sav (y/n)?                     ");

               
/* Remove NLIB */

   strcpy (v[2],"contents: ");
   strcat (v[2],nlibdir);
   strcat (v[2],". Is this correct (y/n)?");
   blank (q,n1-strlen(v[2]));
   strcat (v[2],q);

   box (v,2,n1);
   c = toupper (getchar());
 
   if (c == 'Y')
   {

/* Restore startup.m */

      strcpy (q,matdir);
      strcat (q,"\\bin\\startup.sav");
      strcpy (r,matdir);
      strcat (r,"\\bin\\startup.m");
      cpyfile (q,r);       

/* Delete MATLAB subdirectories */

      printf ("\nDeleting MATLAB toolbox files ...\n\n"); 
      deldir ("toolbox");
      deldir ("exam_mat");
      deldir ("prob_mat");
      deldir ("user_mat");
      deldir ("data");

/* Delete C subdirectories */

      printf ("\nDeleting C library files ...\n\n"); 
      deldir ("exam_c");
      deldir ("user_c");
      deldir ("bin");
      deldir ("figures");

/* Delete NLIB directory */

      printf ("\nDeleting NLIB directory ...\n\n"); 
      deldir ("");

/* Restore autoexec.bat */
       
      box (u,2,n2);
      c = toupper (getchar());
 
      if (c == 'Y')
      {
         strcpy (q,boot);
         strcat (q,"\\autoexec.sav");
         strcpy (r,boot);
         strcat (r,"\\autoexec.bat");
         cpyfile (q,r);
      }
   }
}

/* -------------------------------------------------------------------- */
int main (void) {
/* -------------------------------------------------------------------- */

   char
                c,d,q[256],r[256],s[256],*p;

   int
                size,install,
                n = 256,
                EXIT = 3;

   FILE
                *f,*g;
                
/* Initialize */

   signon();
   do
   {

/* Get preliminary information */ 
      
      install = gettype();
      if ((install >= 1) && (install <= 2))
      {
         getsrc();
         getnlib();
      }
         
/* Perform installation */
      
      switch (install)
      {
         case 1:                    /* MATLAB toolbox */
    
            copymlab();
            if (matcheck())
            {
               getmlab();
               if (cpystart())
                  matdone();
            }
            break;

         case 2:                   /* C library */
         
            copyc();
            if (ccheck())
            { 
               getboot();
               if (upauto())
               {
                  upbat ("bc.bat");
                  upbat ("vc.bat");
                  cdone();
               }
            }   
            break;

      }   

   }
   while (install != EXIT);
   clrscr_();
   return 0;
}

#undef DEBUG
