echo off
rem --------------------------------------------------------------------
rem File:        VC.BAT
rem
rem Description: Compile and link a C source file using Microsoft
rem              Visual C++
rem --------------------------------------------------------------------

rem NLIBDIR must be set to NLIB directory

  set NLIBDIR=c:\nlib
  if "%1" == ""  goto usage
  if exist %1.c  goto comp
  goto nofile

:comp

  if exist %NLIBDIR%\nlib_vc.lib goto comp1
  if "%2" == "" goto comp3
  cl /Za /Fe%2 %1.c > err.log
  goto comp2

:comp3

  cl /Za %1.c > err.log
  goto comp2

rem Use library

:comp1

  if "%2" == "" goto comp4
  cl /Za /Fe%2 %NLIBDIR%\nlib_vc.lib %1.c > err.log
  goto comp2

:comp4

  cl /Za %NLIBDIR%\nlib_vc.lib %1.c > err.log

rem Clean up

:comp2

  type err.log | more 
  if exist %1.obj del %1.obj
  dir %1.*
  goto quit

:usage

  echo -
  echo - This batch file compiles and links a named .c program using 
  echo - the Microsoft Visual C++ command-line compiler.  Usage:
  echo -
  echo -   vc prog 
  echo -
  echo - Here prog is the name of the user program (the .c extension 
  echo - is assumed).  If you get the error message "Bad command or
  echo - file name", then you must first configure the environment to 
  echo - use the Microsoft Visual C++ command-line compiler (cl) as
  echo - follows:
  echo -
  echo -   1. Add a line to the end of autoexec.bat which executes
  echo -      the batch file, vcvars32.bat, located in the bin 
  echo -      directory of Visual C++.
  echo -
  echo -   2. Reboot to make the changes take effect.
  echo -
  goto quit

:nofile

  echo - 
  echo - The source file %1.c does not exist.
  echo - 
  goto quit

:quit
